
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.srw.filters;
import es.gva.cit.catalogClient.filters.AbstractFilter;
import es.gva.cit.catalogClient.filters.AdditionalClauses;
import es.gva.cit.catalogClient.languages.FilterEncoding;
import es.gva.cit.catalogClient.querys.Query;
import es.gva.cit.catalogClient.schemas.DublinCoreSchema;
import es.gva.cit.catalogClient.schemas.EbRIMSchema;
import es.gva.cit.catalogClient.schemas.ISO19115Schema;
import es.gva.cit.catalogClient.schemas.ISchemas;
import es.gva.cit.catalogClient.schemas.Schemas;
import es.gva.cit.catalogClient.traductor.ITranslator;
import es.gva.cit.catalogClient.utils.Strings;

/**
 * This class creates a RSW query for the IDEE server 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class IDEESRWFilter extends AbstractFilter {
/**
 * 
 * 
 */
    private ISchemas equiv = null;

/**
 * 
 * 
 */
    public  IDEESRWFilter() {        
        super();
    } 

/**
 * Return a CQL-Text query
 * 
 * 
 * @param query 
 * @return String
 * @param profile 
 */
    public String getQuery(Query query, String profile) {        
        String pregunta = null;
        
        FilterEncoding filter = new FilterEncoding("", "*", "?", "\\",
                null);    
       
        
        if (query.getTitle() != null) {
            filter.addClauses("title", query.getTitle(), query.getTitleFilter(),
                "PropertyIsLike", "L", "And");
        }     
        
        if (query.isMinimized()){
            if (query.getAbstract() != null) {
                filter.addClauses("subject", Strings.addAsteriscsFromAnArray(query.getAbstract()),
                    "Y", "PropertyIsLike", "L", "Or");
            }
        }else{
              if (query.getAbstract() != null) {
                  filter.addClauses("subject", Strings.addAsteriscsFromAnArray(query.getAbstract()),
                          "Y", "PropertyIsLike", "L", "And");
              }
              
             
        }
   
        pregunta = filter.toString();
        return pregunta;
    } 

/**
 * This function returns true only when the user has choosen the
 * "Fully Outside Of" of the coordinates option.
 * 
 * 
 * @return 
 * @param translator 
 * @param coordinatesOption 
 */
    public boolean getCoordinatesOption(ITranslator translator, String coordinatesOption) {        
        if ((coordinatesOption.equals(translator.getText("coordinatesEqual"))) ||
                (coordinatesOption.equals(translator.getText("coordinatesContains"))) ||
                (coordinatesOption.equals(translator.getText("coordinatesEnclose"))))
            return false;
       
        return true; 
    } 

 }
