
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.traductor;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 * This class is a translator that doesn't use Andami
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class WithOutAndamiTranslator implements ITranslator {

/**
 * 
 * 
 * 
 * @return 
 * @param key 
 */
    public String getText(String key) {        
        File file = null;
        try {
            file = new File("text.properties");
            if (file.exists()) {
                BufferedReader fr = new BufferedReader(new FileReader(file));
                String s;
                while ((s = fr.readLine()) != null) {
                    String[] pair = new String[2];
                    pair = s.split("=");
                    if (pair[0].equals(key)){
                        return pair[1];
                    }
                }
            } else {
                System.out.println("No se encuentra el fichero '" +
                    file.getPath() + "'");
            }
        } catch (FileNotFoundException e) {
            System.out.println("No se encuentra el fichero '" + file.getPath() +
                "'");
            //e.printStackTrace();
        } catch (IOException e) {
            System.out.println("Error de entrada salida en la lectura del fichero");
            //e.printStackTrace();
        }
        return key;
              
    } 
 }
