
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.gazetteer.ui.search;
import es.gva.cit.catalogClient.querys.Coordinates;
import es.gva.cit.catalogClient.traductor.ITranslator;
import es.gva.cit.catalogClient.traductor.Translator;
import es.gva.cit.catalogClient.utils.Doubles;
import es.gva.cit.gazetteer.querys.ThesaurusName;
import es.gva.cit.gazetteer.utils.ThesaurusJTree.ThesaurusJTree;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.util.Vector;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * 
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class SearchLowerPanel extends JPanel {

/**
 * 
 * 
 */
    private String[] resultadosPorPagina = {"10","25","50"};

/**
 * 
 * 
 */
    private Vector features = null;
/**
 * 
 * 
 */
    private JPanel panelRadioButtons = null;
/**
 * 
 * 
 */
    private JRadioButton exactButton = null;
/**
 * 
 * 
 */
    private JRadioButton anyButton = null;
/**
 * 
 * 
 */
    private JRadioButton allButton = null;
/**
 * 
 * 
 */
    private JPanel panelLabNResultados = null;
/**
 * 
 * 
 */
    private JLabel nResultadosLabel = null;
/**
 * 
 * 
 */
    private JComboBox nResultsCombo = null;
/**
 * 
 * 
 */
    private JPanel panelAjusteBotones = null;
/**
 * 
 * 
 */
    private JPanel panelRigth = null;
/**
 * 
 * 
 */
    private JPanel panelLeft = null;
/**
 * 
 * 
 */
    private JPanel panelSuperiores = null;
/**
 * 
 * 
 */
    private JPanel panelInferiores = null;
/**
 * 
 * 
 */
    private JLabel ULXLabel = null;
/**
 * 
 * 
 */
    private JTextField ULXText = null;
/**
 * 
 * 
 */
    private JLabel ULYLabel = null;
/**
 * 
 * 
 */
    private JTextField ULYText = null;
/**
 * 
 * 
 */
    private JLabel BRXLabel = null;
/**
 * 
 * 
 */
    private JTextField BRXText = null;
/**
 * 
 * 
 */
    private JLabel BRYLabel = null;
/**
 * 
 * 
 */
    private JTextField BRYText = null;
/**
 * 
 * 
 */
    private JPanel jPanel = null;
/**
 * 
 * 
 */
    private JPanel panelShowOptions = null;
/**
 * 
 * 
 */
    private JPanel panelNResultadosCombo = null;
/**
 * 
 * 
 */
    private JPanel panelLabTipo = null;
/**
 * 
 * 
 */
    private JPanel panelListTipo = null;
/**
 * 
 * 
 */
    private JLabel tipoLabel = null;
/**
 * 
 * 
 */
    private ThesaurusJTree thesaurusTree = null;
/**
 * 
 * 
 */
    private JComboBox coordenadasCombo = null;
/**
 * 
 * 
 */
    private JPanel panelCoordinates = null;
/**
 * 
 * 
 */
    private JPanel componentesPanel = null;
/**
 * 
 * 
 */
    private JScrollPane jScrollThesaurus = null;
/**
 * 
 * 
 */
    private ITranslator translator = null;

/**
 * 
 * 
 */
    private String serverType = null;
/**
 * 
 * 
 */
    private JCheckBox checkBGoTo = null;
/**
 * 
 * 
 */
    private JCheckBox checkBKeepOld = null;
/**
 * 
 * 
 */
    private JPanel panelShowOptionsPosition = null;

private JCheckBox checkBMark = null;

private JPanel panelAdvancedSearch = null;

private JPanel panelAdvancedSearchPosition = null;

private JCheckBox checkBWithAccents = null;

/**
 * 
 * 
 * 
 * @param features Features list
 * @param translator Class to translate the interface
 * @param serverType Server type used to enable/disable some interface components
 */
    public  SearchLowerPanel(Vector features, ITranslator translator, String serverType) {        
        super();
        this.translator = translator; 
        this.features = features;
        this.serverType = serverType;
        initialize();
        disableComponents(serverType);
        getCheckBGoTo().setSelected(true);
        getCheckBKeepOld().setSelected(true);
        getCheckBMark().setSelected(true);
        getCheckBWithAccents().setSelected(true);
    } 

/**
 * This method initializes this
 * 
 */
    private void initialize() {        
        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.setPreferredSize(new java.awt.Dimension(565,405));
        this.setLocation(0, 0);
        this.setSize(565, 405);
        this.add(getComponentesPanel(), null);
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelRadioButtons() {        
        if (panelRadioButtons == null) {
            panelRadioButtons = new JPanel();
            panelRadioButtons.setLayout(new BoxLayout(panelRadioButtons, BoxLayout.Y_AXIS));
            panelRadioButtons.setBorder(javax.swing.BorderFactory.createTitledBorder(
                    null, Translator.getText(translator,"concordancia"),
                    javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
                    javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
            panelRadioButtons.add(getExactButton(), null);
            panelRadioButtons.add(getAnyButton(), null);
            panelRadioButtons.add(getAllButton(), null);
            ButtonGroup group = new ButtonGroup();
            group.add(getExactButton());
            group.add(getAnyButton());
            group.add(getAllButton());
        }
        return panelRadioButtons;
    } 

/**
 * This method initializes jRadioButton
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    private JRadioButton getExactButton() {        
        if (exactButton == null) {
            exactButton = new JRadioButton();
            exactButton.setText( Translator.getText(translator,"exactSentence"));
            exactButton.setSelected(true);
        }
        return exactButton;
    } 

/**
 * This method initializes jRadioButton1
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    private JRadioButton getAnyButton() {        
        if (anyButton == null) {
            anyButton = new JRadioButton();
            anyButton.setText( Translator.getText(translator,"anyWord"));
        }
        return anyButton;
    } 

/**
 * This method initializes jRadioButton2
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    private JRadioButton getAllButton() {        
        if (allButton == null) {
            allButton = new JRadioButton();
            allButton.setText( Translator.getText(translator,"allWords"));
        }
        return allButton;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelLabNResultados() {        
        if (panelLabNResultados == null) {
            nResultadosLabel = new JLabel();
            panelLabNResultados = new JPanel();
            GridLayout gridLayout2 = new GridLayout();
            panelLabNResultados.setLayout(gridLayout2);
            nResultadosLabel.setText( Translator.getText(translator,"resutsByPage"));
            panelLabNResultados.add(nResultadosLabel, null);
        }
        return panelLabNResultados;
    } 

/**
 * This method initializes jComboBox
 * 
 * 
 * @return javax.swing.JComboBox
 */
    private JComboBox getNResultsCombo() {        
        if (nResultsCombo == null) {
            nResultsCombo = new JComboBox(resultadosPorPagina);
            nResultsCombo.setPreferredSize(new java.awt.Dimension(250,20));
            nResultsCombo.setBackground(Color.white);
            
        }
        return nResultsCombo;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelAjusteBotones() {        
        if (panelAjusteBotones == null) {
            GridLayout gridLayout6 = new GridLayout();
            panelAjusteBotones = new JPanel();
            panelAjusteBotones.setLayout(gridLayout6);
            gridLayout6.setRows(1);
            panelAjusteBotones.add(getPanelRadioButtons(), null);
        }
        return panelAjusteBotones;
    } 

/**
 * This method initializes jPanel3
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel3() {        
        if (panelRigth == null) {
            panelRigth = new JPanel();
            panelRigth.setLayout(new BoxLayout(
                    panelRigth, BoxLayout.Y_AXIS));
            panelRigth.setPreferredSize(new java.awt.Dimension(250,400));
            panelRigth.add(getPanelCoordinates(), null);
            panelRigth.add(getPanelShowOptions(), null);
            panelRigth.add(getPanelAdvancedSearch(), null);
        }
        return panelRigth;
    } 

/**
 * This method initializes jPanel3
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel33() {        
        if (panelLeft == null) {
            panelLeft = new JPanel();
            panelLeft.setLayout(new BoxLayout(
                    panelLeft, BoxLayout.Y_AXIS));
            panelLeft.setPreferredSize(new java.awt.Dimension(250,395));
            panelLeft.add(getPanelAjusteBotones(), null);
            panelLeft.add(getPanelLabTipo(), null);
            panelLeft.add(getPanelListTipo(), null);
            panelLeft.add(getPanelLabNResultados(), null);
            panelLeft.add(getPanelNResultadosCombo(), null);
        }
        return panelLeft;
    } 

/**
 * This method initializes jPanel4
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelSuperiores() {        
        if (panelSuperiores == null) {
            ULXLabel = new JLabel();
            ULYLabel = new JLabel();
            panelSuperiores = new JPanel();
            panelSuperiores.setBorder(javax.swing.BorderFactory.createTitledBorder(
                    null,  Translator.getText(translator,"upperCoordinates"),
                    javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
                    javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
            panelSuperiores.setPreferredSize(new java.awt.Dimension(213,30));
            ULXLabel.setText("ULX:");
            ULYLabel.setText("ULY:");
            panelSuperiores.add(ULXLabel, null);
            panelSuperiores.add(getULXText(), null);
            panelSuperiores.add(ULYLabel, null);
            panelSuperiores.add(getULYText(), null);
        }
        return panelSuperiores;
    } 

/**
 * This method initializes jPanel4
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelInferiores() {        
        if (panelInferiores == null) {
            BRXLabel = new JLabel();
            BRYLabel = new JLabel();
            panelInferiores = new JPanel();
            panelInferiores.setBorder(javax.swing.BorderFactory.createTitledBorder(
                    null,  Translator.getText(translator,"lowerCoordinates"),
                    javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
                    javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
            panelInferiores.setPreferredSize(new java.awt.Dimension(213,30));
            BRXLabel.setText("BRX:");
            BRYLabel.setText("BRY:");
            panelInferiores.add(BRXLabel, null);
            panelInferiores.add(getBRXText(), null);
            panelInferiores.add(BRYLabel, null);
            panelInferiores.add(getBRYText(), null);
        }
        return panelInferiores;
    } 

/**
 * This method initializes jTextField
 * 
 * 
 * @return javax.swing.JTextField
 */
    private JTextField getULXText() {        
        if (ULXText == null) {
            ULXText = new JTextField();
            ULXText.setPreferredSize(new java.awt.Dimension(65,20));
        }
        return ULXText;
    } 

/**
 * This method initializes jTextField
 * 
 * 
 * @return javax.swing.JTextField
 */
    private JTextField getULYText() {        
        if (ULYText == null) {
            ULYText = new JTextField();
            ULYText.setPreferredSize(new java.awt.Dimension(65,20));
        }
        return ULYText;
    } 

/**
 * This method initializes jTextField
 * 
 * 
 * @return javax.swing.JTextField
 */
    private JTextField getBRXText() {        
        if (BRXText == null) {
            BRXText = new JTextField();
            BRXText.setPreferredSize(new java.awt.Dimension(65,20));
        }
        return BRXText;
    } 

/**
 * This method initializes jTextField
 * 
 * 
 * @return javax.swing.JTextField
 */
    private JTextField getBRYText() {        
        if (BRYText == null) {
            BRYText = new JTextField();
            BRYText.setPreferredSize(new java.awt.Dimension(65,20));
        }
        return BRYText;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel() {        
        if (jPanel == null) {
            jPanel = new JPanel();
            jPanel.setPreferredSize(new java.awt.Dimension(10,5));
            jPanel.add(getCoordenadasCombo(), null);
        }
        return jPanel;
    } 

/**
 * This method initializes jPanel8
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelShowOptions() {        
        if (panelShowOptions == null) {
            FlowLayout flowLayout4 = new FlowLayout();
            panelShowOptions = new JPanel();
            panelShowOptions.setLayout(flowLayout4);
            panelShowOptions.setPreferredSize(new java.awt.Dimension(10,100));
            panelShowOptions.setBorder(javax.swing.BorderFactory.createTitledBorder(null, Translator.getText(translator,"aspect"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
            flowLayout4.setAlignment(java.awt.FlowLayout.LEFT);
            panelShowOptions.add(getPanelShowOptionsPosition(), null);
        }
        return panelShowOptions;
    } 

/**
 * This method initializes jPanel9
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelNResultadosCombo() {        
        if (panelNResultadosCombo == null) {
            panelNResultadosCombo = new JPanel();
            panelNResultadosCombo.add(getNResultsCombo(), null);
        }
        return panelNResultadosCombo;
    } 

/**
 * This method initializes jPanel7
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelLabTipo() {        
        if (panelLabTipo == null) {
            tipoLabel = new JLabel();
            GridLayout gridLayout1 = new GridLayout();
            panelLabTipo = new JPanel();
            panelLabTipo.setLayout(gridLayout1);
            gridLayout1.setRows(1);
            tipoLabel.setText(Translator.getText(translator,"type"));
            panelLabTipo.add(tipoLabel, null);
        }
        return panelLabTipo;
    } 

/**
 * This method initializes jPanel7
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelListTipo() {        
        if (panelListTipo == null) {
            panelListTipo = new JPanel();
            panelListTipo.setPreferredSize(new java.awt.Dimension(310,115));
            panelListTipo.add(getJScrollThesaurus(), null);
        }
        return panelListTipo;
    } 

/**
 * This method initializes jTextField
 * 
 * 
 * @return javax.swing.JTextField
 */
    public ThesaurusJTree getThesaurusList() {        
        if (thesaurusTree == null) {
            int numFeatures;
            if (features == null){
                numFeatures = 0;
            }else{
                numFeatures = features.size();
            }
            
            ThesaurusName[] f = new ThesaurusName[numFeatures];
            for (int i=0 ; i<numFeatures ; i++){
                f[i] = (ThesaurusName)features.get(i);
            }
            thesaurusTree = new ThesaurusJTree(features,
                    Translator.getText(translator,"rootName"));
        }
        return thesaurusTree;
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getConcordancia() {        
        if (getExactButton().isSelected()) {
            return "E";
        }
        if (getAnyButton().isSelected()) {
            return "Y";
        }
        if (getAllButton().isSelected()) {
            return "A";
        }
        return null;
    } 

/**
 * Ir returns the current selected thesaurus type
 * 
 * 
 * @return 
 */
    public ThesaurusName getType() {        
        DefaultMutableTreeNode dmt = (DefaultMutableTreeNode)thesaurusTree.getLastSelectedPathComponent();
        if (dmt == null)
            return null;
        return (ThesaurusName) dmt.getUserObject();
    } 

/**
 * Ir returns all the thesaurus in the combo
 * 
 * 
 * @return ThesaurusName[]
 */
    public ThesaurusName[] getAllTypes() {        
        DefaultMutableTreeNode root = (DefaultMutableTreeNode)thesaurusTree.getModel().getRoot();
        ThesaurusName[] thesaurus = new ThesaurusName[root.getChildCount()];        
        
        for (int i=0 ; i<root.getChildCount() ; i++){
            DefaultMutableTreeNode child = (DefaultMutableTreeNode) root.getChildAt(i);
            thesaurus[i] = (ThesaurusName) child.getUserObject();
        }
        
        return thesaurus;
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public int getNPaginas() {        
        String s = (String) getNResultsCombo().getSelectedItem();
        return Integer.valueOf(s).intValue();
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public Coordinates getCoordenadas() {        
        return new Coordinates(getULXText().getText(), getULYText().getText(),
            getBRXText().getText(), getBRYText().getText());
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getCoordenadasOpcion() {        
        return (String) getCoordenadasCombo().getSelectedItem();
    } 

/**
 * It sets the coordinates fields
 * 
 * 
 * @param coordinates 
 */
    public void setCoordinates(Coordinates coordinates) {        
        setULXText(Doubles.get5Decimals(coordinates.ulx));
        setULYText(Doubles.get5Decimals(coordinates.uly));
        setBRXText(Doubles.get5Decimals(coordinates.brx));
        setBRYText(Doubles.get5Decimals(coordinates.bry));
    } 

/**
 * This method initializes jComboBox
 * 
 * 
 * @return javax.swing.JComboBox
 */
    private JComboBox getCoordenadasCombo() {        
        if (coordenadasCombo == null) {
            String[] coordinates;
            
            coordinates = new String[2];
            coordinates[0] = Translator.getText(translator,"coordinatesContains");
            coordinates[1] = Translator.getText(translator,"coordinatesFullyOutsideOf");
           
            coordenadasCombo = new JComboBox(coordinates);
            coordenadasCombo.setPreferredSize(new java.awt.Dimension(240,20));
            coordenadasCombo.setBackground(Color.white);
        }
        return coordenadasCombo;
    } 

/**
 * This method initializes jPanel4
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelCoordinates() {        
        if (panelCoordinates == null) {
            panelCoordinates = new JPanel();
            panelCoordinates.setLayout(new BoxLayout(panelCoordinates, BoxLayout.Y_AXIS));
            panelCoordinates.setBorder(javax.swing.BorderFactory.createTitledBorder(
                    null, Translator.getText(translator,"coordinates"),
                    javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
                    javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
            panelCoordinates.setPreferredSize(new java.awt.Dimension(315,135));
            panelCoordinates.add(getPanelSuperiores(), null);
            panelCoordinates.add(getPanelInferiores(), null);
            panelCoordinates.add(getJPanel(), null);
        }
        return panelCoordinates;
    } 

/**
 * This method initializes jPanel5
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getComponentesPanel() {        
        if (componentesPanel == null) {
            componentesPanel = new JPanel();
            componentesPanel.setPreferredSize(new java.awt.Dimension(565,400));
            componentesPanel.add(getJPanel33(), null);
            componentesPanel.add(getJPanel3(), null);
        }
        return componentesPanel;
    } 

/**
 * This method initializes jScrollPane1
 * 
 * 
 * @return javax.swing.JScrollPane
 */
    public JScrollPane getJScrollThesaurus() {        
		if (jScrollThesaurus == null) {
		    jScrollThesaurus = new JScrollPane(getThesaurusList());
		    jScrollThesaurus.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		    jScrollThesaurus.setPreferredSize(new java.awt.Dimension(250,120));
		}
		return jScrollThesaurus;
    } 

/**
 * 
 * 
 * 
 * @param text The bRXText to set.
 */
    public void setBRXText(String text) {        
        BRXText.setText(text);
    } 

/**
 * 
 * 
 * 
 * @param text The bRYText to set.
 */
    public void setBRYText(String text) {        
        BRYText.setText(text);
    } 

/**
 * 
 * 
 * 
 * @param text The uLXText to set.
 */
    public void setULXText(String text) {        
        ULXText.setText(text);
    } 

/**
 * 
 * 
 * 
 * @param text The uLYText to set.
 */
    public void setULYText(String text) {        
        ULYText.setText(text);
    } 

/**
 * This method disables the components that represent
 * the fileds that the protocol used to do the search doesn't
 * support
 * 
 * 
 * @param type Server type: WFS,WFS-G,ADL,IDEC
 */
    private void disableComponents(String type) {        
        //System.out.println("TYPE: " + type);
       
        
        if (type.equals("WFS-G")){
            getThesaurusList().setEnabled(false);
            /*
            getULXText().setEnabled(false);
            getULYText().setEnabled(false);
            getBRXText().setEnabled(false);
            getBRYText().setEnabled(false);
            getCoordenadasCombo().setEnabled(false);
            */
        }
        
        if (type.equals("WFS")){          
            getULXText().setEnabled(false);
            getULYText().setEnabled(false);
            getBRXText().setEnabled(false);
            getBRYText().setEnabled(false);
            getCoordenadasCombo().setEnabled(false);
            
           
        }
        
        if (type.equals("ADL")){
            getULXText().setEnabled(false);
            getULYText().setEnabled(false);
            getBRXText().setEnabled(false);
            getBRYText().setEnabled(false);
            getCoordenadasCombo().setEnabled(false);
        }
        
        if (type.equals("IDEC")){
            getThesaurusList().setEnabled(false);
            getULXText().setEnabled(false);
            getULYText().setEnabled(false);
            getBRXText().setEnabled(false);
            getBRYText().setEnabled(false);
            getCoordenadasCombo().setEnabled(false);
        }
        
    } 

/**
 * This method initializes jCheckBox
 * 
 * 
 * @return javax.swing.JCheckBox
 */
    private JCheckBox getCheckBGoTo() {        
		if (checkBGoTo == null) {
			checkBGoTo = new JCheckBox();
			checkBGoTo.setText(Translator.getText(translator,"goto"));
		}
		return checkBGoTo;
    } 

/**
 * This method initializes jCheckBox
 * 
 * 
 * @return javax.swing.JCheckBox
 */
    private JCheckBox getCheckBKeepOld() {        
		if (checkBKeepOld == null) {
			checkBKeepOld = new JCheckBox();
			checkBKeepOld.setText(Translator.getText(translator,"mantainold"));
		}
		return checkBKeepOld;
    } 

/**
 * This method initializes jPanel2
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelShowOptionsPosition() {        
		if (panelShowOptionsPosition == null) {
			panelShowOptionsPosition = new JPanel();
			panelShowOptionsPosition.setLayout(new BoxLayout(panelShowOptionsPosition, BoxLayout.Y_AXIS));
			panelShowOptionsPosition.setPreferredSize(new java.awt.Dimension(230,80));
			panelShowOptionsPosition.add(getCheckBGoTo(), null);
			panelShowOptionsPosition.add(getCheckBKeepOld(), null);
			panelShowOptionsPosition.add(getCheckBMark(), null);
		}
		return panelShowOptionsPosition;
    } 

/**
 * It returns if the GOTO component is clicked
 * 
 * 
 * @return 
 */
    public boolean isGoToClicked() {        
	    return getCheckBGoTo().isSelected();
    } 

/**
 * return if the Mantain Old button is enabled
 * 
 * 
 * @return 
 */
    public boolean isKeepOldClicked() {        
	    return getCheckBKeepOld().isSelected();
    }
    
    /**
     * return if the Mantain Old button is enabled
     * 
     * 
     * @return 
     */
        public boolean isMarkedPlaceClicked() {        
    	    return getCheckBMark().isSelected();
        }
        
        
        /**
         * return if the With accents button is enabled
         * 
         * 
         * @return 
         */
            public boolean isAccentsSearchEnabled() {        
        	    return getCheckBWithAccents().isSelected();
            }

/**
 * This method initializes jCheckBox	
 * 	
 * @return javax.swing.JCheckBox	
 */
private JCheckBox getCheckBMark() {
	if (checkBMark == null) {
		checkBMark = new JCheckBox();
		checkBMark.setText(Translator.getText(translator,"paint"));
	}
	return checkBMark;
}

/**
 * This method initializes jPanel2	
 * 	
 * @return javax.swing.JPanel	
 */
private JPanel getPanelAdvancedSearch() {
	if (panelAdvancedSearch == null) {
		FlowLayout flowLayout1 = new FlowLayout();
		flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
		panelAdvancedSearch = new JPanel();
		panelAdvancedSearch.setPreferredSize(new java.awt.Dimension(31,45));
		panelAdvancedSearch.setLayout(flowLayout1);
		panelAdvancedSearch.setBorder(javax.swing.BorderFactory.createTitledBorder(null, Translator.getText(translator,"inteligentSearch"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		panelAdvancedSearch.add(getPanelAdvancedSearchPosition(), null);
	}
	return panelAdvancedSearch;
}

/**
 * This method initializes jPanel2	
 * 	
 * @return javax.swing.JPanel	
 */
private JPanel getPanelAdvancedSearchPosition() {
	if (panelAdvancedSearchPosition == null) {
		panelAdvancedSearchPosition = new JPanel();
		panelAdvancedSearchPosition.setLayout(new BoxLayout(getPanelAdvancedSearchPosition(), BoxLayout.Y_AXIS));
		panelAdvancedSearchPosition.setPreferredSize(new java.awt.Dimension(230,30));
		panelAdvancedSearchPosition.add(getCheckBWithAccents(), null);
	}
	return panelAdvancedSearchPosition;
}

/**
 * This method initializes jCheckBox	
 * 	
 * @return javax.swing.JCheckBox	
 */
private JCheckBox getCheckBWithAccents() {
	if (checkBWithAccents == null) {
		checkBWithAccents = new JCheckBox();
		checkBWithAccents.setText(Translator.getText(translator,"inteligentSearchAscii"));
		checkBWithAccents.setPreferredSize(new java.awt.Dimension(230,20));
	}
	return checkBWithAccents;
} 
 }
//  @jve:decl-index=0:visual-constraint="10,10"
