
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.gazetteer.ui.serverConnect;
import es.gva.cit.catalogClient.traductor.ITranslator;
import es.gva.cit.catalogClient.traductor.Translator;
import com.iver.utiles.swing.jcomboServer.JComboServer;
import com.iver.utiles.swing.jcomboServer.ServerData;
import java.awt.GridLayout;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import java.awt.FlowLayout;

/**
 * This class implements the JPanel for the Server connect window
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class ServerConnectPanel extends JPanel {
/**
 * 
 * 
 */
    private JPanel panelSuperior = null;
/**
 * 
 * 
 */
    private JComboServer servidoresCombo = null;
/**
 * 
 * 
 */
    private JPanel panelBotones = null;
/**
 * 
 * 
 */
    private JRadioButton WFSGButton = null;
/**
 * 
 * 
 */
    private JRadioButton ADLButton = null;
/**
 * 
 * 
 */
    private JPanel panelServidores = null;
/**
 * 
 * 
 */
    private JPanel panelInferior = null;
//  @jve:decl-index=0:
/**
 * 
 * 
 */
    private JEditorPane respuestaText = null;
//  @jve:decl-index=0:visual-constraint="-17,415"
/**
 * 
 * 
 */
    private JPanel panelRespuesta = null;
/**
 * 
 * 
 */
    private JScrollPane jScrollPane = null;
/**
 * 
 * 
 */
    private JPanel panelLabRespuesta = null;
//  @jve:decl-index=0:
/**
 * 
 * 
 */
    private JLabel jLabel1 = null;
/**
 * 
 * 
 */
    private JPanel panelLabServidores = null;
/**
 * 
 * 
 */
    private JLabel servidoresLabel = null;
/**
 * 
 * 
 */
    private JPanel panelServidoresCombo = null;
/**
 * 
 * 
 */
    private JRadioButton IDECButton = null;
/**
 * 
 * 
 */
    private ITranslator translator = null;
/**
 * 
 * 
 */
    private JRadioButton WFSButton = null;
private JPanel jPanel = null;
private JPanel jPanel1 = null;
private JPanel jPanel2 = null;
/**
 * 
 * 
 * 
 * @param translator 
 */
    public  ServerConnectPanel(ITranslator translator) {        
	    this.translator = translator;
	    initialize();
    } 

/**
 * This method initializes this
 * 
 */
    private void initialize() {        
        this.setPreferredSize(new java.awt.Dimension(625,225));
        //this.add(getPanelPrincipal(), null);
        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.setBackground(java.awt.Color.white);
        this.setLocation(0, 0);
        this.setSize(625, 225);
        this.add(getPanelSuperior(), null);
        this.add(getPanelInferior(), null);
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelSuperior() {        
        if (panelSuperior == null) {
            panelSuperior = new JPanel();
            panelSuperior.setPreferredSize(new java.awt.Dimension(625,145));
            panelSuperior.setPreferredSize(new java.awt.Dimension(620,135));
            panelSuperior.add(getPanelServidores(), null);
            panelSuperior.add(getPanelBotones(), null);
        }
        return panelSuperior;
    } 

/**
 * This method initializes jComboBox1
 * 
 * 
 * @return javax.swing.JComboBox
 */
    public JComboServer getServidoresCombo() {        
        if (servidoresCombo == null) {
            servidoresCombo = new JComboServer();
            servidoresCombo.setActionCommand("servidoresCombo");
            servidoresCombo.setPreferredSize(new java.awt.Dimension(472,25));
            servidoresCombo.setEditable(true);
        }
        return servidoresCombo;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelBotones() {        
        if (panelBotones == null) {
            panelBotones = new JPanel();
            panelBotones.setLayout(new BoxLayout(panelBotones, BoxLayout.Y_AXIS));
            panelBotones.setBorder(javax.swing.BorderFactory.createTitledBorder(
                    null, Translator.getText(translator,"protocolsGroup"),
                    javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
                    javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
            panelBotones.setName("Protocolos");
            panelBotones.setToolTipText("");
            panelBotones.setPreferredSize(new java.awt.Dimension(110,135));
            panelBotones.add(getWFSGButton(), null);
            panelBotones.add(getWFSButton(), null);
            panelBotones.add(getADLButton(), null);
            panelBotones.add(getIDECButton(), null);
            ButtonGroup group = new ButtonGroup();
            group.add(getWFSGButton());
            group.add(getWFSButton());
            group.add(getADLButton());
            group.add(getIDECButton());
           
        }
        return panelBotones;
    } 

/**
 * This method initializes jRadioButton
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    public JRadioButton getWFSGButton() {        
        if (WFSGButton == null) {
            WFSGButton = new JRadioButton();
            WFSGButton.setText("WFS-G");
            WFSGButton.setSelected(true);
            WFSGButton.setActionCommand("WFS-G");
        }
        return WFSGButton;
    } 

/**
 * This method initializes jRadioButton
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    private JRadioButton getIDECButton() {        
		if (IDECButton == null) {
			IDECButton = new JRadioButton();
			IDECButton.setText("IDEC/SOAP");
		}
		return IDECButton;
    } 

/**
 * This method initializes jRadioButton
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    private JRadioButton getWFSButton() {        
		if (WFSButton == null) {
			WFSButton = new JRadioButton();
			WFSButton.setActionCommand("WFS");
			WFSButton.setText("WFS");
		}
		return WFSButton;
    } 

/**
 * This method initializes jRadioButton
 * 
 * 
 * @return javax.swing.JRadioButton
 */
    public JRadioButton getADLButton() {        
        if (ADLButton == null) {
            ADLButton = new JRadioButton();
            ADLButton.setText("ADL");
        }
        return ADLButton;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelServidores() {        
        if (panelServidores == null) {
            panelServidores = new JPanel();
            panelServidores.setLayout(new BoxLayout(panelServidores,
                    BoxLayout.Y_AXIS));
            panelServidores.add(getJPanel1(), null);
            panelServidores.add(getJPanel(), null);
            panelServidores.add(getJPanel2(), null);
            panelServidores.add(getJPanel22(), null);
            panelServidores.add(getPanelLabRespuesta(), null);
        }
        return panelServidores;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelInferior() {        
        if (panelInferior == null) {
            panelInferior = new JPanel();
            panelInferior.setLayout(new FlowLayout());
            panelInferior.setComponentOrientation(java.awt.ComponentOrientation.LEFT_TO_RIGHT);
            panelInferior.setPreferredSize(new java.awt.Dimension(600,77));
            panelInferior.add(getJPanel3(), null);
        }
        return panelInferior;
    } 

/**
 * This method initializes jTextArea
 * 
 * 
 * @return javax.swing.JTextArea
 */
    private JEditorPane getRespuestaText() {        
        if (respuestaText == null) {
            respuestaText = new JEditorPane();
            respuestaText.setPreferredSize(new java.awt.Dimension(200, 500));
            respuestaText.setEditable(false);
           
        }
        return respuestaText;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelRespuesta() {        
        if (panelRespuesta == null) {
            panelRespuesta = new JPanel();
            panelRespuesta.setLayout(new BoxLayout(getPanelRespuesta(), BoxLayout.X_AXIS));
            panelRespuesta.setBorder(javax.swing.BorderFactory.createLineBorder(
                    java.awt.Color.lightGray, 0));
            panelRespuesta.setPreferredSize(new java.awt.Dimension(590,70));
            panelRespuesta.add(getJScrollPane(), null);
        }
        return panelRespuesta;
    } 

/**
 * This method initializes jScrollPane
 * 
 * 
 * @return javax.swing.JScrollPane
 */
    private JScrollPane getJScrollPane() {        
        if (jScrollPane == null) {
            jScrollPane = new JScrollPane();
            getRespuestaText().setBackground(jScrollPane.getBackground());
            jScrollPane.setPreferredSize(new java.awt.Dimension(610,75));
            jScrollPane.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
            jScrollPane.setViewportView(getRespuestaText());
        }
        return jScrollPane;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getPanelLabRespuesta() {        
        if (panelLabRespuesta == null) {
            jLabel1 = new JLabel();
            GridLayout gridLayout3 = new GridLayout();
            panelLabRespuesta = new JPanel();
            panelLabRespuesta.setPreferredSize(new java.awt.Dimension(475,20));
            panelLabRespuesta.setLayout(gridLayout3);
            jLabel1.setText(Translator.getText(translator,"serverReply"));
            gridLayout3.setRows(1);
            panelLabRespuesta.add(jLabel1, null);
        }
        return panelLabRespuesta;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel() {        
        if (panelLabServidores == null) {
            servidoresLabel = new JLabel();
            GridLayout gridLayout6 = new GridLayout();
            GridLayout gridLayout5 = new GridLayout();
            GridLayout gridLayout7 = new GridLayout();
            GridLayout gridLayout4 = new GridLayout();
            panelLabServidores = new JPanel();
            panelLabServidores.setLayout(gridLayout7);
            servidoresLabel.setText(Translator.getText(translator,"serverURLCat"));
            servidoresLabel.setPreferredSize(new java.awt.Dimension(375,10));
            servidoresLabel.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
            servidoresLabel.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
            gridLayout4.setRows(1);
            panelLabServidores.setPreferredSize(new java.awt.Dimension(475,20));
            panelLabServidores.setComponentOrientation(java.awt.ComponentOrientation.LEFT_TO_RIGHT);
            gridLayout5.setRows(1);
            gridLayout6.setRows(1);
            gridLayout7.setRows(1);
            panelLabServidores.add(servidoresLabel, null);
        }
        return panelLabServidores;
    } 

/**
 * This method initializes jPanel
 * 
 * 
 * @return javax.swing.JPanel
 */
    private JPanel getJPanel2() {        
        if (panelServidoresCombo == null) {
            panelServidoresCombo = new JPanel();
            panelServidoresCombo.setLayout(new BoxLayout(getJPanel2(), BoxLayout.X_AXIS));
            panelServidoresCombo.setPreferredSize(new java.awt.Dimension(425,25));
            panelServidoresCombo.setName("Protocolos");
            panelServidoresCombo.setToolTipText("Protocolos");
            panelServidoresCombo.setBorder(javax.swing.BorderFactory.createEmptyBorder(
                    0, 0, 0, 0));
            panelServidoresCombo.add(getServidoresCombo(), null);
        }
        return panelServidoresCombo;
    } 

/**
 * It returns the server address
 * 
 * 
 * @return ServerData
 */
    public String getServerAddress() {        
        return (String) getServidoresCombo().getSelectedServer().getServerAddress();
    } 

/**
 * It returns the server
 * 
 * 
 * @return ServerData
 */
    public ServerData getServer() {        
        return (ServerData) getServidoresCombo().getSelectedServer();
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public JComboServer getServerCombo() {        
        return this.getServidoresCombo();
    } 

/**
 * 
 * 
 * 
 * @return 
 */
    public String getProtocol() {        
        if (getWFSGButton().isSelected()) {
            return "WFS-G";
        }
        if (getADLButton().isSelected()) {
            return "ADL";
        }
        
        if (getIDECButton().isSelected())
        {
            return "IDEC";
        }
        
        
        if (getWFSButton().isSelected())
        {
            return "WFS";
        }
        
        
        return null;
    } 

/**
 * Sets the button enabled
 * 
 * 
 * @param protocol 1 - WFSG
 * 2 - ADL
 * 3 - IDEC
 * 4 - WFS
 */
    public void setProtocol(String protocol) {        
        if (protocol.equals(ServerData.SERVER_SUBTYPE_GAZETTEER_WFSG)){
            getWFSGButton().setSelected(true);
        }
        if (protocol.equals(ServerData.SERVER_SUBTYPE_GAZETTEER_ADL)){
            getADLButton().setSelected(true);
        }
        if (protocol.equals(ServerData.SERVER_SUBTYPE_GAZETTEER_IDEC)){
            getIDECButton().setSelected(true);
        }  
        if (protocol.equals(ServerData.SERVER_SUBTYPE_GAZETTEER_WFS)){
            getWFSButton().setSelected(true);
        }       
    
    } 

/**
 * 
 * 
 * 
 * @param texto 
 */
    public void setRespuesta(String texto) {        
        getRespuestaText().setText(texto);
    }

/**
 * This method initializes jPanel	
 * 	
 * @return javax.swing.JPanel	
 */
private JPanel getJPanel3() {
	if (jPanel == null) {
		jPanel = new JPanel();
		jPanel.setLayout(new BoxLayout(getJPanel3(), BoxLayout.Y_AXIS));
		jPanel.setPreferredSize(new java.awt.Dimension(590,70));
		jPanel.add(getPanelRespuesta(), null);
	}
	return jPanel;
}

/**
 * This method initializes jPanel1	
 * 	
 * @return javax.swing.JPanel	
 */
private JPanel getJPanel1() {
	if (jPanel1 == null) {
		jPanel1 = new JPanel();
		jPanel1.setPreferredSize(new java.awt.Dimension(10,30));
	}
	return jPanel1;
}

/**
 * This method initializes jPanel2	
 * 	
 * @return javax.swing.JPanel	
 */
private JPanel getJPanel22() {
	if (jPanel2 == null) {
		jPanel2 = new JPanel();
		jPanel2.setPreferredSize(new java.awt.Dimension(10,40));
	}
	return jPanel2;
} 
 }
//  @jve:decl-index=0:visual-constraint="23,27"
