
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.gazetteer.wfsg.parsers;
import es.gva.cit.catalogClient.metadataXML.XMLNode;
import es.gva.cit.catalogClient.metadataXML.XMLTree;
import es.gva.cit.gazetteer.querys.ThesaurusName;
import es.gva.cit.gazetteer.querys.ThesaurusNameField;

/**
 * This class is used to parse the DescribeFeatureType operation
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class WfsgDescribeFeatureTypeParser {
/**
 * 
 * 
 */
    private XMLNode rootNode = null;

/**
 * 
 * 
 * 
 * @return 
 * @param node 
 * @param thesaurus 
 */
    public boolean parse(XMLNode node, ThesaurusName thesaurus) {        
        setRootNode(node);
        
        String[] s = node.getName().split(":");
        String prefix = "";
        if (s.length == 2)
            prefix = s[0] + ":";
        
        XMLNode[] nFields = XMLTree.searchMultipleNode(node,prefix + "complexType->" + prefix + "complexContent->" + prefix + "extension->" + prefix + "sequence->" + prefix + "element");
        ThesaurusNameField[] fields = new ThesaurusNameField[nFields.length];
        
        for (int i=0; i<nFields.length ; i++){
            fields[i] = new ThesaurusNameField(XMLTree.searchAtribute(nFields[i],"name"),
                    Integer.valueOf(XMLTree.searchAtribute(nFields[i],"minOccurs")).intValue(),
                    Boolean.valueOf(XMLTree.searchAtribute(nFields[i],"nillable")).booleanValue(),
                    XMLTree.searchAtribute(nFields[i],"type"));
        }   
        
        thesaurus.setFields(fields);
        
        return true;
    } 

/**
 * 
 * 
 * 
 * @return Returns the rootNode.
 */
    public XMLNode getRootNode() {        
        return rootNode;
    } 

/**
 * 
 * 
 * 
 * @param rootNode The rootNode to set.
 */
    public void setRootNode(XMLNode rootNode) {        
        this.rootNode = rootNode;
    } 
 }
