/*
 * Created on 05-may-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import java.awt.Component;
import java.io.File;
import java.io.FileWriter;

import javax.swing.JFileChooser;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.View;

import com.iver.cit.gvsig.gui.layout.FLayoutZooms;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.utiles.GenericFileFilter;

import org.apache.log4j.Logger;
import org.exolab.castor.xml.Marshaller;


/**
 * Extensin para controlar las operaciones basicas sobre el Layout.
 *
 * @author Vicente Caballero Navarro
 */
public class LayoutControls implements Extension {
	private static Logger logger = Logger.getLogger(LayoutControls.class.getName());
	private Layout layout = null;

	/**
	 * @see com.iver.andami.plugins.Extension#execute(java.lang.String)
	 */
	public void execute(String s) {
		layout = (Layout) PluginServices.getMDIManager().getActiveView();

		FLayoutZooms zooms = new FLayoutZooms(layout);
		logger.debug("Comand : " + s);

		if (s.compareTo("PAN") == 0) {
			layout.setTool(Layout.PAN);
		} else if (s.compareTo("ZOOM_IN") == 0) {
			layout.setTool(Layout.ZOOM_MAS);
		} else if (s.compareTo("ZOOM_OUT") == 0) {
			layout.setTool(Layout.ZOOM_MENOS);
		} else if (s.compareTo("CONFIG") == 0) {
			layout.showFConfig();
			layout.fullRect();
		} else if (s.compareTo("PROPERTIES") == 0) {
			layout.showFProperties();
		} else if (s.compareTo("FULL") == 0) {
			layout.fullRect();
		} else if (s.compareTo("REALZOOM") == 0) {
			zooms.realZoom();
		} else if (s.compareTo("ZOOMOUT") == 0) {
			zooms.zoomOut();
		} else if (s.compareTo("ZOOMIN") == 0) {
			zooms.zoomIn();
		} else if (s.compareTo("ZOOMSELECT") == 0) {
			zooms.zoomSelect();
		} else if (s.compareTo("PDF")==0){
			layout.layoutToPDF();
		} else if (s.compareTo("SAVETEMPLATE")==0){
			saveLayout();
		} 
			
		
	}
	private void saveLayout() {
    	layout = (Layout) PluginServices.getMDIManager().getActiveView();
		JFileChooser jfc = new JFileChooser();
		jfc.addChoosableFileFilter(new GenericFileFilter("gvt",
				PluginServices.getText(this, "plantilla")));

		if (jfc.showSaveDialog((Component) PluginServices.getMainFrame()) == JFileChooser.APPROVE_OPTION) {
			File file=jfc.getSelectedFile();
			if (!(file.getPath().endsWith(".gvt") || file.getPath().endsWith(".GVT"))){
				file=new File(file.getPath()+".gvt");
			}
			try {
				FileWriter writer = new FileWriter(file.getAbsolutePath());
				Marshaller m = new Marshaller(writer);
				m.setEncoding("ISO-8859-1");
				m.marshal(layout.getXMLEntity().getXmlTag());
			} catch (Exception e) {
				NotificationManager.addError(PluginServices.getText(this, "Error_guardando_la_plantilla"), e);
			}
		}
	}
	/**
	 * @see com.iver.mdiApp.plugins.Extension#isVisible()
	 */
	public boolean isVisible() {
		View f = PluginServices.getMDIManager().getActiveView();

		if (f == null) {
			return false;
		}

		if (f.getClass() == Layout.class) {
		//	Layout layout = (Layout) f;

			return true; //layout.m_Display.getMapControl().getMapContext().getLayers().layerCount() > 0;
		} else {
			return false;
		}
	}

	/**
	 * @see com.iver.andami.plugins.Extension#inicializar()
	 */
	public void inicializar() {
	}

	/**
	 * @see com.iver.andami.plugins.Extension#isEnabled()
	 */
	public boolean isEnabled() {
		return true;
	}

	/**
	 * Devuelve el Layout sobre el que se opera.
	 *
	 * @return Layout.
	 */
	public Layout getLayout() {
		return layout;
	}
}
