/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.View;

import com.iver.cit.gvsig.gui.layout.Layout;

import org.apache.log4j.Logger;


/**
 * Extensin que contiene todas las herramientas de edicin.
 *
 * @author Vicente Caballero Navarro
 */
public class LayoutEditableToolsExtension implements Extension {
    private static Logger logger = Logger.getLogger(LayoutEditableToolsExtension.class.getName());
    private Layout layout = null;

    /**
     * DOCUMENT ME!
     */
    public void inicializar() {
        // TODO Auto-generated method stub
    }

    /**
     * DOCUMENT ME!
     *
     * @param s DOCUMENT ME!
     */
    public void execute(String s) {
        layout = (Layout) PluginServices.getMDIManager().getActiveView();

        logger.debug("Comand : " + s);

        if (s.compareTo("SELECT") == 0) {
            layout.setTool(Layout.SELECT);
        } else if (s.compareTo("RECTANGLEVIEW") == 0) {
            layout.setTool(Layout.RECTANGLEVIEW);
        } else if (s.compareTo("RECTANGLEPICTURE") == 0) {
            layout.setTool(Layout.RECTANGLEPICTURE);
        } else if (s.compareTo("RECTANGLESCALEBAR") == 0) {
            layout.setTool(Layout.RECTANGLESCALEBAR);
        } else if (s.compareTo("RECTANGLELEGEND") == 0) {
            layout.setTool(Layout.RECTANGLELEGEND);
        } else if (s.compareTo("RECTANGLETEXT") == 0) {
            layout.setTool(Layout.RECTANGLETEXT);
        } else if (s.compareTo("RECTANGLENORTH") == 0) {
            layout.setTool(Layout.RECTANGLENORTH);
        } else if (s.compareTo("POINT") == 0) {
            layout.setTool(Layout.POINT);
        } else if (s.compareTo("LINE") == 0) {
            layout.setTool(Layout.LINE);
        } else if (s.compareTo("POLYLINE") == 0) {
            layout.setTool(Layout.POLYLINE);
        } else if (s.compareTo("CIRCLE") == 0) {
            layout.setTool(Layout.CIRCLE);
        } else if (s.compareTo("RECTANGLESIMPLE") == 0) {
            layout.setTool(Layout.RECTANGLESIMPLE);
        } else if (s.compareTo("POLYGON") == 0) {
            layout.setTool(Layout.POLYGON);
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean isEnabled() {
        View f = PluginServices.getMDIManager().getActiveView();

        if (f == null) {
            return false;
        }

        if (f instanceof Layout) {
            return ((Layout) f).isEditable();
        }

        return false;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean isVisible() {
        View f = PluginServices.getMDIManager().getActiveView();

        if (f == null) {
            return false;
        }

        if (f.getClass() == Layout.class) {
            //	Layout layout = (Layout) f;
            return true; //layout.m_Display.getMapControl().getMapContext().getLayers().layerCount() > 0;
        } else {
            return false;
        }
    }
}
