/*
 * Created on 28-jul-2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import java.util.ArrayList;

import org.apache.log4j.Logger;
import org.cresques.io.GeoRasterFile;
import org.cresques.io.raster.RasterFilterStackManager;
import org.cresques.ui.raster.BandSetupPanel;
import org.cresques.ui.raster.EnhancedPanel;
import org.cresques.ui.raster.FilterRasterDialogPanel;
import org.cresques.ui.raster.RasterTransparencyPanel;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.fmap.FMap;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.RasterAdapter;
import com.iver.cit.gvsig.gui.View;
import com.iver.cit.gvsig.gui.Panels.PropertiesRasterDialog;
import com.iver.cit.gvsig.gui.thememanager.FThemeManagerWindow;
import com.iver.cit.gvsig.project.ProjectView;


/**
 * Extensin de operaciones sobre capas raster y vectorial.
 * El control es comn y visible para ambos tipos de capa. Dependiendo de que
 * sea una capa u otra la seleccionada se ejecutar una accin u otra.
 *
 * @author Nacho brodin (brodin_ign@gva.es)
 */
public class RasterVectorialControls implements Extension {
	private static Logger logger = Logger.getLogger(ThemeControls.class.getName());

	/**
	 * @see com.iver.mdiApp.plugins.Extension#updateUI(java.lang.String)
	 */
	public void execute(String s) {
		View vista = (View) PluginServices.getMDIManager().getActiveView();
		ProjectView model = vista.getModel();
		FMap mapa = model.getMapContext();
		MapControl mapCtrl = vista.getMapControl();
		logger.debug("Comand : " + s);

        FLayer[] selected = mapa.getLayers().getActives();
		
		if (s.compareTo("PROPERTIES") == 0) {
			if(selected[0] instanceof FLyrVect) {
			    FThemeManagerWindow fThemeManagerWindow = new FThemeManagerWindow(selected[0], mapa);
			    PluginServices.getMDIManager().addView(fThemeManagerWindow);
            } else if(selected[0] instanceof FLyrRaster) {
				showRasterProperties((FLyrRaster)selected[0]);
            }
		}  
	}

	public void showRasterProperties(FLyrRaster lyr){
		RasterFilterStackManager 	stackManager = null;
		PropertiesRasterDialog		propsDialog = null;
		BandSetupPanel 				bandSetup = null;
   
		stackManager = new RasterFilterStackManager(((FLyrRaster)lyr).getSource().getFilterStack());
	       		       		
	    int[][] rangeR = stackManager.getTransparecyR();
	    int[][] rangeG = stackManager.getTransparecyG();
	    int[][] rangeB = stackManager.getTransparecyB();
	       		
	    propsDialog = new PropertiesRasterDialog(((FLyrRaster)lyr), rangeR, rangeG, rangeB);
	       	       			
	    int alpha = 255-((FLyrRaster)lyr).getSource().getTransparency();
				
		bandSetup = ((FilterRasterDialogPanel)propsDialog.getContentPane()).getBandSetup();
				
		//Asignacin del alpha actual de la imagen al dialogo
		RasterTransparencyPanel rasterTrans = ((FilterRasterDialogPanel)propsDialog.getContentPane()).getTransparencyPanel();
		rasterTrans.setOpacity(alpha);
					
		//Asignacin del porcentaje de recorte actual de la imagen al dialogo
		EnhancedPanel pEnhan =  ((FilterRasterDialogPanel)propsDialog.getContentPane()).getEnhancedPanel();
				
		propsDialog.setRasterFilterStackManager(stackManager);
				
		ArrayList stackList = stackManager.getStringsFromStack();
		boolean remove = false;
		String hideBands = null;
		for(int i=0;i<stackList.size();i++){
			//System.out.println("*=>"+((String)stackList.get(i)));
			if(((String)stackList.get(i)).startsWith("filter.tail.value")){
				int tail = (int)(Double.parseDouble(stackManager.getValue((String)stackList.get(i)))*200);
				pEnhan.setPercentTail(tail);
			}
			if(((String)stackList.get(i)).startsWith("filter.tail.remove"))
				remove = Boolean.valueOf(stackManager.getValue((String)stackList.get(i))).booleanValue();
					
			if(((String)stackList.get(i)).startsWith("filter.enhanced.remove"))
				remove = Boolean.valueOf(stackManager.getValue((String)stackList.get(i))).booleanValue();
			
			if(((String)stackList.get(i)).startsWith("filter.removebands.bands"))
				hideBands = stackManager.getValue((String)stackList.get(i));
		}
				
		if(stackManager.isActive(stackManager.getTypeFilter("enhanced"))){
			if(remove)
				pEnhan.setSelectedFilter(1);
			else
				pEnhan.setSelectedFilter(2);
		}else
			pEnhan.setSelectedFilter(0);
							
		GeoRasterFile[] files = ((FLyrRaster)lyr).getSource().getFiles();
		bandSetup.addFiles(files);
		for(int i=0; i< files.length;i++)
			propsDialog.addNumBands(files[i].getBandCount());
				
		RasterAdapter rad = ((FLyrRaster)lyr).getSource();
		int posR = 0, posG = 0, posB = 0;
			
		for(int i=0;i<rad.getPosFile(GeoRasterFile.RED_BAND);i++)
			posR += files[i].getBandCount();
		posR += rad.getBand(GeoRasterFile.RED_BAND);
				
		for(int i=0;i<rad.getPosFile(GeoRasterFile.GREEN_BAND);i++)
			posG += files[i].getBandCount();
		posG += rad.getBand(GeoRasterFile.GREEN_BAND);
				
		for(int i=0;i<rad.getPosFile(GeoRasterFile.BLUE_BAND);i++)
			posB += files[i].getBandCount();
		posB += rad.getBand(GeoRasterFile.BLUE_BAND);
							
		bandSetup.assignBand(posR, GeoRasterFile.RED_BAND);
		bandSetup.assignBand(posG, GeoRasterFile.GREEN_BAND);
		bandSetup.assignBand(posB, GeoRasterFile.BLUE_BAND);	
				
		//Seleccin de 1, 2 o 3 bandas para visualizar
		if(hideBands != null){
			int pos = 2;
			if(hideBands.length() == 1)
				pos = 1;
			else if(hideBands.length() == 2)
				pos = 0;
			bandSetup.getFileList().getJComboBox().setSelectedIndex(pos);
					
			//Reseteamos los controles de la tabla
				
			for(int i=0;i<bandSetup.getRGBTable().getModel().getRowCount();i++)
				for(int j=0;j<3;j++)
					bandSetup.getRGBTable().getModel().setValueAt(new Boolean(false), i, j);
					
			if(hideBands.equals("GB") || hideBands.equals("G") || hideBands.equals("B") )
				bandSetup.getRGBTable().getModel().setValueAt(new Boolean(true), posR, 0);
					
			if(hideBands.equals("RB") || hideBands.equals("R") || hideBands.equals("B") )
				bandSetup.getRGBTable().getModel().setValueAt(new Boolean(true), posG, 1);
					
			if(hideBands.equals("RG") || hideBands.equals("R") || hideBands.equals("G") )
				bandSetup.getRGBTable().getModel().setValueAt(new Boolean(true), posB, 2);
		}
				
		propsDialog.readStat();
				
	    PluginServices.getMDIManager().addView(propsDialog);
	}
	
	/**
	 * @see com.iver.mdiApp.plugins.Extension#isVisible()
	 */
	public boolean isVisible() {
		com.iver.andami.ui.mdiManager.View f = PluginServices.getMDIManager()
															 .getActiveView();

		if (f == null) {
			return false;
		}

		if (f.getClass() == View.class) {
			FMap mapa = ((View) f).getModel().getMapContext();

			return mapa.getLayers().getLayersCount() > 0;
		} else {
			return false;
		}
	}

	/**
	 * @see com.iver.andami.plugins.Extension#isEnabled()
	 */
	public boolean isEnabled() {
		View f = (View) PluginServices.getMDIManager().getActiveView();

		if (f == null) {
			return false;
		}

		FLayer[] selected = f.getModel().getMapContext().getLayers().getActives();
		if (	selected.length == 1 && 
				(selected[0] instanceof FLyrVect ||
				selected[0] instanceof FLyrRaster)){
			return true;
		}
		return false;
	}

	/**
	 * @see com.iver.andami.plugins.Extension#inicializar()
	 */
	public void inicializar() {
	}
}