/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import com.hardcode.gdbms.engine.data.driver.DriverException;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.View;

import com.iver.cit.gvsig.gui.Table;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public class TableEditInsertExtension implements Extension {
    /**
     * @see com.iver.andami.plugins.Extension#inicializar()
     */
    public void inicializar() {
    }

    /**
     * @see com.iver.andami.plugins.Extension#execute(java.lang.String)
     */
    public void execute(String actionCommand) {
        if ("INSERTROW".equals(actionCommand)) {
            View v = PluginServices.getMDIManager().getActiveView();

            try {
                ((Table) v).addEmptyRow();
            } catch (DriverException e) {
                NotificationManager.addError("No se pudo insertar la fila", e);
            }
        }

        if ("INSERTCOLUMN".equals(actionCommand)) {
            View v = PluginServices.getMDIManager().getActiveView();

            try {
                ((Table) v).addEmptyRow();
            } catch (DriverException e) {
                NotificationManager.addError("No se pudo insertar la fila", e);
            }
        }
    }

    /**
     * @see com.iver.andami.plugins.Extension#isEnabled()
     */
    public boolean isEnabled() {
    	 View v = PluginServices.getMDIManager().getActiveView();

         if (v == null) {
             return false;
         } else if (v.getClass() == Table.class) {
             return ((Table) v).isEditing();
         } else {
             return false;
         }
    }

    /**
     * @see com.iver.andami.plugins.Extension#isVisible()
     */
    public boolean isVisible() {
        View v = PluginServices.getMDIManager().getActiveView();

        if (v == null) {
            return false;
        } else if (v.getClass() == Table.class) {
            return true;
        } else {
            return false;
        }
    }
}
