package com.iver.cit.gvsig;

import com.hardcode.gdbms.engine.data.driver.DriverException;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.View;

import com.iver.cit.gvsig.gui.Table;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public class TableEditStopExtension implements Extension {
    /**
     * @see com.iver.andami.plugins.Extension#inicializar()
     */
    public void inicializar() {
    }

    /**
     * @see com.iver.andami.plugins.Extension#execute(java.lang.String)
     */
    public void execute(String actionCommand) {
        if ("ROLLBACK".equals(actionCommand)) {
            View v = PluginServices.getMDIManager().getActiveView();

            try {
                ((Table) v).cancelEditing();
            } catch (DriverException e) {
                NotificationManager.addError("No se pudo cancelar la edicin", e);
            }
        } else if ("COMMIT".equals(actionCommand)) {
            View v = PluginServices.getMDIManager().getActiveView();

            try {
                ((Table) v).stopEditing();
            } catch (DriverException e) {
                NotificationManager.addError("No se pudo guardar la edicin", e);
            }
        }
    }

    /**
     * @see com.iver.andami.plugins.Extension#isEnabled()
     */
    public boolean isEnabled() {
        View v = PluginServices.getMDIManager().getActiveView();

        if (v == null) {
            return false;
        } else if (v.getClass() == Table.class) {
            return ((Table) v).isEditing();
        } else {
            return false;
        }
    }

    /**
     * @see com.iver.andami.plugins.Extension#isVisible()
     */
    public boolean isVisible() {
        View v = PluginServices.getMDIManager().getActiveView();

        if (v == null) {
            return false;
        } else if (v.getClass() == Table.class) {
            return true;
        } else {
            return false;
        }
    }
}
