/*
 * Created on 24-jun-2003
 *
 * Copyright (c) 2003
 * Francisco Jos� Pe�arrubia Mart�nez
 * IVER Tecnolog�as de la Informaci�n S.A.
 * Salamanca 50
 * 46005 Valencia (        SPAIN )
 * +34 963163400
 * mailto:fran@iver.es
 * http://www.iver.es
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.Dialogs;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.StringTokenizer;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.table.AbstractTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

import com.iver.andami.PluginServices;
import com.iver.andami.Utilities;
import com.iver.andami.ui.mdiManager.SingletonView;
import com.iver.andami.ui.mdiManager.ViewInfo;
import com.iver.cit.gvsig.project.ProjectView;


/**
 * DOCUMENT ME!
 *
 * @author Administrador To change the template for this generated type comment
 *         go to Window>Preferences>Java>Code Generation>Code and Comments
 */
public final class FInfoDialog extends JPanel implements SingletonView {
   	boolean DEBUG=true;
    private ArrayList m_arrayNomTemas;
    private String m_strInfo;
    private ArrayList m_arrayStrings;
    private MyTableModel m_gridModel;
    private int m_itemSelected;
    private int m_subItemSelected;
    private DefaultTreeModel m_treeModel;

    // Variables declaration - do not modify
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTable m_grid;
    private javax.swing.JTree jTree1;
    
	private ProjectView viewModel = null; 
	
	/**
     * Creates new form FInfoDialog
     *
     * @param parent DOCUMENT ME!
     * @param modal DOCUMENT ME!
     */
    public FInfoDialog() {
        //super(parent, modal);
        m_arrayNomTemas = new ArrayList();
        m_arrayStrings = new ArrayList();

        initComponents();
        
        this.setSize(300, 235);
    }

    /**
     * DOCUMENT ME!
     */
    public void refresh() {
        setSelected(0, 0);
        refreshLeft();
        refreshRight();
    }

    /**
     * DOCUMENT ME!
     */
    public void clearAll() {
        m_arrayStrings.clear();
        m_arrayNomTemas.clear();
        m_strInfo = "";
        jTree1.removeAll();
        

        DefaultMutableTreeNode top = new DefaultMutableTreeNode("root");

        // m_treeModel.setRoot(top);
        m_treeModel = new DefaultTreeModel(top);
        m_gridModel.setData("","",0);
        jTree1.setModel(m_treeModel);
    }

    /**
     * DOCUMENT ME!
     */
    private void refreshLeft() {
        int i;
        int j;

        DefaultMutableTreeNode idRoot = (DefaultMutableTreeNode) m_treeModel.getRoot();
        
        

        for (i = 0; i < m_arrayStrings.size(); i++) {
            String strInfo = (String) m_arrayStrings.get(i);
            String nomTema = (String) m_arrayNomTemas.get(i);
            StringTokenizer tkz = new StringTokenizer(strInfo, "\n");
            String strCampos = tkz.nextToken();

            DefaultMutableTreeNode idTema = new DefaultMutableTreeNode(nomTema);
            m_treeModel.insertNodeInto(idTema, idRoot, i);
            
            j = 0;

            while (tkz.hasMoreTokens()) {
                String token = tkz.nextToken();
                StringTokenizer tkzValores = new StringTokenizer(token, "|");
                String strID = tkzValores.nextToken();
                MyTreeItem aux = new MyTreeItem(strID, i, j);

                DefaultMutableTreeNode idChild = new DefaultMutableTreeNode(aux);
                m_treeModel.insertNodeInto(idChild, idTema, j);

                // jTree1.expandRow(j);
                if ((i == m_itemSelected) && (j == m_subItemSelected)) {
                    // TreePath elPath = jTree1.getPathForRow(j);
                    TreePath elPath = new TreePath(idChild.getPath());
                    jTree1.expandPath(elPath);
                   if (DEBUG) System.out.println("El path = " + elPath);
                    jTree1.setSelectionPath(elPath);
                }

                // m_tree->Expand(idChild);
                // m_tree->EnsureVisible(idChild);
                j++;
            }
        }
         // for tema

        jTree1.stopEditing();
        jTree1.setRootVisible(false);
    }

    /**
     * DOCUMENT ME!
     */
    private void refreshRight() {
        m_grid.invalidate();
        m_grid.repaint();
    }

    /**
     * DOCUMENT ME!
     *
     * @param idItem DOCUMENT ME!
     * @param idSubItem DOCUMENT ME!
     */
    private void setSelected(int idItem, int idSubItem) {
        m_itemSelected = idItem;
        m_subItemSelected = idSubItem;

        int i;
        int numCols;
        int numRows = 0;

        for (i = 0; i < m_arrayStrings.size(); i++) {
            if (i == m_itemSelected) {
                m_strInfo = (String) m_arrayStrings.get(i);
            }
        }

        StringTokenizer tkz = new StringTokenizer(m_strInfo, "\n");
        if (! tkz.hasMoreTokens()) return;
        
        String strCampos = tkz.nextToken();

        StringTokenizer tkzCampos = new StringTokenizer(strCampos, "|");
        i = 0;

        while (tkzCampos.hasMoreTokens()) {
            tkzCampos.nextToken();
            i++;
        }

        numCols = i;

        int regSelec = 0;
        String strValores = "";

        while (tkz.hasMoreTokens()) {
            String token = tkz.nextToken();

            if (regSelec == m_subItemSelected) {
                strValores = token;
            }

            regSelec++;
        }

        if (strValores != "") {
            m_gridModel.setData(strCampos, strValores, numCols);
        }

        refreshRight();
    }

    /**
     * This method is called from within the constructor to initialize the
     * form. WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
        jSplitPane1 = new javax.swing.JSplitPane();

        DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode("root");
        m_treeModel = new DefaultTreeModel(rootNode);

        jTree1 = new javax.swing.JTree(m_treeModel);
        jTree1.setEditable(true);
        jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        jTree1.setShowsRootHandles(true);

        m_grid = new javax.swing.JTable();

      /*  addWindowListener(new java.awt.event.WindowAdapter() {
                public void windowClosing(java.awt.event.WindowEvent evt) {
                    closeDialog(evt);
                }
            });
*/
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
                public void valueChanged(
                    javax.swing.event.TreeSelectionEvent evt) {
                    jTree1ValueChanged(evt);
                }
            });

        //Create the scroll pane and add the tree to it. 
        JScrollPane treeView = new JScrollPane(jTree1);
        treeView.setPreferredSize((new Dimension(80, 200)));
        //Add the scroll panes to a split pane.
        jSplitPane1.setLeftComponent(treeView);

        m_gridModel = new MyTableModel();
        m_grid.setModel(m_gridModel);

        JScrollPane tableView = new JScrollPane(m_grid);

        // tableView.setBackground(java.awt.Color.WHITE);
        jSplitPane1.setRightComponent(tableView);

        java.awt.Dimension minimumSize = new java.awt.Dimension(100, 50);
        m_grid.setMinimumSize(minimumSize);
        treeView.setMinimumSize(minimumSize);

        // splitPane.setDividerLocation(100); //XXX: ignored in some releases
        //of Swing. bug 4101306
        //workaround for bug 4101306:
        //treeView.setPreferredSize(new Dimension(100, 100)); 
        jSplitPane1.setPreferredSize(new java.awt.Dimension(300, 200));

        setLayout(new BorderLayout());
        add(jSplitPane1, java.awt.BorderLayout.CENTER);

        //pack();
    }

    /**
     * DOCUMENT ME!
     *
     * @param evt DOCUMENT ME!
     */
    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {
        // Add your handling code here:
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getLastSelectedPathComponent();

        if (node == null) {
            return;
        }

        Object nodeInfo = node.getUserObject();

        if (node.isLeaf()) {
            MyTreeItem dato = (MyTreeItem) nodeInfo;
            setSelected(dato.m_idNodo, dato.m_idSubNodo);
        }

        // System.out.println("El path seleccionado= " + jTree1.getRowForPath(evt.getPath()));
    }

   
    /**
     * DOCUMENT ME!
     *
     * @param nomTema DOCUMENT ME!
     * @param strInfo DOCUMENT ME!
     */
    public void addLayerInfo(String nomTema, String strInfo) {
        m_arrayNomTemas.add(nomTema);
        m_arrayStrings.add(strInfo);
    }

    private class MyTableModel extends AbstractTableModel {
        private String[] columnNames;
        private Object[][] data;

        MyTableModel() {
            columnNames = new String[2];
            columnNames[0] = PluginServices.getText(this,"campo");
            columnNames[1] = PluginServices.getText(this,"Valor");
            data = new Object[1][2];
        }

        public int getColumnCount() {
            return columnNames.length;
        }

        public int getRowCount() {
            return data.length;
        }

        public String getColumnName(int col) {
            return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
            return data[row][col];
        }

        public void setData(String strCampos, String strValores, int numRows) {
            // Fijamos columnNames y data en funci�n de strInfo.
            // strInfo es una cabecera con los nombres de los campos separados
            // por | y despu�s una l�nea por cada registro con los valores
            // de los campos.			
            data = new Object[numRows][2];
            
            if (strCampos == "") return; // Como si borraramos la tabla

            int i;

            StringTokenizer tkzCampos = new StringTokenizer(strCampos, "|");
            i = 0;

            while (tkzCampos.hasMoreTokens()) {
                data[i][0] = tkzCampos.nextToken();
                i++;
            }

            StringTokenizer tkzValores = new StringTokenizer(strValores, "|");
            String strID = tkzValores.nextToken();
            i = 0;

            while (tkzValores.hasMoreTokens()) {
                // m_grid->SetCellValue(i,1,tkzValores.GetNextToken());
                data[i][1] = tkzValores.nextToken();
                i++;
            }
        }
    }
     // MyTableModel

    private final class MyTreeItem {
        public int m_idNodo;
        public int m_idSubNodo;
        private String m_strVal;

        public MyTreeItem(String str, int idN, int idSub) {
            m_strVal = str;
            m_idNodo = idN;
            m_idSubNodo = idSub;
        }

        public String toString() {
            return m_strVal;
        }
    }
	/* (non-Javadoc)
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo m_ViewInfo=new ViewInfo(ViewInfo.MODELESSDIALOG|ViewInfo.RESIZABLE);
			m_ViewInfo.setTitle(PluginServices.getText(this,"Identificar_Resultados"));
return m_ViewInfo;
		}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.SingletonView#getViewModel()
	 */
	public Object getViewModel() {
		return viewModel;
	}

    // End of variables declaration
	/**
	 * @param view
	 */
	public void setViewModel(ProjectView view) {
		viewModel = view;
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#viewActivated()
	 */
	public void viewActivated() {
	}

}
