/*
 * Created on 18-jun-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Rectangle2D;
import java.io.File;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.cresques.cts.ICoordTrans;
import org.cresques.cts.IProjection;
import org.cresques.cts.ProjectionPool;
import org.cresques.cts.gt2.CoordSys;
import org.cresques.cts.gt2.CoordTrans;

import com.hardcode.driverManager.Driver;
import com.hardcode.driverManager.DriverLoadException;
import com.hardcode.gdbms.engine.data.driver.DBDriver;
import com.hardcode.gdbms.engine.instruction.FieldNotFoundException;
import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.ui.mdiManager.View;
import com.iver.andami.ui.mdiManager.ViewInfo;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver;
import com.iver.cit.gvsig.fmap.drivers.RasterDriver;
import com.iver.cit.gvsig.fmap.drivers.VectorialFileDriver;
import com.iver.cit.gvsig.fmap.drivers.WithDefaultLegend;
import com.iver.cit.gvsig.fmap.layers.CancelationException;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.LayerFactory;
import com.iver.cit.gvsig.fmap.layers.layerOperations.Classifiable;
import com.iver.cit.gvsig.fmap.rendering.LegendFactory;
import com.iver.cit.gvsig.fmap.rendering.VectorialLegend;
import com.iver.cit.gvsig.gui.thememanager.FThemeManagerWindow;

/**
 * @author FJP
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class FPanelLocConfig extends JPanel implements ActionListener,View {
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JList jList = null;
	private javax.swing.JButton jBtnUp = null;
	private javax.swing.JButton jBtnDown = null;
	private javax.swing.JButton jBtnAddLayer = null;  //
	private javax.swing.JButton jBtnRemoveLayer = null;
	private javax.swing.JButton jBtnEditLegend = null;
	private javax.swing.JButton jBtnCancel = null;
	
	//private JDialog m_Owner;
	private MapControl mapCtrl;
	private ViewInfo m_viewinfo = null;
	/**
	 * This is the default constructor
	 */
	public FPanelLocConfig( MapControl mc) {
		super();
		mapCtrl = mc;
		initialize();
		refreshList();
		updateControls(null);
	}
	
	private void refreshList()
	{
		DefaultListModel lstModel = (DefaultListModel) getJList().getModel();
		lstModel.clear();
		for (int i=mapCtrl.getMapContext().getLayers().getLayersCount()-1; i >=0; i--)
		{
			FLayer lyr = mapCtrl.getMapContext().getLayers().getLayer(i);
			lstModel.addElement(lyr.getName());
		}	
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		this.setLayout(null);
		this.setSize(390, 250);
		this.setPreferredSize(new java.awt.Dimension(370,200));
		this.add(getJLabel(), null);
		this.add(getJList(), null);
		this.add(getJBtnUp(), null);
		this.add(getJBtnDown(), null);
		this.add(getJBtnAddLayer(), null);
		this.add(getJBtnRemoveLayer(), null);
		this.add(getJBtnEditLegend(), null);
		this.add(getJBtnCancel(), null);
	}
	/**

	 * This method initializes jLabel	

	 * 	

	 * @return javax.swing.JLabel	

	 */    
	private javax.swing.JLabel getJLabel() {
		if (jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText(PluginServices.getText(this,"Capas_del_localizador")+":");
			jLabel.setBounds(22, 15, 132, 25);
		}
		return jLabel;
	}

	/**

	 * This method initializes jList	

	 * 	

	 * @return javax.swing.JList	

	 */    
	private javax.swing.JList getJList() {
		if (jList == null) {
			jList = new javax.swing.JList(new DefaultListModel());
			jList.setBounds(22, 49, 179, 139);
			jList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			jList.setBorder(BorderFactory.createLineBorder(Color.BLACK));
			jList.addListSelectionListener(new javax.swing.event.ListSelectionListener() { 

				public void valueChanged(javax.swing.event.ListSelectionEvent e) {    
					updateControls(e);
				}
			});

		}
		return jList;
	}
	
	private void updateControls(javax.swing.event.ListSelectionEvent e)
	{
		System.out.println("valueChanged()"); // TODO Auto-generated Event stub valueChanged()
		DefaultListModel lstModel = (DefaultListModel) getJList().getModel();
		int selIndex = jList.getSelectedIndex();
		jBtnDown.setEnabled(false);
		jBtnUp.setEnabled(false);
		
		if (selIndex != -1)
		{
			if (lstModel.getSize() > 1)
			{
				if (selIndex < (lstModel.getSize()-1))
					jBtnDown.setEnabled(true);
				
				if (selIndex > 0)
					jBtnUp.setEnabled(true);
			}
			
		}

		
	}

	/**

	 * This method initializes jBtnUp	

	 * 	

	 * @return javax.swing.JButton	

	 */    
	private javax.swing.JButton getJBtnUp() {
		if (jBtnUp == null) {
			jBtnUp = new javax.swing.plaf.basic.BasicArrowButton(
					javax.swing.SwingConstants.NORTH);
			jBtnUp.setBounds(206, 49, 25, 23);
			jBtnUp.setToolTipText(PluginServices.getText(this,"Subir_capa"));
			jBtnUp.addActionListener(this);
			jBtnUp.setActionCommand("UP");

		}
		return jBtnUp;
	}

	/**

	 * This method initializes jBtnDown	

	 * 	

	 * @return javax.swing.JButton	

	 */    
	private javax.swing.JButton getJBtnDown() {
		if (jBtnDown == null) {
			jBtnDown = new javax.swing.plaf.basic.BasicArrowButton(
					javax.swing.SwingConstants.SOUTH);
			jBtnDown.setBounds(206, 164, 25, 23);
			jBtnDown.setToolTipText(PluginServices.getText(this,"Bajar_capa"));
			jBtnDown.setActionCommand("DOWN");
			jBtnDown.addActionListener(this);
		}
		return jBtnDown;
	}

	/**

	 * This method initializes jButton2	

	 * 	

	 * @return javax.swing.JButton	

	 */    
	private javax.swing.JButton getJBtnAddLayer() {
		if (jBtnAddLayer == null) {
			jBtnAddLayer = new javax.swing.JButton();
			jBtnAddLayer.setBounds(251, 49, 109, 23);
			jBtnAddLayer.setText(PluginServices.getText(this,"Anadir_capa")+"...");
			jBtnAddLayer.addActionListener(this);
			jBtnAddLayer.setActionCommand("ADD_LAYER");
		}
		return jBtnAddLayer;
	}

	/**

	 * This method initializes jBtnRemoveLayer	

	 * 	

	 * @return javax.swing.JButton	

	 */    
	private javax.swing.JButton getJBtnRemoveLayer() {
		if (jBtnRemoveLayer == null) {
			jBtnRemoveLayer = new javax.swing.JButton();
			jBtnRemoveLayer.setBounds(251, 78, 109, 23);
			jBtnRemoveLayer.setText(PluginServices.getText(this,"Quitar_capa")+"...");
			jBtnRemoveLayer.addActionListener(this);
			jBtnRemoveLayer.setActionCommand("REMOVE_LAYER");
			
		}
		return jBtnRemoveLayer;
	}

	/**

	 * This method initializes jBtnEditLegend	

	 * 	

	 * @return javax.swing.JButton	

	 */    
	private javax.swing.JButton getJBtnEditLegend() {
		if (jBtnEditLegend == null) {
			jBtnEditLegend = new javax.swing.JButton();
			jBtnEditLegend.setBounds(251, 113, 109, 23);
			jBtnEditLegend.setText(PluginServices.getText(this,"Editar_leyenda")+"...");
			jBtnEditLegend.addActionListener(this);
			jBtnEditLegend.setActionCommand("EDIT_LEGEND");
		}
		return jBtnEditLegend;
	}

	/**

	 * This method initializes jBtnCancel	

	 * 	

	 * @return javax.swing.JButton	

	 */    
	private javax.swing.JButton getJBtnCancel() {
		if (jBtnCancel == null) {
			jBtnCancel = new javax.swing.JButton();
			jBtnCancel.setBounds(251, 162, 109, 23);
			jBtnCancel.setText(PluginServices.getText(this,"Cerrar"));
			jBtnCancel.setActionCommand("CANCEL");
			jBtnCancel.addActionListener(this); 

		}
		return jBtnCancel;
	}
	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e)
	{
		DefaultListModel lstModel = (DefaultListModel) getJList().getModel();
		FLayers theLayers = mapCtrl.getMapContext().getLayers();
        IProjection proj = null; 
		
		int numLayers = theLayers.getLayersCount()-1;

		if (e.getActionCommand() == "CANCEL")
		{
			if (PluginServices.getMainFrame() != null)
			{
				PluginServices.getMDIManager().closeView(FPanelLocConfig.this);
			}
			else
			{
				((JDialog) (getParent().getParent().getParent().getParent())).dispose();
			}
		}
		if (e.getActionCommand() == "ADD_LAYER")
		{
            FOpenDialog fopen = new FOpenDialog();            
            if (PluginServices.getMainFrame() != null)
            {
                FileOpenDialog fileDlg = new FileOpenDialog(new Class[]{VectorialFileDriver.class, GeorreferencedRasterDriver.class});
//                DataBaseOpenDialog dbop = new DataBaseOpenDialog();
//                dbop.setClasses(new Class[] { DBDriver.class });
                fopen.addTab("Fichero", fileDlg);
//                fopen.addTab("Base de datos", dbop);
                PluginServices.getMDIManager().addView(fopen);

                if (fopen.isAccepted()) {
                    // TODO: Hacer lo de la capa WMS tambin.
                    if (fileDlg.getFiles() == null) {
                        return;
                    }
                    proj =FOpenDialog.getLastProjection();
                    FLayer lyr = null;
                    File[] files = fileDlg.getFiles();
                    String[] driverNames = fileDlg.getDriverNames();
                    Driver[] drivers = new Driver[driverNames.length];
                    for (int i = 0; i < drivers.length; i++) {
						try {
							drivers[i] = LayerFactory.getDM().getDriver(driverNames[i]);
						} catch (DriverLoadException e1) {
							e1.printStackTrace();
						}
					}
                    Rectangle2D[] rects=new Rectangle2D[files.length];
                    boolean first=false;
                    mapCtrl.getMapContext()
                       .beginAtomicEvent();
                    
                    for (int iFile = 0; iFile < files.length; iFile++) {
                        File fich = files[iFile];
                        String layerName = fich.getName();
                        String layerPath = fich.getAbsolutePath();

                        try {
                        	if (drivers[iFile] instanceof VectorialFileDriver){
                                lyr = LayerFactory.createLayer(layerName, (VectorialFileDriver) drivers[iFile],
                                        fich, proj);
                        	}else if (drivers[iFile] instanceof RasterDriver){
                                lyr = LayerFactory.createLayer(layerName,
                                        (RasterDriver) drivers[iFile], fich, proj);
                        	}

                            if (lyr != null) {
                                try {

                                    lyr.setVisible(true);
                                    mapCtrl.getMapContext().getLayers()
                                           .addLayer(lyr);
                                    try
                                    {
                                        // Le asignamos tambin una leyenda por defecto acorde con
                                        // el tipo de shape que tenga. Tampoco s si es aqu el
                                        // sitio adecuado, pero en fin....
                                        if (lyr instanceof FLyrVect)
                                        {
                                            FLyrVect lyrVect = (FLyrVect) lyr;
                                            // Comprobar que la projeccin es la misma que la vista                                            
                                            if (proj != mapCtrl.getProjection()) {
                                                int option = JOptionPane.showConfirmDialog(null,
                                                        PluginServices.getText(this, "reproyectar_aviso"),
                                                        PluginServices.getText(this, "reproyectar_pregunta"),
                                                        JOptionPane.YES_NO_OPTION);

                                                if (option == JOptionPane.NO_OPTION) {
                                                    return;
                                                } else {
                                                    ICoordTrans ct = new CoordTrans((CoordSys) proj,
                                                            (CoordSys) mapCtrl.getProjection());
                                                    lyrVect.setCoordTrans(ct);
                                                    System.err.println("coordTrans = " +
                                                        proj.getAbrev() + " " +
                                                        mapCtrl.getProjection().getAbrev());
                                                }
                                            }
                                            
                                            if (drivers[iFile] instanceof WithDefaultLegend) {
                                                WithDefaultLegend aux = (WithDefaultLegend) drivers[iFile];
                                                lyrVect.setLegend((VectorialLegend) aux.getDefaultLegend());                                        
                                            } else {
                                                lyrVect.setLegend(LegendFactory.createSingleSymbolLegend(
                                                        lyrVect.getShapeType()));
                                            }
                                        }
                                    }
                                    catch (FieldNotFoundException fe)
                                    {
                                        fe.printStackTrace();
                                    }
                                    
                                } catch (CancelationException ex) {
                                    // TODO Auto-generated catch block
                                    ex.printStackTrace();
                                }

                            }
                        } catch (DriverException ex) {
                        	NotificationManager.addError("Aadiendo capa",ex);
                        }
                    } // for
                    //Esto permite que cuando se cargan varias capas de golpe y la vista est vacia,se ponga como extent la suma de todos sus extents.
                    if (rects.length > 1) {
                        Rectangle2D rect = new Rectangle2D.Double();
                        rect.setRect(rects[0]);

                        if (first) {
                            for (int i = 0; i < rects.length; i++) {
                                rect.add(rects[i]);
                            }

                            mapCtrl.getMapContext().getViewPort()
                                   .setExtent(rect);
                        }
                    }
                    mapCtrl.getMapContext().endAtomicEvent();
                    if (mapCtrl instanceof MapOverview){
                        ((MapOverview)mapCtrl).refreshExtent();
                    }
                    
                }
            	
            }
            else
            {
            	JDialog dlg = new JDialog();
                dlg.setModal(true);
                FileOpenDialog fileDlg = new FileOpenDialog(new Class[]{VectorialFileDriver.class});
                DataBaseOpenDialog dbop = new DataBaseOpenDialog();
                dbop.setClasses(new Class[]{DBDriver.class});
                
                fopen = new FOpenDialog();
                fopen.addTab("Fichero", fileDlg);
                fopen.addTab("Base de datos", dbop);
                // fileDlg.setPreferredSize(fopen.getSize());
                dlg.setSize(fopen.getSize());
                dlg.getContentPane().add(fopen);
                dlg.pack();
                dlg.show();
                
      
                // TODO: Hacer lo de la capa WMS tambin.
        		if (fileDlg.getFiles() == null) return;
        		FLayer lyr = null;
        		File[] files = fileDlg.getFiles();
        		String[] driverNames = fileDlg.getDriverNames();
        		Driver[] drivers = new Driver[driverNames.length];
        		for (int i = 0; i < drivers.length; i++) {
					try {
						drivers[i] = LayerFactory.getDM().getDriver(driverNames[i]);
					} catch (DriverLoadException e1) {
						e1.printStackTrace();
					}
				}
        		for  (int iFile=0; iFile < files.length; iFile++)
        		{
        			File fich = files[iFile];
        			String layerName = fich.getName();
        			String layerPath = fich.getAbsolutePath();
        			
        			try {
        				if (drivers[iFile] instanceof VectorialFileDriver) {
            				lyr = LayerFactory.createLayer(layerName, (VectorialFileDriver) drivers[iFile], fich, proj);
        				}else if (drivers[iFile] instanceof RasterDriver) {
            				lyr = LayerFactory.createLayer(layerName, driverNames[iFile], fich, proj);
        				}

        				lyr.setVisible(true);
        				lyr.setName(layerName);
        				if (lyr != null )
        				{
        					try {
        						mapCtrl.getMapContext().getLayers().addLayer(lyr);
        					} catch (CancelationException ex) {
        						// TODO Auto-generated catch block
        						ex.printStackTrace();
        					}
        				}    		
        				
        			} catch (DriverException ex) {
        				NotificationManager.addError("Aadiendo capa",ex);
    				}
        		} // for
           //  lstModel.addElement(lyr.getName());
            }
            refreshList();
            updateControls(null);
	            
 		}
		if (e.getActionCommand() == "REMOVE_LAYER")
		{
			if (jList.getSelectedIndex() != -1)
			{
				theLayers.removeLayer((String) lstModel.get(jList.getSelectedIndex()));
				lstModel.remove(jList.getSelectedIndex());
				///mapCtrl.drawMap();
				updateControls(null);
				  if (mapCtrl instanceof MapOverview){
                	((MapOverview)mapCtrl).refreshExtent();
                }
			}
		}
		if (e.getActionCommand() == "EDIT_LEGEND")
		{
			int idSelec = jList.getSelectedIndex(); 
			if (idSelec != -1)
			{
				FLayer lyr = theLayers.getLayer((String) lstModel.get(idSelec));
				if (lyr instanceof Classifiable)
				{
					FThemeManagerWindow m_LegendEditor = new FThemeManagerWindow();
					try {
						theLayers.setActive(false);
						lyr.setActive(true);
						m_LegendEditor.setMapContext(mapCtrl.getMapContext());
					} catch (DriverException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					if (PluginServices.getMainFrame() == null) {
						JDialog dlg = new JDialog();
						    							
						m_LegendEditor.setPreferredSize(m_LegendEditor.getSize());
						dlg.getContentPane().add(m_LegendEditor);
						dlg.setModal(true);			
						dlg.pack();
						dlg.show();
						
					} else {
						PluginServices.getMDIManager().addView(m_LegendEditor);
					}
				}
				else
				{
					JOptionPane.showMessageDialog(null, PluginServices.getText(this,"Solo_para_capas_vectoriales")+".");
				}

			}

		}
		if (e.getActionCommand() == "UP")
		{
			int idSelec = jList.getSelectedIndex();
		    int fromIndex = idSelec;
		    int toIndex = idSelec-1;
		        FLayer aux = theLayers.getLayer((String) lstModel.get(fromIndex));
		        try {
					theLayers.moveTo(numLayers-fromIndex, numLayers-toIndex);
				} catch (CancelationException e1) {
					e1.printStackTrace();
				}
		        
		        lstModel.remove(fromIndex);
		        lstModel.add(toIndex,aux.getName());
		        
		        jList.setSelectedIndex(toIndex);
		        
		        ///mapCtrl.drawMap();
		}
		if (e.getActionCommand() == "DOWN")
		{
			int idSelec = jList.getSelectedIndex();
		    int fromIndex = idSelec;
		    int toIndex = idSelec+1;
		        FLayer aux = theLayers.getLayer((String) lstModel.get(fromIndex));
		        try {
		        	theLayers.moveTo(numLayers-fromIndex, numLayers-toIndex);
				} catch (CancelationException e1) {
					e1.printStackTrace();
				}
		        
		        lstModel.remove(fromIndex);
		        lstModel.add(toIndex,aux.getName());
		        
		        jList.setSelectedIndex(toIndex);
		        
		        ///mapCtrl.drawMap();
		}
		
		
	}
	/* (non-Javadoc)
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		if (m_viewinfo==null){
    		m_viewinfo=new ViewInfo(ViewInfo.PALETTE);
			m_viewinfo.setTitle(PluginServices.getText(this,"Configurar_localizador"));
		}
			return m_viewinfo;
		}
	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#viewActivated()
	 */
	public void viewActivated() {
	}

        }  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
