/*
 * Created on 21-jun-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui;

import com.iver.cit.gvsig.fmap.ColorEvent;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.ExtentEvent;
import com.iver.cit.gvsig.fmap.FMap;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.ViewPortListener;
import com.iver.cit.gvsig.fmap.tools.Behavior.PointBehavior;
import com.iver.cit.gvsig.gui.toolListeners.MapOverviewListener;
import com.iver.cit.gvsig.gui.toolListeners.StatusBarListener;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;


/**
 * DOCUMENT ME!
 *
 * @author FJP TODO To change the template for this generated type comment go
 * 		   to Window - Preferences - Java - Code Generation - Code and
 * 		   Comments
 */
public class MapOverview extends MapControl implements ViewPortListener {
	private MapControl m_MapAssoc;
	boolean first = true;

	/**
	 * Crea un nuevo MapOverview.
	 *
	 * @param mapAssoc DOCUMENT ME!
	 */
	public MapOverview(MapControl mapAssoc) {
		super();

		// super.vp.setBackColor(new Color(230,230,230));
		m_MapAssoc = mapAssoc;

		// setModel((FMap) m_MapAssoc.getMapContext().clone()); // Lo inicializamos con
		// los mismos temas que tenga el grande.
		MapOverviewListener movl = new MapOverviewListener(this);
		addMapTool("zoomtopoint", new PointBehavior(movl));
		setCursor(movl.getCursor());

		setTool("zoomtopoint");
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public FMap getAssociatedMapContext() {
		return m_MapAssoc.getMapContext();
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.opensig.gui.IMapExtentListener#extentChanged(java.awt.geom.Rectangle2D)
	 */
	public void extentChanged(ExtentEvent evExtent) {
		// Nos llega el nuevo extent del FMap asociado, as que dibujamos nuestro 
		// rectngulo para mostrar la zona de dibujo del otro mapa.
		repaint();
	}

	/**
	 * Recalcula el extent a aplicar de las capas que estan aadidas.
	 */
	public void refreshExtent() {
		try {
		if (this.getMapContext().getFullExtent()!=null){
				this.getMapContext().getViewPort().setExtent(this.getMapContext().getFullExtent());
		}else{
			delModel();
		}
		} catch (DriverException e1) {
			e1.printStackTrace();
		}
	}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
	 */
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
			if ((m_MapAssoc.getMapContext().getViewPort().getExtent() != null) &&
					(getMapContext().getViewPort().getExtent() != null)) {
				if (first) {
					first = false;
					repaint();

					return;
				} else {
					first = true;
				}

				ViewPort vp = getMapContext().getViewPort();
				ViewPort vpOrig = m_MapAssoc.getMapContext().getViewPort();
				Graphics2D g2 = (Graphics2D) g;
				g2.setColor(Color.black);
				g2.setXORMode(Color.white);

				// Dibujamos el extent del mapa asociado.
				g2.setTransform(vp.getAffineTransform());

				g2.fill(vpOrig.getAdjustedExtent());
				// dibujamos las lneas vertical y horizontal
				Point2D pRightUp = vp.toMapPoint(getWidth(), 0);
				Line2D.Double linVert = new Line2D.Double(vpOrig.getExtent()
																.getCenterX(),
						vp.getExtent().getMinY(), vpOrig.getExtent().getCenterX(),
						pRightUp.getY());
				Line2D.Double linHoriz = new Line2D.Double(vp.getExtent().getMinX(),
						vpOrig.getExtent().getCenterY(), pRightUp.getX(),
						vpOrig.getExtent().getCenterY());

				g2.draw(linVert);
				g2.draw(linHoriz);

				g2.setTransform(new AffineTransform());

				// System.out.println("Dibujo el extent " + m_MapAssoc.getExtent().toString());
			}
		
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param model DOCUMENT ME!
	 */
	public void setModel(FMap model) {
		this.setMapContext(model);
		m_MapAssoc.getMapContext().getViewPort().addViewPortListener(this);
		getMapContext().getViewPort().addViewPortListener(this);
	}
	private void delModel(){
		this.getMapContext().getViewPort().setExtent(null);
		m_MapAssoc.getMapContext().getViewPort().removeViewPortListener(this);
		getMapContext().getViewPort().removeViewPortListener(this);
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.ViewPortListener#backColorChanged(com.iver.cit.gvsig.fmap.ColorEvent)
	 */
	public void backColorChanged(ColorEvent e) {
	}
}
