/*
 * Created on 17-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.Panels;

import java.awt.Dimension;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.io.IOException;

import org.cresques.cts.IProjection;
import org.cresques.geo.ViewPortData;
import org.cresques.io.EcwWriter;
import org.cresques.io.GdalWriter;
import org.cresques.io.GeoRasterWriter;
import org.cresques.io.IDataWriter;
import org.cresques.px.Extent;
import org.cresques.ui.raster.ProgressSaveRasterPanel;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.View;
import com.iver.andami.ui.mdiManager.ViewInfo;
import com.iver.cit.gvsig.RasterizerLayer;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.gui.Panels.SaveRasterDialog.DriverProperties;

import es.gva.cit.jgdal.Gdal;
import es.gva.cit.jgdal.GdalDriver;
import es.gva.cit.jgdal.GdalException;

/**
 * @author Nacho Brodin <brodin_ign@gva.es>
 */
public class ProgressSaveRasterDialog extends ProgressSaveRasterPanel implements View{
	
	private FLayers 					layers = null;
	private IProjection 				currentProjection = null;
	private MapControl					mapCtrl = null;
	private ViewPort 					vp = null;
	private DriverProperties 			driverProps = null;
	private GeoRasterWriter 			writer = null;
	private String 						fName = null;
	private int 						sizeBlock = 64;
	private int 						compresion = 1;
	private Dimension 					dimension = null;
	private Save						threadSave = null;
	private double[]					maxPercentBarList = new double[1];
	
	/**
	 * @author Nacho Brodin <brodin_ign@gva.es>
	 */
	class Save extends Thread{
		
		private ProgressSaveRasterDialog window = null;
		
		Save(ProgressSaveRasterDialog window){
			this.window = window;
		}
		
		public void run(){
			if (fName.endsWith(".ecw") || fName.endsWith(".jp2")) {
				//System.out.println("Salvando vista a fichero "+fName+" a formato Ecw");
				try{
				
					RasterizerLayer p = new RasterizerLayer(layers, vp, sizeBlock, mapCtrl);
					p.setProgressBar(window.getJProgressBar(), maxPercentBarList[0]);
					Extent ex = new Extent(vp.getAdjustedExtent());
					Dimension imgSz = vp.getImageSize();
					ViewPortData vpData = new ViewPortData(vp.getProjection(), ex, imgSz );
					writer = new EcwWriter( ((IDataWriter)p), 
											vpData, 
											fName,
											sizeBlock,
											3, 
											compresion);
					//Si han sido modificadas las propiedades se asignan los valores modificados
					String[] prp = driverProps.getProperties("ecw"); 
					if(prp!=null)
						writer.setProps(prp);
					((EcwWriter)writer).dataWrite();
					((EcwWriter)writer).writeClose(); 
						
						
				}catch(IOException ev){
						ev.printStackTrace();
				}catch(es.gva.cit.jecwcompress.EcwException r){ 
						r.printStackTrace();
				}
				
			}else if (	fName.endsWith(".tif") || fName.endsWith(".jpg") || fName.endsWith(".jpeg")) {	
				//System.out.println("Salvando fichero "+fName+" a formato Tif");
				try{
					String drvName = null;
					String fJpegName = null;
					String drvJpegName = null;
					
					String end = fName.substring(fName.lastIndexOf("."), fName.length()); 
					if(end.equals(".tif"))
						drvName = "GTiff";
					
					if(end.equals(".jpg") || end.equals(".jpeg")){
						drvName = "GTiff";
						drvJpegName = "JPEG";
						fJpegName = fName;
						fName = fName.substring(0, fName.lastIndexOf("."))+".tif";
						maxPercentBarList = new double[2];
						maxPercentBarList[0] = 75D;
						maxPercentBarList[1] = 25D;
					}
					
					RasterizerLayer p = new RasterizerLayer(layers, vp, sizeBlock, mapCtrl);
					p.setProgressBar(window.getJProgressBar(),maxPercentBarList[0]);
					Extent ex = new Extent(vp.getAdjustedExtent());
					
				    writer = new GdalWriter( 	((IDataWriter)p), 
				    							dimension.width, 
												dimension.height, 
												fName, 
												ex.maxX(), 
												ex.minX(), 
												ex.maxY(), 
												ex.minY(), 
												3, 
												sizeBlock,
												drvName);
				    //Si han sido modificadas las propiedades se asignan los valores modificados
				    String[] prp = driverProps.getProperties("tif");
				    
				    if(prp!=null)
						writer.setProps(prp);

				    
					((GdalWriter)writer).dataWrite();
					((GdalWriter)writer).writeClose();
					
					//Barra de progreso de comprimir a Jpeg
					if(end.equals(".jpg") || end.equals(".jpeg")){
						
						CopyDataset copyDataset = new CopyDataset(	fName,
															fName.substring(0, fName.lastIndexOf("."))+".jpg",
															vp,
															prp,
															"JPEG",
															"jpg",
															window);
						copyDataset.setMaxPercentBar(maxPercentBarList[1]);
						//copyDataset.setPriority(Thread.MAX_PRIORITY);
						copyDataset.start();
						copyDataset.copy();
						new File(fName).delete();
					}
					
				}catch(IOException ev){
					ev.printStackTrace();
				}catch(es.gva.cit.jgdal.GdalException r){ 
					r.printStackTrace();
				}
				
			} else {
			    System.err.println("Extensin del fichero " + fName + " no soportada.");
			}
			PluginServices.getMDIManager().closeView(this.window);
		}
	}
	
	
	/**
	 * @author Nacho Brodin <brodin_ign@gva.es>
	 * 
	 * Esta clase copia un dataset desde disco en un formato soportado por Gdal
	 * a otro especificado.
	 */
	class CopyDataset extends Thread{
		
		private GdalDriver 					driver = null;
		private String 						fDstName = null;
		private String 						fSrcName = null;
		private ViewPort 					vp = null;
		private String[]					driverProps = null;
		private String 						extension = null;
		private double 						maxPercentBar = 0D;
		private boolean 					runCopy = false;
		private ProgressSaveRasterDialog	window = null;
		
		/**
		 * Constructor
		 * @param src	Nombre del fichero fuente
		 * @param dst	Nombre del fichero destino
		 * @param viewPort	Viewport
		 * @param dp	DriverProperties
		 * @param drvName	Nombre del driver de Gdal
		 * @param extens	Extensin del fichero
		 */
		CopyDataset(String src, 
					String dst, 
					ViewPort viewPort, 
					String[] dp,
					String drvName,
					String extens,
					ProgressSaveRasterDialog window){
			fSrcName = src;			
			fDstName = dst;
			vp = viewPort;
			this.window = window;
			this.driverProps = dp;
			this.extension = extens;
			try{
				driver = Gdal.getDriverByName(drvName);
			}catch(GdalException exc){
			    System.err.println("No se ha podido obtener el driver.");
			}
			runCopy = true;
		}
		
		/**
		 * Funcin que realiza la copia del dataset
		 */
		public void copy(){
			try{	
				GdalWriter.createCopy(	driver,
										fDstName, 
										fSrcName, 
										false, 
										driverProps,
										vp.getProjection());
			}catch(IOException ev){
				ev.printStackTrace();
			}catch(GdalException ev){
				ev.printStackTrace();
			}			
			runCopy = false;
		}
		
		/**
		 * El thread maneja el incremento de la barra
		 */
		public void run(){
			File f = new File(fSrcName);
			long sizeSrc = f.length();
			long sizeDst = 0;
			if(extension.equals("jpg"))
				sizeDst = (long)(sizeSrc * 0.085);
			double incrProgressBar = 0;
			int last = 0;
			
			String osname = System.getProperty("os.name").toLowerCase();
			if(osname.indexOf("windows")>=0){
				//Temporalmente hacemos esto en windows 
				long l1 = System.currentTimeMillis();
				long l2 = 0;
				while(runCopy){
					if((l2 - l1) > 1000){
						l1 = System.currentTimeMillis();
						window.getJProgressBar().setValue(window.getJProgressBar().getValue() + 1);
					}
					l2 = System.currentTimeMillis();
					try{
						Thread.sleep(10);
					}catch(InterruptedException exc){}
				}
			}else{
				while(runCopy){
					File fdst = new File(fDstName);
					incrProgressBar = (fdst.length() * maxPercentBar) / sizeDst;
					if(fdst.exists() && incrProgressBar < maxPercentBar){
						if(last != ((int)incrProgressBar)){
							window.getJProgressBar().setValue(window.getJProgressBar().getValue() + 1);
							//System.out.println(fdst.length()+" "+maxPercentBar+" "+sizeDst+"**>"+incrProgressBar);
						}
						last=(int)incrProgressBar;
					}
					try{
						Thread.sleep(10);
					}catch(InterruptedException exc){}
				}
			}
			window.getJProgressBar().setValue(100);
		}
		
		/**
		 * Asigna el porcentaje mximo a la barra
		 * @param max	Porcentaje mximo de la barra
		 */
		public void setMaxPercentBar(double max){
			this.maxPercentBar = max;
		}
	}
	
	/**
	 * Contructor 
	 * @param mapCtrl			MapControl
	 * @param layers			Capas a rasterizar
	 * @param currentProjection	Proyeccin 
	 * @param dimension			Dimensin del marco en pixeles
	 * @param ext				Extend de las capas a rasterizar
	 */
	public ProgressSaveRasterDialog(	MapControl mapCtrl, 
										FLayers layers, 
										IProjection currentProjection,
										Dimension dimension, 
										Rectangle2D ext){
		super();
		this.layers = layers;
		this.currentProjection = currentProjection;
		this.mapCtrl = mapCtrl;
		this.dimension = dimension;
		
		vp = new ViewPort(currentProjection);
		vp.setBackColor(mapCtrl.getViewPort().getBackColor());
		vp.setImageSize(dimension);
		vp.setExtent(ext);
		
		threadSave = new Save(this);
	}
	
	/**
	 * Asigna los textos a los paneles en el idioma seleccionado
	 */	
	private void setTranslation(){
		this.lwait.setText(PluginServices.getText(this,"espere"));
	}
	
	/**
	 * Asigna el objeto que contiene las propiedades
	 * @param driverProps
	 */
	public void setProps(DriverProperties driverProps){
		this.driverProps = driverProps;
	}
	
	/**
	 * Asigna el nombre del fichero
	 * @param fName	Nombre del fichero
	 */
	public void setFName(String fName){
		this.fName = fName;
	}
	
	/**
	 * Asigna el GeoRasterWriter que se usar para salvar
	 * @param writer
	 */
	public void setWriter(GeoRasterWriter writer){
		this.writer = writer;
	}
	
	/**
	 * Asigna el tamao de bloque que se lee de una sola vez desde el origen
	 * Esto influye en la velocidad de escritura y depende de la memoria que 
	 * tengamos disponible. Si disponemos de poca corremos el riesgo de que al
	 * asignar un bloque muy grande nos de un error
	 * @param sizeBlock Tamao de bloque
	 */
	public void setBlockSize(int sizeBlock){
		this.sizeBlock = sizeBlock;
	}
	
	/**
	 * Asigna la compresin si el formato dispone de este parmetro
	 * @param compresion Nivel de compresin
	 */
	public void setCompresion(int compresion){
		this.compresion = compresion;
	}
	
	/**
	 * Muestra la barra de incremento
	 *
	 */
	public void showWindow(){
		threadSave.start();
		PluginServices.getMDIManager().addView(this);
	}
		
	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo m_viewinfo=new ViewInfo(ViewInfo.MODALDIALOG);
    		m_viewinfo.setTitle(PluginServices.getText(this, "tarea_en_progreso"));
		return m_viewinfo;
	}
}


