/*
 * Created on 17-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.Panels;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.geom.Rectangle2D;

import org.cresques.cts.IProjection;
import org.cresques.io.EcwWriter;
import org.cresques.io.GdalWriter;
import org.cresques.io.GeoRasterWriter;
import org.cresques.ui.raster.DataInputSaveRaster;
import org.cresques.ui.raster.SaveRasterDialogPanel;
import org.cresques.ui.raster.SaveSetupPanel;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.View;
import com.iver.andami.ui.mdiManager.ViewInfo;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.layers.FLayers;

/**
 * Dialogo para abrir fichero.
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
//public class SaveRasterDialog extends JDialog{
public class SaveRasterDialog extends SaveRasterDialogPanel implements View {
	
	//private SaveRasterDialogPanel 		contentPane = null;  
	private GeoRasterWriter				writer=null;
	private GeoRasterWriter				writerProps=null;
	private IProjection 				currentProjection = null;
	private SaveRasterPropsDialog 		frameSaveRasterProps = null;
	private int 						compresion = 1;
	private int 						sizeBlock = 64;
	public DriverProperties				driverProps = null;
	private FLayers				 		layers = null;
	private MapControl					mapCtrl = null;
	 
	class DriverProperties{
		
		private String[][]				driversProps = null;
		private String[]				driversExtension = null;
		
		DriverProperties(){
			
			driversProps = new String[GeoRasterWriter.getNDrivers()][];
			for(int i=0;i<GeoRasterWriter.getNDrivers();i++)
				driversProps[i] = null;
			driversExtension = GeoRasterWriter.getDriversExtensions();
			
		}
		
		/**
		 * Asigna un vector de propiedades de driver de escritura.
		 * @param ext	extensin del driver.
		 * @param props	propiedades.
		 */
		public void setProperties(String ext, String[] props){
			for(int i=0;i<driversExtension.length;i++){
				if(ext.equals(driversExtension[i])){
					driversProps[i] = props;
				}
			}
		}
		
		/**
		 * Obtiene un vector de propiedades de driver de escritura.
		 * @param ext	extensin del driver.
		 * @return	propiedades.
		 */
		public String[] getProperties(String ext){
			for(int i=0;i<driversExtension.length;i++){
				if(ext.equals(driversExtension[i])){
					return driversProps[i];
				}
			}
			return null;
		}
		
	}
	
	/**
	 * Constructor de la ventana de dialogo.
	 *
	 */
	public SaveRasterDialog(FLayers layers, MapControl mapCtrl) {
		super();
		//super.setModal(true);
		driverProps = new DriverProperties();
		this.layers = layers;
		this.mapCtrl = mapCtrl;
		init();
		this.setTranslation();
	}
	
	/**
	 * Asigna los textos a los paneles
	 */
	public void setTranslation(){
		DataInputSaveRaster dInput = ((SaveSetupPanel)super.getContentPanel()).getSaveParameters();
		dInput.lSupIzq.setText(PluginServices.getText(this,"lsup_izq")+":");
		dInput.lInfDer.setText(PluginServices.getText(this,"linf_der")+":");
		dInput.lFile.setText(PluginServices.getText(this,"Fichero")+":");
		dInput.lResolucion.setText(PluginServices.getText(this,"resolucion"));
		dInput.lEscala.setText(PluginServices.getText(this,"escala")+" 1:");
		dInput.lPpp.setText(PluginServices.getText(this,"lppp"));
		dInput.bSeleccion.setText(PluginServices.getText(this,"Seleccionar"));
		dInput.lAncho.setText(PluginServices.getText(this,"ancho")+".");
		dInput.lAlto.setText(PluginServices.getText(this,"alto")+".");
		getAcceptButton().setText(PluginServices.getText(this, "aceptar"));
		getCancelButton().setText(PluginServices.getText(this, "cancelar"));
		
		String text = dInput.getBPropiedades().getText();
		dInput.getBPropiedades().setText(PluginServices.getText(this, "propiedades")+" "+text.substring(text.lastIndexOf(" ") + 1,text.length()));				
	}
	
	/**
	 * Inicializa el jDialog	
	 * 	
	 * @return javax.swing.JDialog	
	 */    
	private void init() {
		setBounds(0, 0, 386, 268);
		setName("saveRaster");
				
	 	this.getAcceptButton().setEnabled(false);
	 	this.getAcceptButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	acceptButtonActionPerformed(evt);
                closeJDialog();
            }
        });
	 	this.getCancelButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeJDialog();
            }
        });
	 	this.getApplyButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	acceptButtonActionPerformed(evt);
             }
        });
		
		//Captura de eventos para el botn de propiedades
		
		((SaveSetupPanel)this.getContentPanel()).getSaveParameters().getBPropiedades().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	propsButtonActionPerformed(evt);
             }
        });
		
	}
	
	
	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	public Container getContentPane() {
		return this;
	}
	
	/**
	 * 
	 * @param prj
	 */
	
	public void setProjection(IProjection prj) {
		this.currentProjection = prj;
	}
	
	/**
	 * Asigna el FLayers
	 * @param layers
	 */
	public void setLayerList(FLayers layers){
		this.layers = layers;
	}
	
		
	public void closeJDialog() {
		this.hide();
		for(int i=0;i<layers.getLayersCount();i++){
			layers.getLayer(i).getFMap().invalidate();
		}
		PluginServices.getMDIManager().closeView(SaveRasterDialog.this);
		//dlg.dispose();
	}
	
	private void propsButtonActionPerformed(ActionEvent e){
		DataInputSaveRaster dialog = (DataInputSaveRaster)((SaveSetupPanel)((SaveRasterDialogPanel)this.getContentPane()).getContentPanel()).getSaveParameters();
		if(dialog.getBPropiedades().getText().endsWith("Ecw")){
			writerProps = new EcwWriter();
			if(driverProps.getProperties("ecw")!=null){
				writerProps.setProps(driverProps.getProperties("ecw"));
			}
		}
				
		if(	dialog.getBPropiedades().getText().endsWith("GeoTiff") || 
			dialog.getBPropiedades().getText().endsWith("Jpeg")){
			writerProps = new GdalWriter("GTiff");
			if(driverProps.getProperties("tif")!=null){
				writerProps.setProps(driverProps.getProperties("tif"));
			}
		}
		
		if(dialog.getBPropiedades().getText().endsWith("Jp2")){
			writerProps = new EcwWriter();
			if(driverProps.getProperties("jp2")!=null){
				writerProps.setProps(driverProps.getProperties("jp2"));
			}
		}
		
		frameSaveRasterProps = new SaveRasterPropsDialog(writerProps);
		frameSaveRasterProps.setParentDialog(this);
		frameSaveRasterProps.show();
	}
	
	/**
	 * 
	 * @param e
	 */
    private void acceptButtonActionPerformed(ActionEvent e) {
    	DataInputSaveRaster dialog = (DataInputSaveRaster)((SaveSetupPanel)((SaveRasterDialogPanel)this.getContentPane()).getContentPanel()).getSaveParameters();
    	    	
		String fName = ((SaveSetupPanel)((SaveRasterDialogPanel)this.getContentPane()).getContentPanel()).getFileName();
		Dimension dimension = new Dimension(Integer.parseInt(dialog.getTancho().getText()), 
											Integer.parseInt(dialog.getTalto().getText()));
		
		double lrX = Double.parseDouble(dialog.getTinf_derX().getText());
		double lrY = Double.parseDouble(dialog.getTinf_derY().getText());
		double ulX = Double.parseDouble(dialog.getTsup_izqX().getText());
		double ulY = Double.parseDouble(dialog.getTsup_izqY().getText());
		double width = 0;
		if(ulX>lrX)width = (double)(ulX-lrX);
			else width = (double)(lrX-ulX);
		double height = 0;
		if(ulY>lrY)height = (double)(ulY-lrY);
			else height = (double)(lrY-ulY);
		Rectangle2D ext = null;
		
		if(ulY<lrY)
			ext = new Rectangle2D.Double(ulX, ulY, width, height);
		else
			ext = new Rectangle2D.Double(ulX, lrY, width, height);
		
		ProgressSaveRasterDialog progressBar = new ProgressSaveRasterDialog(mapCtrl,
																			this.layers,
																			this.currentProjection,
																			dimension,
																			ext);
		
		progressBar.setProps(driverProps);
		progressBar.setWriter(writer);
		progressBar.setFName(fName);
		progressBar.setBlockSize(sizeBlock);
		progressBar.setCompresion(compresion);
		progressBar.showWindow();
		
		/*ViewPort vp = new ViewPort(this.currentProjection);
		vp.setBackColor(mapCtrl.getViewPort().getBackColor());
		vp.setImageSize(dimension);
		vp.setExtent(ext);		
		
		if (fName.endsWith(".ecw")) {
			//System.out.println("Salvando vista a fichero "+fName+" a formato Ecw");
			try{
			
				RasterizerLayer p = new RasterizerLayer(this.layers, vp, sizeBlock, mapCtrl);
				Extent ex = new Extent(vp.getAdjustedExtent());
				Dimension imgSz = vp.getImageSize();
				ViewPortData vpData = new ViewPortData(vp.getProjection(), ex, imgSz );
				writer = new EcwWriter( ((IDataWriter)p), 
										vpData, 
										fName,
										sizeBlock,
										3, 
										compresion);
				//Si han sido modificadas las propiedades se asignan los valores modificados
				String[] prp = driverProps.getProperties("ecw"); 
				if(prp!=null)
					writer.setProps(prp);
				((EcwWriter)writer).dataWrite();
				((EcwWriter)writer).writeClose(); 
					
					
			}catch(IOException ev){
					ev.printStackTrace();
			}catch(es.gva.cit.jecwcompress.EcwException r){ 
					r.printStackTrace();
			}
			
		}else if (fName.endsWith(".tif")) {	
			//System.out.println("Salvando fichero "+fName+" a formato Tif");
			try{
							
				RasterizerLayer p = new RasterizerLayer(this.layers, vp, sizeBlock, mapCtrl);
				Extent ex = new Extent(vp.getAdjustedExtent());
			    writer = new GdalWriter( 	((IDataWriter)p), 
			    							dimension.width, 
											dimension.height, 
											fName, 
											ex.maxX(), 
											ex.minX(), 
											ex.maxY(), 
											ex.minY(), 
											3, 
											sizeBlock,
											"GTiff");
			    //Si han sido modificadas las propiedades se asignan los valores modificados
			    String[] prp = driverProps.getProperties("tif");
			    if(prp!=null)
					writer.setProps(prp);
				((GdalWriter)writer).dataWrite();
				((GdalWriter)writer).writeClose();
			}catch(IOException ev){
				ev.printStackTrace();
			}catch(es.gva.cit.jgdal.GdalException r){ 
				r.printStackTrace();
			}
			
		} else {
		    System.err.println("Extensin del fichero " + fName + " no soportada.");
		}*/
		
		for(int i=0;i<layers.getLayersCount();i++){
			layers.getLayer(i).getFMap().invalidate();
		}
    }
    
	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo m_viewinfo=new ViewInfo(ViewInfo.MODALDIALOG);
    		m_viewinfo.setTitle(PluginServices.getText(this, "salvar_raster"));
		return m_viewinfo;
	}

}  
