/*
 * Creado el 7-marzo-2005
 */
package com.iver.cit.gvsig.gui.Panels;

import java.awt.Container;
import java.awt.event.ActionEvent;

import javax.swing.JDialog;

import org.cresques.cts.IProjection;
import org.cresques.io.CXMLParser;
import org.cresques.io.GeoRasterWriter;
import org.cresques.px.PxLayerList;
import org.cresques.ui.raster.SavePropsSetupPanel;
import org.cresques.ui.raster.SaveRasterPropsDialogPanel;

import com.iver.andami.PluginServices;

/**
 * Dialogo para abrir fichero.
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class SaveRasterPropsDialog extends JDialog {
	
	private SaveRasterPropsDialogPanel 	contentPane = null;  
	private GeoRasterWriter 			writer=null;
	private String 						formato = null;
	private IProjection 				currentProjection = null;
	private PxLayerList 				layerList = null;
	private int 						widthWindow=386;
	private int 						heightWindow=300;
	private String[]					properties = null;
	private SaveRasterDialog			parentDialog = null;
	
	/**
	 * Constructor
	 * @param writer
	 */
	public SaveRasterPropsDialog(GeoRasterWriter writer) {
		super();
		super.setModal(true);
		this.writer = writer;
		this.formato = writer.getIdent();
		//Obtenemos el tamao de la ventana del XML generado por el driver
		String xml = writer.getXMLPropertiesDialog();
		if(xml!=null){
			CXMLParser parser = new CXMLParser(xml);
			widthWindow = Integer.parseInt(parser.getAttr("window","sizex"));
			heightWindow = Integer.parseInt(parser.getAttr("window","sizey"));
		}
		initialize();
	}
	
	/**
	 * Inicializacin del dialogo	
	 * 	
	 * @return javax.swing.JDialog	
	 */    
	private void initialize() {
		setBounds(0, 0, widthWindow, heightWindow);  //Size Ventana
		setResizable(false);
		setName("saveRasterProps");
		setTitle(PluginServices.getText(this, "propiedades"));
		setContentPane(getContentPane());
		
		contentPane.getAcceptButton().setText(PluginServices.getText(this, "aceptar"));
		contentPane.getCancelButton().setText(PluginServices.getText(this, "cancelar"));
		
		contentPane.getAcceptButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	acceptButtonActionPerformed(evt);
                closeJDialog();
            }
        });
		contentPane.getCancelButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeJDialog();
            }
        });
		contentPane.getApplyButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	acceptButtonActionPerformed(evt);
             }
        });
		
	}
	
	/**
	 * Asigna el dialogo padre a una variable.
	 * @param parentDialog	Cuadro de dialogo padre.
	 */
	public void setParentDialog(SaveRasterDialog parentDialog){
		this.parentDialog = parentDialog;
	}
	
	/**
	 * Inicializa contenPane	
	 * @return Container	
	 */    
	public Container getContentPane() {
		if (contentPane == null) {
			contentPane = new SaveRasterPropsDialogPanel(writer); 
			//contentPane.addAncestorListener(this);
		}
		return contentPane;
	}
	
	/**
	 * Asigna la proyeccin
	 * @param prj Proyeccin
	 */
	
	public void setProjection(IProjection prj) {
		this.currentProjection = prj;
	}
	
	/**
	 * 
	 * @param layerList
	 */
	
	public void setLayerList(PxLayerList layerList){
		this.layerList = layerList;
	}
	
		
	public void closeJDialog() {
		this.hide();
	}
	
	
	/**
	 * Cuando se acepta se obtienen las propiedades seleccionadas
	 * @param e
	 */
    private void acceptButtonActionPerformed(ActionEvent e) {
    	if(((SavePropsSetupPanel)((SaveRasterPropsDialogPanel)this.getContentPane()).getContentPanel()).getProperties()!=null){            
    		properties = ((SavePropsSetupPanel)((SaveRasterPropsDialogPanel)this.getContentPane()).getContentPanel()).getProperties();
    		parentDialog.driverProps.setProperties(writer.getDriverName(), properties);
    	}	
    }
}  
