/*
 * Created on 02-ago-2004
 *
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.layout.fframes.dialogs;

import java.awt.geom.Rectangle2D;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.ViewInfo;
import com.iver.cit.gvsig.fmap.core.v02.FConstant;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameGraphics;
import com.iver.cit.gvsig.gui.thememanager.legendmanager.panels.FPanelLegendDefault;


/**
 * Dilogo de las propiedades de los grficos.
 *
 * @author Vicente Caballero Navarro
 */
public class FFrameGraphicsDialog extends FPanelLegendDefault
	implements IFFrameDialog {
	private Rectangle2D rect = new Rectangle2D.Double();
	private Layout m_layout = null; //  @jve:visual-info  decl-index=0 visual-constraint="393,10"
	private boolean isAcepted = false;
	private FFrameGraphics fframegraphics = null;
	private javax.swing.JButton bAceptar = null;
	private javax.swing.JButton bCancelar = null;
	private JPRotation pRotation = null;

	/**
	 * Crea un nuevo FFrameGraphicsDialog.
	 *
	 * @param layout Referencia al Layout.
	 * @param fframe Referencia al fframe de grfico.
	 */
	public FFrameGraphicsDialog(Layout layout, FFrameGraphics fframe) {
		m_layout = layout;
		fframegraphics = fframe;
		setFSymbol(fframegraphics.getFSymbol());
		//fillCheckBox.setSelected(false);

		initialize();
		if (getFSymbol().getSymbolType()==FConstant.SHAPE_TYPE_POINT){
			this.getJPanelPoint().setVisible(true);
		}else{
		this.getJPanelPoint().setVisible(false);
		}
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		this.add(getBAceptar(), null);
		this.add(getBCancelar(), null);
		this.setSize(582, 373);
		this.add(getPRotation(), null);
		getPRotation().setRotation(fframegraphics.getRotation());
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.SingletonView#getViewModel()
	 */
	public Object getViewModel() {
		return "FPanelLegendDefault";
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo m_viewinfo = new ViewInfo(ViewInfo.MODALDIALOG);
		m_viewinfo.setTitle(PluginServices.getText(this, "propiedades_grafico"));

		return m_viewinfo;
	}

	/**
	 * @see com.iver.cit.gvsig.gui.layout.fframes.dialogs.IFFrameDialog#setRectangle(java.awt.geom.Rectangle2D)
	 */
	public void setRectangle(Rectangle2D r) {
		rect.setRect(r);
	}

	/**
	 * @see com.iver.cit.gvsig.gui.layout.fframes.dialogs.IFFrameDialog#getIsAcepted()
	 */
	public boolean getIsAcepted() {
		return isAcepted;
	}

	/**
	 * This method initializes bAceptar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBAceptar() {
		if (bAceptar == null) {
			bAceptar = new javax.swing.JButton();
			bAceptar.setBounds(85, 326, 122, 28);
			bAceptar.setText(PluginServices.getText(this, "Aceptar"));
			bAceptar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						if (getFSymbol().getSymbolType() == FConstant.SYMBOL_TYPE_POINT) {
							updateControls(false); // Para que lo que haya en 
						}

						// ese momento en los controles pase al m_FSymbol
						///m_Renderer.setLegendType(FConstant.LEGEND_TYPE_DEFAULT);
						fframegraphics.setSize(Integer.parseInt(getJTextField().getText()));
						fframegraphics.setFSymbol(getFSymbol());
						fframegraphics.setRotation(getPRotation().getRotation());
						///m_Renderer.setDefaultSymbol(m_defaultLegendPanel.getFSymbol());
						PluginServices.getMDIManager().closeView(FFrameGraphicsDialog.this);
						m_layout.refresh();
						isAcepted = true;
					}
				});
		}

		return bAceptar;
	}

	/**
	 * This method initializes bCancelar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBCancelar() {
		if (bCancelar == null) {
			bCancelar = new javax.swing.JButton();
			bCancelar.setBounds(292, 326, 122, 28);
			bCancelar.setText(PluginServices.getText(this, "Cancelar"));
			bCancelar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						PluginServices.getMDIManager().closeView(FFrameGraphicsDialog.this);
					}
				});
		}

		return bCancelar;
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#viewActivated()
	 */
	public void viewActivated() {
	}

	/**
	 * This method initializes pRotation	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPRotation getPRotation() {
		if (pRotation == null) {
			pRotation = new JPRotation();
			pRotation.setBounds(415, 156, 120, 120);
		}
		return pRotation;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
