/*
 * Created on 02-jun-2004
 *
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.layout.fframes.dialogs;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.ViewInfo;

import com.iver.cit.gvsig.gui.Dialogs.FontChooser;
import com.iver.cit.gvsig.gui.layout.FLayoutUtilities;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameLegend;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameView;
import com.iver.cit.gvsig.gui.layout.fframes.IFFrame;
import com.iver.cit.gvsig.gui.layout.fframes.ListViewModel;

import java.awt.geom.Rectangle2D;

import javax.swing.JList;
import javax.swing.JPanel;


/**
 * Dialogo para aadir la leyenda de alguna vista al Layout.
 *
 * @author Vicente Caballero Navarro
 */
public class FFrameLegendDialog extends JPanel implements IFFrameDialog {
	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JLabel lMarcoVista = null;
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JLabel lVisualizacion = null;
	private javax.swing.JComboBox cbVisualizacion = null;
	private javax.swing.JLabel lCalidad = null;
	private javax.swing.JComboBox cbCalidad = null;
	private javax.swing.JButton bAceptar = null;
	private javax.swing.JButton bCancelar = null;
	private javax.swing.JList liVistas = null;
	private Rectangle2D rect = new Rectangle2D.Double();
	private Layout m_layout = null; //  @jve:visual-info  decl-index=0 visual-constraint="393,10"
	private FFrameLegend fframelegend = null; //new FFrameLegend();
	private boolean isAcepted = false;
	private javax.swing.JButton bFuente = null;
	private FFrameView fframeview = null;
	private JPRotation pRotation = null;

	/**
	 * This is the default constructor
	 *
	 * @param layout Referencia al Layout.
	 * @param fframe Referencia al FFrameLegend.
	 */
	public FFrameLegendDialog(Layout layout, FFrameLegend fframe) {
		super();
		m_layout = layout;
		fframelegend = fframe;
		initialize();
	}

	/**
	 * Inserta el rectngulo que ocupar el fframe de leyenda.
	 *
	 * @param r extent.
	 */
	public void setRectangle(Rectangle2D r) {
		rect.setRect(r);
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		this.setLayout(null);
		this.add(getJContentPane(), null);
		this.setSize(531, 175);
		getPRotation().setRotation(fframelegend.getRotation());
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getLMarcoVista(), null);
			jContentPane.add(getJScrollPane(), null);
			jContentPane.add(getLVisualizacion(), null);
			jContentPane.add(getCbVisualizacion(), null);
			jContentPane.add(getLCalidad(), null);
			jContentPane.add(getCbCalidad(), null);
			jContentPane.add(getBAceptar(), null);
			jContentPane.add(getBCancelar(), null);
			jContentPane.add(getBFuente(), null);
			jContentPane.setBounds(3, 1, 524, 171);
			jContentPane.add(getPRotation(), null);
		}

		return jContentPane;
	}

	/**
	 * This method initializes lMarcoVista
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLMarcoVista() {
		if (lMarcoVista == null) {
			lMarcoVista = new javax.swing.JLabel();
			lMarcoVista.setSize(156, 63);
			lMarcoVista.setText(PluginServices.getText(this, "marco_vista"));
			lMarcoVista.setLocation(5, 10);
		}

		return lMarcoVista;
	}

	/**
	 * This method initializes jScrollPane
	 *
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getLiVistas());
			jScrollPane.setSize(217, 65);
			jScrollPane.setPreferredSize(new java.awt.Dimension(70, 60));
			jScrollPane.setLocation(167, 10);
		}

		return jScrollPane;
	}

	/**
	 * This method initializes lVisualizacion
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLVisualizacion() {
		if (lVisualizacion == null) {
			lVisualizacion = new javax.swing.JLabel();
			lVisualizacion.setSize(99, 16);
			lVisualizacion.setText(PluginServices.getText(this, "visualizacion"));
			lVisualizacion.setLocation(6, 83);
		}

		return lVisualizacion;
	}

	/**
	 * This method initializes cbVisualizacion
	 *
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getCbVisualizacion() {
		if (cbVisualizacion == null) {
			cbVisualizacion = new javax.swing.JComboBox();
			cbVisualizacion.addItem(PluginServices.getText(this, "cuando_activo"));
			cbVisualizacion.addItem(PluginServices.getText(this, "siempre"));
			cbVisualizacion.setSelectedIndex(fframelegend.getViewing());
			cbVisualizacion.setSize(179, 20);
			cbVisualizacion.setPreferredSize(new java.awt.Dimension(200, 20));
			cbVisualizacion.setLocation(111, 83);
			cbVisualizacion.setEnabled(false);
		}

		return cbVisualizacion;
	}

	/**
	 * This method initializes lCalidad
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLCalidad() {
		if (lCalidad == null) {
			lCalidad = new javax.swing.JLabel();
			lCalidad.setSize(99, 16);
			lCalidad.setText(PluginServices.getText(this, "calidad"));
			lCalidad.setLocation(6, 103);
		}

		return lCalidad;
	}

	/**
	 * This method initializes cbCalidad
	 *
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getCbCalidad() {
		if (cbCalidad == null) {
			cbCalidad = new javax.swing.JComboBox();
			cbCalidad.addItem(PluginServices.getText(this, "presentacion"));
			cbCalidad.addItem(PluginServices.getText(this, "borrador"));
			cbCalidad.setSelectedIndex(fframelegend.getQuality());
			cbCalidad.setSize(179, 20);
			cbCalidad.setPreferredSize(new java.awt.Dimension(200, 20));
			cbCalidad.setLocation(111, 103);
		}

		return cbCalidad;
	}

	/**
	 * This method initializes bAceptar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBAceptar() {
		if (bAceptar == null) {
			bAceptar = new javax.swing.JButton();
			bAceptar.setSize(79, 26);
			bAceptar.setText(PluginServices.getText(this, "Aceptar"));
			bAceptar.setLocation(77, 129);
			bAceptar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						for (int i = 0; i < m_layout.getFFrames().size();
								i++) {
							IFFrame f = (IFFrame) m_layout.getFFrames().get(i);

							if (f instanceof FFrameView &&
									(fframeview != null)) {
								//if (f.getName().compareTo(m_projectView.getName())==0){
								//Esto cambia para que la escala se calcule en fframeview y no en fframescalebar.
								///	fframelegend.setFMap(((FFrameView)f).getFMap());
								fframelegend.setName("Leyenda de " +
									((FFrameView) f).toString());

								///fframescalebar.setScaleView(((FFrameView)f).getScale());
								//}
							}
						}

						/*if (m_projectView!=null){
						   fframelegend.setLayers(m_projectView.getMapContext().getLayers());
						   }
						 */
						fframelegend.setViewing(cbVisualizacion.getSelectedIndex());
						fframelegend.setQuality(cbCalidad.getSelectedIndex());
						fframelegend.setBoundBox(FLayoutUtilities.toSheetRect(
								rect, m_layout.getAT()));
						fframelegend.setRotation(getPRotation().getRotation());
						PluginServices.getMDIManager().closeView(FFrameLegendDialog.this);
						m_layout.refresh();
						isAcepted = true;
					}
				});
		}

		return bAceptar;
	}

	/**
	 * This method initializes bCancelar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBCancelar() {
		if (bCancelar == null) {
			bCancelar = new javax.swing.JButton();
			bCancelar.setSize(85, 26);
			bCancelar.setText(PluginServices.getText(this, "Cancelar"));
			bCancelar.setLocation(233, 129);
			bCancelar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						PluginServices.getMDIManager().closeView(FFrameLegendDialog.this);
					}
				});
		}

		return bCancelar;
	}

	/**
	 * This method initializes liVistas
	 *
	 * @return javax.swing.JList
	 */
	private javax.swing.JList getLiVistas() {
		if (liVistas == null) {
			ListViewModel listmodel = new ListViewModel();

			//listmodel.addViews();	
			listmodel.addViews(m_layout);

			///ArrayList list = listmodel.getViews();
			liVistas = new javax.swing.JList();
			liVistas.setModel(listmodel);

			for (int i = 0; i < liVistas.getModel().getSize(); i++) {
				if (fframelegend.getFFrameDependence() != null) {
					fframeview = (FFrameView) liVistas.getModel().getElementAt(i);

					if (fframeview == fframelegend.getFFrameDependence()) {
						liVistas.setSelectedIndex(i);
					}

					/*m_projectView=(ProjectView)liVistas.getModel().getElementAt(i);
					   if (m_projectView.getMapContext()==fframelegend.getFMap()){
					           liVistas.setSelectedIndex(i);
					   }
					 */
				}
			}

			liVistas.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
					private int selectIndex=-1;
					public void valueChanged(
						javax.swing.event.ListSelectionEvent e) {
						/*                        int selectInt=(int)e.getFirstIndex();
						   m_projectView=(ProjectView)liVistas.getModel().getElementAt(selectInt);
						 */
						int selectInt = (int) ((JList)e.getSource()).getSelectedIndex();
						if (selectInt!=selectIndex){
							selectIndex=selectInt;
						fframeview = (FFrameView) liVistas.getModel()
														  .getElementAt(selectInt);

						for (int i = 0; i < m_layout.getFFrames().size();
								i++) {
							IFFrame f = (IFFrame) m_layout.getFFrames().get(i);

							if (f instanceof FFrameView) {
								if (((FFrameView) f).getView() == fframeview.getView()) {
									fframelegend.setFFrameDependence(fframeview);
								}
							}
						}

						//fframelegend.setFFrameView(fframeview);
					}
					}
				});
		}

		return liVistas;
	}

	/* (non-Javadoc)
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo m_viewinfo = new ViewInfo(ViewInfo.MODALDIALOG);
		m_viewinfo.setTitle(PluginServices.getText(this,
				"propiedades_marco_leyenda"));

		return m_viewinfo;
	}

	/**
	 * @see com.iver.cit.gvsig.gui.layout.fframes.dialogs.IFFrameDialog#getIsAcepted()
	 */
	public boolean getIsAcepted() {
		return isAcepted;
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#viewActivated()
	 */
	public void viewActivated() {
	}

	/**
	 * This method initializes bFuente
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBFuente() {
		if (bFuente == null) {
			bFuente = new javax.swing.JButton();
			bFuente.setSize(90, 23);
			bFuente.setText(PluginServices.getText(this, "fuente"));
			bFuente.setLocation(297, 89);
			bFuente.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						if (fframelegend.getFont() != null) {
							fframelegend.setFont(FontChooser.showDialog(
									PluginServices.getText(this,
										"seleccion_fuente"),
									fframelegend.getFont())); // fchoser=new FontChooser();	
						} else {
							fframelegend.setFont(FontChooser.showDialog(
									PluginServices.getText(this,
										"seleccion_fuente"), getFont()));
						}
					}
				});
		}

		return bFuente;
	}

	/**
	 * This method initializes pRotation	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPRotation getPRotation() {
		if (pRotation == null) {
			pRotation = new JPRotation();
			pRotation.setBounds(400, 19, 120, 120);
		}
		return pRotation;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10" 