/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.selectionByTheme;

import java.util.ArrayList;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JPanel;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.View;
import com.iver.andami.ui.mdiManager.ViewInfo;
import com.iver.cit.gvsig.fmap.layers.FLayer;


public class SelectionByTheme extends JPanel implements View {
	public static final int EQUALS = 0;
	public static final int DISJOINT = 1;
	public static final int INTERSECTS = 2;
	public static final int TOUCHES = 3;
	public static final int CROSSES = 4;
	public static final int WITHIN = 5;
	public static final int CONTAINS = 6;
	public static final int OVERLAPS = 7;
	public final String[] textosAcciones = new String[] {
    PluginServices.getText(this, "Sean_iguales_a"), //"sean iguales a",
    PluginServices.getText(this, "Sean_disjuntos_a"), //"sean disjuntos a",
    PluginServices.getText(this, "Intersecten_con"), //"intersecten con",
    PluginServices.getText(this, "Toquen"), //"toquen",
    PluginServices.getText(this, "Crucen_con"), //"crucen con",
    PluginServices.getText(this, "Contengan"), //"contengan",
    PluginServices.getText(this, "Esten_contenidos_en"), //"estn contenidos en",
    PluginServices.getText(this, "Se_superponen_a"), //"se superponen a"
	};

	private SelectionByThemeModel dataSource = null;

	private ArrayList listeners = new ArrayList();

	private javax.swing.JPanel jPanel = null;
	private javax.swing.JPanel jPanel1 = null;
	private javax.swing.JLabel jLabel = null;
	private javax.swing.JComboBox cmbAction = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JComboBox cmbCapas = null;
	private javax.swing.JButton btnNew = null;
	private javax.swing.JButton btnAdd = null;
	private javax.swing.JButton btnFrom = null;
	private javax.swing.JButton btnCancel = null;
	/**
	 * This is the default constructor
	 */
	public SelectionByTheme() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		java.awt.FlowLayout layFlowLayout2 = new java.awt.FlowLayout();
		layFlowLayout2.setHgap(0);
		layFlowLayout2.setVgap(0);
		this.setLayout(layFlowLayout2);
		this.add(getJPanel(), null);
		this.add(getJPanel1(), null);
		this.setSize(440, 220);
	}
	/**
	 * This method initializes jPanel
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel() {
		if(jPanel == null) {
			jPanel = new javax.swing.JPanel();
			java.awt.FlowLayout layFlowLayout1 = new java.awt.FlowLayout();
			layFlowLayout1.setVgap(30);
			jPanel.setLayout(layFlowLayout1);
			jPanel.add(getJLabel(), null);
			jPanel.add(getCmbAction(), null);
			jPanel.add(getJLabel1(), null);
			jPanel.add(getCmbCapas(), null);
			jPanel.setPreferredSize(new java.awt.Dimension(290,220));
		}
		return jPanel;
	}
	/**
	 * This method initializes jPanel1
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJPanel1() {
		if(jPanel1 == null) {
			jPanel1 = new javax.swing.JPanel();
			java.awt.FlowLayout layFlowLayout3 = new java.awt.FlowLayout();
			layFlowLayout3.setVgap(25);
			jPanel1.setLayout(layFlowLayout3);
			jPanel1.add(getBtnNew(), null);
			jPanel1.add(getBtnAdd(), null);
			jPanel1.add(getBtnFrom(), null);
			jPanel1.add(getBtnCancel(), null);
			jPanel1.setPreferredSize(new java.awt.Dimension(140,220));
		}
		return jPanel1;
	}
	/**
	 * This method initializes jLabel
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel() {
		if(jLabel == null) {
			jLabel = new javax.swing.JLabel();
			jLabel.setText(PluginServices.getText(this, "Seleccionar_de_las_capas_activas_los_elementos_que") + "... ");
			jLabel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 10));
		}
		return jLabel;
	}
	/**
	 * This method initializes cmbAction
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getCmbAction() {
		if(cmbAction == null) {
			cmbAction = new javax.swing.JComboBox();
			cmbAction.setPreferredSize(new java.awt.Dimension(200,20));
			DefaultComboBoxModel model = new DefaultComboBoxModel(textosAcciones);
			cmbAction.setModel(model);
			cmbAction.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 10));
		}
		return cmbAction;
	}
	/**
	 * This method initializes jLabel1
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getJLabel1() {
		if(jLabel1 == null) {
			jLabel1 = new javax.swing.JLabel();
			jLabel1.setText(PluginServices.getText(this, "Elementos_seleccionados_de_la_capa"));
			jLabel1.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 10));
		}
		return jLabel1;
	}
	/**
	 * This method initializes cmbCapas
	 * 
	 * @return javax.swing.JComboBox
	 */
	private javax.swing.JComboBox getCmbCapas() {
		if(cmbCapas == null) {
			cmbCapas = new javax.swing.JComboBox();
			cmbCapas.setPreferredSize(new java.awt.Dimension(200,20));
			cmbCapas.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 10));
		}
		return cmbCapas;
	}
	/**
	 * This method initializes btnNew
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBtnNew() {
		if(btnNew == null) {
			btnNew = new javax.swing.JButton();
			btnNew.setText(PluginServices.getText(this, "Nuevo_conjunto"));
			btnNew.setMargin(new java.awt.Insets(2,2,2,2));
			btnNew.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 10));
			btnNew.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					callNewListeners(cmbCapas.getSelectedIndex(), cmbAction.getSelectedIndex());
				}
			});
		}
		return btnNew;
	}
	/**
	 * This method initializes btnAdd
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBtnAdd() {
		if(btnAdd == null) {
			btnAdd = new javax.swing.JButton();
			btnAdd.setText(PluginServices.getText(this, "Anadir_al_conjunto"));
			btnAdd.setMargin(new java.awt.Insets(2,2,2,2));
			btnAdd.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 10));
			btnAdd.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					callAddToListeners(cmbCapas.getSelectedIndex(), cmbAction.getSelectedIndex());
				}
			});
		}
		return btnAdd;
	}
	/**
	 * This method initializes btnFrom
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBtnFrom() {
		if(btnFrom == null) {
			btnFrom = new javax.swing.JButton();
			btnFrom.setText(PluginServices.getText(this, "Seleccionar_del_conjunto"));
			btnFrom.setMargin(new java.awt.Insets(2,2,2,2));
			btnFrom.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 10));
			btnFrom.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					callFromListeners(cmbCapas.getSelectedIndex(), cmbAction.getSelectedIndex());
				}
			});
		}
		return btnFrom;
	}
	/**
	 * This method initializes btnCancel
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBtnCancel() {
		if(btnCancel == null) {
			btnCancel = new javax.swing.JButton();
			btnCancel.setText(PluginServices.getText(this, "Cancel"));
			btnCancel.setMargin(new java.awt.Insets(2,2,2,2));
			btnCancel.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 10));
			btnCancel.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					PluginServices.getMDIManager().closeView(SelectionByTheme.this);
				}
			});
		}
		return btnCancel;
	}
	
	/**
	 * @return
	 */
	public SelectionByThemeModel getModel() {
		return dataSource;
	}

	/**
	 * @param source
	 */
	public void setModel(SelectionByThemeModel source) {
		dataSource = source;
		String[] nameLayers = new String[dataSource.getLayers().getLayersCount()];
		for (int i=0; i < nameLayers.length; i++)
			nameLayers[i] = dataSource.getLayers().getLayer(i).getName();
		DefaultComboBoxModel model = 
			new DefaultComboBoxModel(nameLayers);
		cmbCapas.setModel(model);
	}
	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo vi = new ViewInfo(ViewInfo.MODALDIALOG);
		return vi;
	}
	
	private void callNewListeners(int selection, int actionCode){
		for (int i = 0; i < listeners.size();
				i++) {
			SelectionByThemeListener l = (SelectionByThemeListener) listeners.get(i);
			l.newSet(dataSource.getLayers().getActives(), dataSource.getLayers().getLayer(selection), actionCode);
		}
		
	}
	
	private void callAddToListeners(int selection, int actionCode){
		for (int i = 0; i < listeners.size();
				i++) {
			SelectionByThemeListener l = (SelectionByThemeListener) listeners.get(i);
			l.addToSet(dataSource.getLayers().getActives(), dataSource.getLayers().getLayer(selection), actionCode);
		}
		
	}
	
	private void callFromListeners(int selection, int actionCode){
		for (int i = 0; i < listeners.size();
				i++) {
			SelectionByThemeListener l = (SelectionByThemeListener) listeners.get(i);
			l.fromSet(dataSource.getLayers().getActives(), dataSource.getLayers().getLayer(selection), actionCode);
		}
		
	}
	
	/**
	 * DOCUMENT ME!
	 *
	 * @param arg0
	 *
	 * @return
	 */
	public boolean addSelectionListener(SelectionByThemeListener arg0) {
		return listeners.add(arg0);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param arg0
	 *
	 * @return
	 */
	public boolean removeSelectionListener(SelectionByThemeListener arg0) {
		return listeners.remove(arg0);
	}
	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#viewActivated()
	 */
	public void viewActivated() {
	}
	
}  //  @jve:visual-info  decl-index=0 visual-constraint="10,10"
