package com.iver.cit.gvsig.gui.thememanager.legendmanager.panels;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.Messages;

import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.layerOperations.Classifiable;
import com.iver.cit.gvsig.fmap.rendering.Legend;
import com.iver.cit.gvsig.fmap.rendering.VectorialLegend;

import javax.swing.JOptionPane;
import javax.swing.JPanel;


/**
 * Clase utilizada para reutilizar mtodos.
 *
 * @author Vicente Caballero Navarro
 */
public abstract class AbstractPanel extends JPanel {
	/**
	 * Cuando hay varios temas vectoriales seleccionados, devolver el ltimo.
	 *
	 * @param layers Grupo de layers.
	 *
	 * @return la primera flayer seleccionada.
	 */
	protected FLayer getFirstActiveLayerVect(FLayers layers) {
		// Comprobar en openLegendManager que hay algn tema activo!
		FLayer[] activeLyrs = layers.getActives();

		if (activeLyrs.length == 0) {
			JOptionPane.showMessageDialog(null,
				Messages.getString("necesita_un_tema_activo"), "",
				JOptionPane.ERROR_MESSAGE);

			return null;
		}

		FLayer lyr = null;

		for (int i = 0; i < activeLyrs.length; i++) {
			if (activeLyrs[i] instanceof FLayers) {
				lyr = getFirstActiveLayerVect((FLayers) activeLyrs[i]);
			}

			if (activeLyrs[i] instanceof Classifiable) {
				Classifiable auxC = (Classifiable) activeLyrs[i];
				Legend theLegend = auxC.getLegend();

				if (theLegend instanceof VectorialLegend) {
					lyr = (FLayer) auxC;
				}
			}
		}

		if (lyr == null) {
			System.out.println(PluginServices.getText(this,
					"Por_favor_active_el_tema") + ".");
			JOptionPane.showMessageDialog(null,
				Messages.getString(PluginServices.getText(this,
						"necesita_un_tema_vectorial_activo")), "",
				JOptionPane.ERROR_MESSAGE);

			return null;
		}

		return lyr;
	}
}
