/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.toolListeners;

import java.awt.Point;
import java.awt.geom.Point2D;

import org.cresques.cts.IProjection;
import org.cresques.ui.raster.DataInputSaveRaster;
import org.cresques.ui.raster.SaveRasterDialogPanel;
import org.cresques.ui.raster.SaveSetupPanel;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.FMap;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.fmap.tools.SaveRasterListenerImpl;
import com.iver.cit.gvsig.fmap.tools.Events.RectangleEvent;
import com.iver.cit.gvsig.gui.View;
import com.iver.cit.gvsig.gui.Panels.SaveRasterDialog;


/**
 * Extensin de la clase SaveRasterListenerImpl de FMap para poder llamar a mtodos
 * de andami o de gvSIG.
 *
 * @author Nacho Brodin <brodin_ign@gva.es>
 */
public class SaveRasterListener extends SaveRasterListenerImpl {
	
	FLyrRaster 			layer = null;
	
	public SaveRasterListener(MapControl mapCtrl) {
		super(mapCtrl);
	}
		
	/**
	 * 
	 * @param flyr
	 */
	public void  setRasterLayer(FLyrRaster flyr){
		layer = flyr;
	}
	
	public void rectangle(RectangleEvent event) {
		super.rectangle(event);
				
		if (PluginServices.getMainFrame() != null)
		    PluginServices.getMainFrame().enableControls();
		
		FLayers layers = mapCtrl.getMapContext().getLayers();
		
		SaveRasterDialog saveRaster = new SaveRasterDialog(layers, mapCtrl);
		
		ViewPort vp = mapCtrl.getViewPort();
		Point2D ini = vp.fromMapPoint(rect.getMinX(), rect.getMinY());
		Point2D fin = vp.fromMapPoint(rect.getMaxX(), rect.getMaxY());
		if(Math.abs(fin.getY()-ini.getY())>10 && Math.abs(fin.getX()-ini.getX())>10){						
			saveRaster.setProjection(((View) PluginServices.getMDIManager().getActiveView()).getProjection());
			
			DataInputSaveRaster dialog = ((SaveSetupPanel)(((SaveRasterDialogPanel)saveRaster.getContentPane()).getContentPanel())).getSaveParameters();
			dialog.setProjection(vp.getProjection());
			dialog.setWidthInPixelsGeodesicas((int)Math.abs(fin.getX()-ini.getX()));
			dialog.setHeightInPixelsGeodesicas((int)Math.abs(fin.getY()-ini.getY()));
					
			int indexPoint = String.valueOf(rect.getMaxX()).indexOf('.');
			dialog.getTinf_derX().setText(String.valueOf(rect.getMaxX()).substring(0,indexPoint+2));
			indexPoint = String.valueOf(rect.getMaxY()).indexOf('.');
			dialog.getTinf_derY().setText(String.valueOf(rect.getMinY()).substring(0,indexPoint+2));
			indexPoint = String.valueOf(rect.getMinX()).indexOf('.');
			dialog.getTsup_izqX().setText(String.valueOf(rect.getMinX()).substring(0,indexPoint+2));
			indexPoint = String.valueOf(rect.getMinY()).indexOf('.');
			dialog.getTsup_izqY().setText(String.valueOf(rect.getMaxY()).substring(0,indexPoint+2));
						
			PluginServices.getMDIManager().addView(saveRaster);
		}
		
		
	}
}
