/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.project;

import com.hardcode.gdbms.engine.data.driver.DriverException;

import com.iver.cit.gvsig.fmap.layers.XMLException;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.project.OpenException;
import com.iver.cit.gvsig.gui.project.SaveException;

import com.iver.utiles.XMLEntity;

import java.text.DateFormat;

import java.util.Date;


/**
 * DOCUMENT ME!
 *
 * @author Fernando Gonzlez Corts
 */
public class ProjectMap extends ProjectElement {
	public static int numMaps = 0;
	private Layout model;

	/**
	 * DOCUMENT ME!
	 *
	 * @param baseName DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public static ProjectMap createMap(String baseName) {
		ProjectMap m = new ProjectMap();
		m.setName(baseName + " - " + numMaps);
		m.setCreationDate(DateFormat.getInstance().format(new Date()));
		numMaps++;

		return m;
	}

	/**
	 * @see com.iver.cit.gvsig.project.ProjectMap#getModel()
	 */
	public Layout getModel() {
		return model;
	}

	/**
	 * @see com.iver.cit.gvsig.project.ProjectMap#setMapContext(com.iver.cit.gvsig.project.castor.XMLEntity)
	 */
	public void setModel(Layout f) {
		model = f;
		f.setName(getName());
	}

	/**
	 * @see com.iver.cit.gvsig.project.ProjectElement#setName(java.lang.String)
	 */
	public void setName(String string) {
		super.setName(string);

		Layout m = getModel();

		if (m != null) {
			m.setName(string);
		}
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 * @throws SaveException 
	 * @throws XMLException
	 *
	 * @throws DriverException
	 */
	public XMLEntity getXMLEntity() throws SaveException   {
		XMLEntity xml = super.getXMLEntity();
		try{
		//xml.putProperty("nameClass", this.getClass().getName());
		xml.putProperty("numMaps", numMaps);
		xml.addChild(model.getXMLEntity());
		}catch (Exception e) {
			throw new SaveException(e,this.getClass().getName());
		}
		return xml;
	}

	/**
	 * @throws OpenException 
	 * @see com.iver.cit.gvsig.project.ProjectElement#setXMLEntity(com.iver.utiles.XMLEntity)
	 */
	public void setXMLEntity(XMLEntity xml, Project p) throws OpenException {
		try {
			numMaps = xml.getIntProperty("numMaps");
			model = Layout.createLayout(xml.getChild(0),p);
		} catch (Exception e) {
			throw new OpenException(e,this.getClass().getName());
		}
	}

	/**
	 * @see com.iver.cit.gvsig.project.ProjectElement#setXMLEntity(com.iver.utiles.XMLEntity)
	 */
	public void setXMLEntity03(XMLEntity xml, Project p) {
		numMaps = xml.getIntProperty("numMaps");
		model = Layout.createLayout03(xml.getChild(0), p);
	}
}
