package com.iver.cit.gvsig.jdbc_spatial.gui.jdbcwizard;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.View;
import com.iver.utiles.swing.wizard.Step;
import com.iver.utiles.swing.wizard.WizardControl;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Rectangle2D;

import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;


import javax.swing.JButton;
/**
 * DOCUMENT ME!
 *
 * @author Fernando Gonzlez Corts
 */
public class DBLayerDefinitionPanel extends JPanel implements Step {
    private JList lstTables = null;
    private JLabel jLabel = null;
    private JPanel pnlExtent = null;
    private JLabel jLabel1 = null;
    private JTextField txtMinX = null;
    private JLabel jLabel2 = null;
    private JTextField txtMaxX = null;
    private JLabel jLabel3 = null;
    private JTextField txtMinY = null;
    private JLabel jLabel4 = null;
    private JTextField txtMaxY = null;
    private DefaultListModel lstTablesModel = new DefaultListModel();
    private JRadioButton radFullTable = null;
    private JRadioButton radWorkingArea = null;
    private boolean advanced = false;
    private JScrollPane jScrollPane = null;
    private JPanel jPanel = null;
    private JTextField txtLayerName = null;
    private JPanel jPanel1 = null;
    private JLabel jLabel5 = null;

	private JButton jButton = null;
    /**
     * This is the default constructor
     */
    public DBLayerDefinitionPanel() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     */
    private void initialize() {
        jLabel = new JLabel();
        this.setLayout(null);
        this.setSize(509, 271);
        this.setPreferredSize(new java.awt.Dimension(1260, 180));
        jLabel.setText(PluginServices.getText(this, "seleccione_tabla") + ":");
        jLabel.setPreferredSize(new java.awt.Dimension(330, 15));
        jLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel.setBounds(15, 8, 330, 15);
        jLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        this.add(getJPanel1(), null);
        this.add(getJButton(), null);
        this.add(getPnlExtent(), null);
        this.add(getJPanel(), null);
        this.add(getJScrollPane(), null);
        this.add(jLabel, null);
        ButtonGroup bt = new ButtonGroup();
        bt.add(getRadFullTable());
        bt.add(getRadWorkingArea());
        enableExtent(false);
    }

    /**
     * This method initializes lstTables
     *
     * @return javax.swing.JList
     */
    private JList getLstTables() {
        if (lstTables == null) {
            lstTables = new JList();
            lstTables.setModel(lstTablesModel);
            lstTables.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
            lstTables.addListSelectionListener(new javax.swing.event.ListSelectionListener() { 
            	public void valueChanged(javax.swing.event.ListSelectionEvent e) {    
                    String aux = (String) lstTables.getSelectedValue();
                    getTxtLayerName().setText(aux);
            	}
            });
        }

        return lstTables;
    }

    /**
     * This method initializes pnlExtent
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnlExtent() {
        if (pnlExtent == null) {
            jLabel4 = new JLabel();
            jLabel3 = new JLabel();
            jLabel2 = new JLabel();
            jLabel1 = new JLabel();
            pnlExtent = new JPanel();
            pnlExtent.setLayout(null);
            pnlExtent.setPreferredSize(new java.awt.Dimension(400,60));
            jLabel1.setText(PluginServices.getText(this, "minx:"));
            jLabel1.setBounds(9, 25, 50, 15);
            jLabel2.setText(PluginServices.getText(this, "maxx:"));
            jLabel2.setBounds(9, 80, 50, 15);
            jLabel3.setText(PluginServices.getText(this, "miny:"));
            jLabel3.setBounds(9, 48, 50, 15);
            jLabel4.setText(PluginServices.getText(this, "maxy:"));
            jLabel4.setBounds(9, 103, 50, 15);
            pnlExtent.setBounds(300, 118, 194, 131);
            String strWorkingArea = PluginServices.getText(this,"area_trabajo");
            pnlExtent.setBorder(javax.swing.BorderFactory.createTitledBorder(null, strWorkingArea, javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
            pnlExtent.add(getTxtMaxY(), null);
            pnlExtent.add(jLabel4, null);
            pnlExtent.add(getTxtMinY(), null);
            pnlExtent.add(jLabel3, null);
            pnlExtent.add(getTxtMaxX(), null);
            pnlExtent.add(jLabel2, null);
            pnlExtent.add(getTxtMinX(), null);
            pnlExtent.add(jLabel1, null);
        }

        return pnlExtent;
    }

    /**
     * This method initializes txtMinX
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtMinX() {
        if (txtMinX == null) {
            txtMinX = new JTextField();
            txtMinX.setPreferredSize(new java.awt.Dimension(100, 19));
            txtMinX.setBounds(65, 21, 118, 19);
        }

        return txtMinX;
    }

    /**
     * This method initializes txtMaxX
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtMaxX() {
        if (txtMaxX == null) {
            txtMaxX = new JTextField();
            txtMaxX.setPreferredSize(new java.awt.Dimension(100, 19));
            txtMaxX.setBounds(65, 76, 118, 19);
        }

        return txtMaxX;
    }

    /**
     * This method initializes txtMinY
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtMinY() {
        if (txtMinY == null) {
            txtMinY = new JTextField();
            txtMinY.setPreferredSize(new java.awt.Dimension(100, 19));
            txtMinY.setBounds(65, 44, 118, 19);
        }

        return txtMinY;
    }

    /**
     * This method initializes txtMaxY
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtMaxY() {
        if (txtMaxY == null) {
            txtMaxY = new JTextField();
            txtMaxY.setPreferredSize(new java.awt.Dimension(100, 19));
            txtMaxY.setBounds(65, 99, 118, 19);
        }

        return txtMaxY;
    }

    /**
     * DOCUMENT ME!
     *
     * @param tables DOCUMENT ME!
     */
    public void setTables(String[] tables) {
        lstTablesModel = new DefaultListModel();

        for (int i = 0; i < tables.length; i++) {
            lstTablesModel.addElement(tables[i]);
        }

        getLstTables().setModel(lstTablesModel);
    }

    /**
     * DOCUMENT ME!
     *
     * @param rect DOCUMENT ME!
     */
    public void setExtent(Rectangle2D rect) {
        getTxtMinX().setText(String.valueOf(rect.getMinX()));
        getTxtMinY().setText(String.valueOf(rect.getMinY()));
        getTxtMaxX().setText(String.valueOf(rect.getMaxX()));
        getTxtMaxY().setText(String.valueOf(rect.getMaxY()));
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public Rectangle2D getExtent() {
        if (getRadFullTable().isSelected()) {
            return null;
        } else {
            return new Rectangle2D.Double(Double.parseDouble(
                    getTxtMinX().getText()),
                Double.parseDouble(getTxtMinY().getText()),
                Double.parseDouble(getTxtMaxX().getText()) -
                Double.parseDouble(getTxtMinX().getText()),
                Double.parseDouble(getTxtMaxY().getText()) -
                Double.parseDouble(getTxtMinY().getText()));
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean done() {
        boolean done = (getTable() != null) && (!getLayerName().trim().equals(""));

        if (getRadWorkingArea().isSelected()) {
            done = done && (getTxtMaxX().getText().length() > 0) &&
                (getTxtMaxY().getText().length() > 0) &&
                (getTxtMinX().getText().length() > 0) &&
                (getTxtMinY().getText().length() > 0);
        }

        return done;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getTable() {
        return (String) getLstTables().getSelectedValue();
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getLayerName() {
        return (String) getTxtLayerName().getText();
    }
    
    public String getWhere(){
        throw new UnsupportedOperationException();
    }

    /**
     * This method initializes radFullTable
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRadFullTable() {
        if (radFullTable == null) {
            radFullTable = new JRadioButton();
            radFullTable.setText(PluginServices.getText(this, "toda_la_tabla")+":");
            radFullTable.setSelected(true);
            radFullTable.setPreferredSize(new java.awt.Dimension(189,23));
            radFullTable.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        enableExtent(radWorkingArea.isSelected());
                    }
                });
        }

        return radFullTable;
    }

    /**
     * DOCUMENT ME!
     *
     * @param enable DOCUMENT ME!
     */
    private void enableExtent(boolean enable) {
        for (int i = 0; i < pnlExtent.getComponentCount(); i++) {
            pnlExtent.getComponent(i).setEnabled(enable);
        }
        getJButton().setEnabled(enable);
    }

    /**
     * This method initializes radWorkingArea
     *
     * @return javax.swing.JRadioButton
     */
    private JRadioButton getRadWorkingArea() {
        if (radWorkingArea == null) {
            radWorkingArea = new JRadioButton();
            radWorkingArea.setText(PluginServices.getText(this, "area_trabajo")+":");
            radWorkingArea.setPreferredSize(new java.awt.Dimension(189,23));
            radWorkingArea.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        enableExtent(radWorkingArea.isSelected());
                    }
                });
        }

        return radWorkingArea;
    }

    /**
     * This method initializes jScrollPane
     *
     * @return javax.swing.JScrollPane
     */
    private JScrollPane getJScrollPane() {
        if (jScrollPane == null) {
            jScrollPane = new JScrollPane();
            jScrollPane.setBounds(18, 25, 270, 193);
            jScrollPane.setViewportView(getLstTables());
            jScrollPane.setPreferredSize(new java.awt.Dimension(270, 110));
        }

        return jScrollPane;
    }

    /**
     * @see com.iver.utiles.swing.wizard.Step#init(com.iver.utiles.swing.wizard.WizardControl)
     */
    public void init(WizardControl w) {
    }

    /**
     * This method initializes jPanel
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel() {
        if (jPanel == null) {
            jPanel = new JPanel();
            jPanel.setBounds(295, 26, 197, 55);
            jPanel.add(getRadFullTable(), null);
            jPanel.add(getRadWorkingArea(), null);
            
        }

        return jPanel;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    private JTextField getTxtLayerName() {
        if (txtLayerName == null) {
            txtLayerName = new JTextField();
            txtLayerName.setPreferredSize(new java.awt.Dimension(100, 19));
            txtLayerName.setBounds(120, 5, 149, 19);
        }

        return txtLayerName;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel1() {
        if (jPanel1 == null) {
            jLabel5 = new JLabel();
            jPanel1 = new JPanel();
            jLabel5.setText(PluginServices.getText(this, "nombre_capa")+":");
            jLabel5.setBounds(3, 7, 106, 15);
            jPanel1.setLayout(null);
            jPanel1.setPreferredSize(new java.awt.Dimension(383,29));
            jPanel1.setBounds(19, 223, 278, 29);
            jPanel1.add(getTxtLayerName(), null);
            jPanel1.add(jLabel5, null);
        }

        return jPanel1;
    }

    /**
     * @return
     */
    public Rectangle2D getWorkingArea() {
        if (getRadWorkingArea().isSelected()) {
            return new Rectangle2D.Double(
                    Double.parseDouble(getTxtMinX().getText()),
                    Double.parseDouble(getTxtMinY().getText()),
                    Double.parseDouble(getTxtMaxX().getText()) - Double.parseDouble(getTxtMinX().getText()),
                    Double.parseDouble(getTxtMaxY().getText()) - Double.parseDouble(getTxtMinY().getText())
                    );
        }else{
            return null;
        }
    }
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText(PluginServices.getText(this, "importar_extent")+":");
			jButton.setBounds(297, 86, 196, 27);
			jButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    View v = PluginServices.getMDIManager().getActiveView();
                    com.iver.cit.gvsig.gui.View vista = (com.iver.cit.gvsig.gui.View) v;
                    Rectangle2D r = vista.getModel().getMapContext().getViewPort().getAdjustedExtent();
                    if (r == null)
                    {
                        JOptionPane.showMessageDialog(null,PluginServices.getText(this, "aviso_sin_extent_de_referencia"));
                        return;
                    }
                    
                    getTxtMinX().setText(Double.toString(r.getMinX()));
                    getTxtMinY().setText(Double.toString(r.getMinY()));
                    getTxtMaxX().setText(Double.toString(r.getMaxX()));
                    getTxtMaxY().setText(Double.toString(r.getMaxY()));
                }
            });
		}
		return jButton;
	}
 } //  @jve:decl-index=0:visual-constraint="10,10"
