package com.iver.cit.gvsig.jdbc_spatial.gui.jdbcwizard;

import javax.swing.JPanel;

import javax.swing.DefaultListModel;
import javax.swing.JScrollPane;
import javax.swing.JList;
import javax.swing.JLabel;

import com.iver.andami.PluginServices;
import com.iver.utiles.swing.wizard.Step;
import com.iver.utiles.swing.wizard.WizardControl;
import javax.swing.JButton;
import java.awt.CardLayout;
import java.awt.GridLayout;
import javax.swing.BoxLayout;
import java.awt.BorderLayout;
/**
 * @author Fernando Gonzlez Corts
 */
public class FieldSelection extends JPanel implements Step{

	private JScrollPane jScrollPane = null;
	private JList lstCampos = null;
	private DefaultListModel lstFieldsModel;
	private JLabel jLabel = null;
	private JPanel jPanel = null;
	private JButton jButton = null;
	private JButton jButton1 = null;
    private JPanel jPanel1 = null;  //  @jve:decl-index=0:visual-constraint="326,146"
    private JPanel jPanel2 = null;  //  @jve:decl-index=0:visual-constraint="340,183"
	
	/**
	 * This is the default constructor
	 */
	public FieldSelection() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		jLabel = new JLabel();
		this.setLayout(new BorderLayout());
		this.setSize(300, 261);
		jLabel.setText(PluginServices.getText(this, "seleccion_de_campos") + ":");
		jLabel.setPreferredSize(new java.awt.Dimension(352,15));
		jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jLabel.setName("jLabel");
		this.add(getJPanel2(), java.awt.BorderLayout.WEST);
		this.add(getJPanel1(), java.awt.BorderLayout.EAST);
		this.add(getJPanel(), java.awt.BorderLayout.SOUTH);
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		this.add(jLabel, java.awt.BorderLayout.NORTH);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param fields DOCUMENT ME!
	 */
	public void setFields(String[] fields) {
		lstFieldsModel = new DefaultListModel();

		for (int i = 0; i < fields.length; i++) {
			lstFieldsModel.addElement(fields[i]);
		}

		getLstCampos().setModel(lstFieldsModel);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public String[] getFields() {
		Object[] selection = getLstCampos().getSelectedValues();
		String[] ret = new String[selection.length];
		for (int i = 0; i < selection.length; i++) {
			ret[i] = (String) selection[i];
		}
			
		return ret;
	}
	
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setPreferredSize(new java.awt.Dimension(200,140));
			jScrollPane.setName("jScrollPane");
			jScrollPane.setViewportView(getLstCampos());
		}
		return jScrollPane;
	}
	/**
	 * This method initializes lstCampos	
	 * 	
	 * @return javax.swing.JList	
	 */    
	private JList getLstCampos() {
		if (lstCampos == null) {
			lstCampos = new JList();
		}
		return lstCampos;
	}
	/**
	 * @see com.iver.utiles.swing.wizard.Step#init(com.iver.utiles.swing.wizard.WizardControl)
	 */
	public void init(WizardControl w) {
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setPreferredSize(new java.awt.Dimension(350,25));
			jPanel.setName("jPanel");
			jPanel.add(getJButton(), null);
			jPanel.add(getJButton1(), null);
		}
		return jPanel;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setText(PluginServices.getText(this, "select_all"));
			jButton.setPreferredSize(new java.awt.Dimension(140,18));
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int[] indices = new int[lstCampos.getModel().getSize()];
					for (int i = 0; i < indices.length; i++) {
						indices[i] = i;
					}
					lstCampos.setSelectedIndices(indices);
				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setText(PluginServices.getText(this, "select_none"));
			jButton1.setPreferredSize(new java.awt.Dimension(140,18));
			jButton1.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					lstCampos.setSelectedIndices(new int[0]);
				}
			});
		}
		return jButton1;
	}
	/**
	 * @return
	 */
	public boolean done() {
		return getLstCampos().getSelectedIndex() != -1;
	}
    /**
     * This method initializes jPanel1	
     * 	
     * @return javax.swing.JPanel	
     */    
    private JPanel getJPanel1() {
    	if (jPanel1 == null) {
    		jPanel1 = new JPanel();
    		jPanel1.setSize(56, 71);
    		jPanel1.setPreferredSize(new java.awt.Dimension(70,10));
    	}
    	return jPanel1;
    }
    /**
     * This method initializes jPanel2	
     * 	
     * @return javax.swing.JPanel	
     */    
    private JPanel getJPanel2() {
    	if (jPanel2 == null) {
    		jPanel2 = new JPanel();
    		jPanel2.setSize(42, 60);
    		jPanel2.setPreferredSize(new java.awt.Dimension(70,10));
    	}
    	return jPanel2;
    }
}  //  @jve:decl-index=0:visual-constraint="10,10"
