package com.iver.cit.gvsig.jdbc_spatial.gui.jdbcwizard;

import javax.swing.JPanel;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;

import com.iver.andami.PluginServices;
import java.awt.BorderLayout;
/**
 * @author Fernando Gonzlez Corts
 */
public class GeomFieldSelection extends JPanel {

	private JLabel jLabel = null;
	private JList lstFields = null;
	private JScrollPane jScrollPane = null;
    private JPanel jPanel = null;  //  @jve:decl-index=0:visual-constraint="215,282"
    private JPanel jPanel1 = null;  //  @jve:decl-index=0:visual-constraint="9,197"
	/**
	 * This is the default constructor
	 */
	public GeomFieldSelection() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private  void initialize() {
		jLabel = new JLabel();
		this.setLayout(new BorderLayout());
		this.setSize(300, 263);
		jLabel.setText(PluginServices.getText(this, "select_geom_field") + ":");
		jLabel.setPreferredSize(new java.awt.Dimension(359,15));
		jLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		this.add(getJPanel1(), java.awt.BorderLayout.WEST);
		this.add(getJPanel(), java.awt.BorderLayout.EAST);
		this.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
		this.add(jLabel, java.awt.BorderLayout.NORTH);
	}
	/**
	 * This method initializes jList	
	 * 	
	 * @return javax.swing.JList	
	 */    
	private JList getLstFields() {
		if (lstFields == null) {
			lstFields = new JList();
			lstFields.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
		}
		return lstFields;
	}
	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */    
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getLstFields());
			jScrollPane.setPreferredSize(new java.awt.Dimension(260,131));
		}
		return jScrollPane;
	}
	
	public boolean done() {
		return (lstFields.getSelectedIndex() != -1);
	}
	/**
	 * @param fields
	 */
	public void setFields(String[] fields) {
		DefaultListModel model = new DefaultListModel();
		for (int i = 0; i < fields.length; i++) {
			model.addElement(fields[i]);
		}
		
		lstFields.setModel(model);
	}
	
	public String getField(){
		return (String) getLstFields().getSelectedValue();
	}
    /**
     * This method initializes jPanel	
     * 	
     * @return javax.swing.JPanel	
     */    
    private JPanel getJPanel() {
    	if (jPanel == null) {
    		jPanel = new JPanel();
    		jPanel.setSize(46, 32);
    		jPanel.setPreferredSize(new java.awt.Dimension(80,10));
    	}
    	return jPanel;
    }
    /**
     * This method initializes jPanel1	
     * 	
     * @return javax.swing.JPanel	
     */    
    private JPanel getJPanel1() {
    	if (jPanel1 == null) {
    		jPanel1 = new JPanel();
    		jPanel1.setSize(47, 66);
    		jPanel1.setPreferredSize(new java.awt.Dimension(80,10));
    	}
    	return jPanel1;
    }
  }  //  @jve:decl-index=0:visual-constraint="10,10"
