/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package com.iver.cit.gvsig.wcsclient;

import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.AddLayer;
import com.iver.cit.gvsig.gui.toc.FPopupMenu;
import com.iver.cit.gvsig.gui.toc.WCSPropsRaster;
import com.iver.cit.gvsig.gui.toc.WCSPropsTocMenuEntry;
import com.iver.cit.gvsig.gui.toc.WCSZoomPixelCursorTocMenuEntry;
import com.iver.cit.gvsig.gui.wcs.WCSWizard;

/**
 * @author jaume - jaume.dominguez@iver.es
 *
 */
public class WCSClientModule implements Extension {
	/**
	 * Initializes the toc menu
	 * 
	 */
	public void inicializar() {
		//System.out.println("Aado WCSWizard.");
		AddLayer.addWizard(WCSWizard.class);
    	FPopupMenu.addEntry(new WCSZoomPixelCursorTocMenuEntry());
    	FPopupMenu.addEntry(new WCSPropsTocMenuEntry());
    	FPopupMenu.addEntry(new WCSPropsRaster());
	}

	public void execute(String actionCommand) {
		/*if (actionCommand.equals("properties")){
			FLayer[] selected = ((View) PluginServices.getMDIManager().getActiveView()).getModel().getMapContext().getLayers().getActives();
			if(selected[0] instanceof FLyrWCS){
				WCSPropsDialog dialog = new WCSPropsDialog((FLyrDefault) selected[0]);
		       	dialog.openWCSPropertiesDialog();  	
			}
		}*/
	}

	/**
	 * What do you think? this tells you if it is enabled or not
	 */
	public boolean isEnabled() {
		return true;
	}
	
	/**
	 * What do you think? this tells you if it is visible or not
	 */
	public boolean isVisible() {
		return false;
	}
	
}
