package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * AxisDescription.java
 *
 * Created on 8 de enero de 2005, 13:57
 */
import java.util.*;

/**
 *
 * @author  jaume
 */
public class AxisDescription {
    private String semantic;
    private String refSys;
    private String refSysLabel;
    private String metadataLink;
    private String description;
    private String name;
    private String Default;
    
    private String label;
    private Values values;
    
    /** Creates a new instance of AxisDescription */
    public AxisDescription(XMLNode node) {
        if (WCSToolkit.isWCSTab(node.getSubNode(0), "AxisDescription")) node = node.getSubNode(0);
        //if (node.getSubNode(0).getName().equals("AxisDescription")) node = node.getSubNode(0);
        semantic = node.getAttribute("semantic");
        refSys = node.getAttribute("refSys");
        refSysLabel = node.getAttribute("refSysLabel");
        for (int i=0; i<node.getNumSubNodes();i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "metadatalink")) metadataLink = subnode.getText(); 
            //if (subnode.getName().equals("metadataLink")) metadataLink = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "description")) description = subnode.getText();
            //if (subnode.getName().equals("description")) description = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "name")) name = subnode.getText();
            //if (subnode.getName().equals("name")) name = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "label")) label = subnode.getText();
            // if (subnode.getName().equals("label")) label = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "values")) values = new Values(subnode);
            //if (subnode.getName().equals("values")) values = new Values(subnode);
        }
    }
    
    public String getSemantic(){
        return semantic;
    }

    public String getRefSys(){
        return refSys;
    }
    
    public String getRefSysLabel(){
        return refSysLabel;
    }
    
    public String getMetadataLink(){
        return metadataLink;
    }
    
    public String getDescription(){
        return description;
    }

    public String getName(){
        return name;
    }

    public String getLabel(){
        return label;
    }
    
    public ArrayList getSingleValues(){
        if (!values.getSingleValueList().isEmpty()) return values.getSingleValueList();
        return null;
    }
    
    
    public String getValuesType(){
        return values.getValuesType();
        
    }
    
    public Interval getInterval(){
        return values.getInterval();
    }
    
    public String getDefault(){
        return Default;
    }

    public String toString(){
        return "\nName: "+name+
               "\nLabel: "+label+
               "\nDescription: "+description+
               "\nReference system: "+refSys+
               "\nReference system label: "+refSysLabel+
               "\nSemantic: "+semantic+
               "\nMetadata Link: "+metadataLink;
        //+
        //       "\nValues: "+getValues();
    }
}



