package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * ContentMetadata.java
 *
 * Created on 27 de diciembre de 2004, 12:45
 */
import java.util.*;
/**
 *
 * @author  jaume
 */
public class ContentMetadata {
    private ArrayList coverageOfferingBriefList = new ArrayList();
    private int numLayers;
    
    /** Creates a new instance of ContentMetadata */
    public ContentMetadata(XMLNode node){
        for (int i=0; i<node.getNumSubNodes(); i++){
            if (WCSToolkit.isWCSTab(node.getSubNode(i), "CoverageOfferingBrief")){
                coverageOfferingBriefList.add(new CoverageOfferingBrief(node.getSubNode(i)));
                numLayers++;
            }
        }
    }
    
    public String toString(){
        Iterator i = coverageOfferingBriefList.iterator();
        String s = "\nNum layers: "+numLayers;
        while (i.hasNext()){
            CoverageOfferingBrief aux = (CoverageOfferingBrief) i.next();
            s += aux.toString();
        }
        return s;
    }
    
    public int getNumLayers(){
        return numLayers;
    }
    
    public CoverageOfferingBrief getCoverageOfferingBrief(String name){
        // Tryes to get the brief description of the coverage named name 
        // from the list. If it does not exist then returns null.
        
        Iterator i = coverageOfferingBriefList.iterator();
        while (i.hasNext()){
            CoverageOfferingBrief aux = (CoverageOfferingBrief) i.next();
            if (aux.getName().equals(name)) return aux;
        }
        return null;
    }
    
    public ArrayList getCoverageOfferingBriefList(){
        return coverageOfferingBriefList;
    }
    
/*    public ArrayList getLayerNames(){
        ArrayList names;
        Iterator i = coverageOfferingBriefList.listIterator();
        while (i.hasNext()){
            names.add(((CoverageOfferingBrief) i.next()).getName());
        }
        return names;
    }*/
}