package es.uji.lsi.wcs.XmlWcsParsing;


/*
 * CoverageOffering.java
 *
 * Created on 31 de diciembre de 2004, 15:25
 */

/**
 *
 * @author  jaume
 */
public class CoverageOffering {
    private CoverageOfferingBrief coverageOfferingBrief;
    private DomainSet domainSet;
    private RangeSet rangeSet;
    private SupportedCRSs supportedCRSs;
    private SupportedFormats supportedFormats;
    private SupportedInterpolations supportedInterpolations;
    
    /** Creates a new instance of CoverageOffering */
    public CoverageOffering(XMLNode node, Capabilities capabilities) {
        for (int i=0; i<node.getNumSubNodes(); i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "name")){
                // CoverageOffering type is composed from the already known 
                // CoverageOfferingBrief and others. Don't need to read the
                // CoverageOfferingBrief again, just use the previous loaded
                // one when GetCapabilities operation was performed.
                coverageOfferingBrief = capabilities.getContentMetadata().getCoverageOfferingBrief(subnode.getText());
            }
            if (WCSToolkit.isWCSTab(subnode, "domainSet")) domainSet = new DomainSet(subnode);
            if (WCSToolkit.isWCSTab(subnode, "rangeSet")) rangeSet = new RangeSet(subnode);
            if (WCSToolkit.isWCSTab(subnode, "supportedCRSs")) supportedCRSs = new SupportedCRSs(subnode);
            if (WCSToolkit.isWCSTab(subnode, "supportedFormats")) supportedFormats = new SupportedFormats(subnode);
            if (WCSToolkit.isWCSTab(subnode, "supportedInterpolations")) supportedInterpolations = new SupportedInterpolations(subnode);
        }
        
    }

    public DomainSet getDomainSet(){
        return domainSet;
    }
    
    public RangeSet getRangeSet(){
        return rangeSet;
    }
    
    public SupportedCRSs getSupportedCRSs(){
        return supportedCRSs;
    }

    public SupportedFormats getSupportedFormats(){
        return supportedFormats;
    }

    public SupportedInterpolations getSupportedInterpolations(){
        return supportedInterpolations;
    }

    public CoverageOfferingBrief getCoverageOfferingBrief(){
        return coverageOfferingBrief;
    }
    
    public String toString(){
        String s = "\nCOVERAGE OFFERING";
        
        return "\n"+getCoverageOfferingBrief()+
               "\n"+getDomainSet()+
               "\n"+getRangeSet()+
               "\n"+getRangeSet()+
               "\n"+getSupportedCRSs()+
               "\n"+getSupportedFormats()+
               "\n"+getSupportedInterpolations();
    }
}
