package es.uji.lsi.wcs.XmlWcsParsing;


/*
 * CoverageOfferingBrief.java
 *
 * Created on 27 de diciembre de 2004, 12:50
 */

/**
 *
 * @author  jaume
 */
public class CoverageOfferingBrief {
    private String metadataLink;
    private String description;
    private String name;
    
    private String label;
    private LonLatEnvelope lonLatEnvelope;
    private String keywords;
    
    /** Creates a new instance of CoverageOfferingBrief */
    public CoverageOfferingBrief(XMLNode node) {
        for (int i=0; i<node.getNumSubNodes(); i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "metadataLink")) setMetadataLink(subnode);
            if (WCSToolkit.isWCSTab(subnode, "description")) setDescription(subnode);
            if (WCSToolkit.isWCSTab(subnode, "name")) setName(subnode);
            if (WCSToolkit.isWCSTab(subnode, "label")) setLabel(subnode);
            if (WCSToolkit.isWCSTab(subnode, "lonLatEnvelope")) setLonLatEnvelope(subnode);
            if (WCSToolkit.isWCSTab(subnode, "keywords")) setKeywords(subnode);
        }
            
    }
    
    public void setMetadataLink(XMLNode node){
        metadataLink = node.getText();
    }

    public void setDescription(XMLNode node){
        description = node.getText();
    }
    
    public void setName(XMLNode node){
        name = node.getText();
    }
    
    public void setLabel(XMLNode node){
        label = node.getText();
    }
    
    public void setKeywords(XMLNode node){
        keywords = "";
        for (int i=0; i<node.getNumSubNodes(); i++){
            keywords += node.getSubNode(i).getName()+"="+node.getSubNode(i).getText()+";";
        }
    }
    
    public void setLonLatEnvelope(XMLNode node){
        lonLatEnvelope = new LonLatEnvelope(node);
    }
    
    public String getMetadataLink(){
        return metadataLink;
    }
    
    public String getDescription(){
        return description;
    }
    
    public String getName(){
        return name;
    }
    
    public String getLabel(){
        return label;
    }
    
    public String getKeywords(){
        return keywords;
    }
    
    
    public String toString(){
        return "\nname: "+getName()+"\ndescription: "+getDescription()+
               "\nlabel: "+getLabel()+"\nmetadata link: "+getMetadataLink()+
               "\nkeywords: "+getKeywords()+"\nLon-lat envelope"+lonLatEnvelope.toString();
    }

	/**
	 * Devuelve el nombre del SRS estndar del CoverageOfferingBrief
	 * @return String
	 */
	public String getSRS(){ 
		return lonLatEnvelope.getSRS();
	}
	
}
