package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * DCPType.java
 *
 * Created on 26 de diciembre de 2004, 19:36
 */

/**
 * This file implements the DCPType class. For the moment, HTTP is the only DCP 
 * defined and for now, a server may list either a GET or POST access point, or
 * both, for each operation.
 * @author  jaume
 */


public class DCPType {
    private AccessPoint httpGetOperationAccessPoint;
    private AccessPoint httpPostOperationAccessPoint;
    /** Creates a new instance of DCPType */
    public DCPType(XMLNode node) {
        for (int i=0; i<node.getNumSubNodes(); i++){
            
            // This is the only DCP defined until this version was released. You are welcomed
            // to upgrade this file for further future DCPs, just add more attributes to the 
            // class and more cases to this loop.
            if (node.getSubNode(i).getName().equals("HTTP")){
                XMLNode subNode = node.getSubNode(i);
                for (int j=0; j<subNode.getNumSubNodes(); j++){
                    if (WCSToolkit.isWCSTab(subNode.getSubNode(j), "Get")) 
                        httpGetOperationAccessPoint = new AccessPoint(subNode.getSubNode(j));
                    if (WCSToolkit.isWCSTab(subNode.getSubNode(j), "Post")) 
                        httpGetOperationAccessPoint = new AccessPoint(subNode.getSubNode(j));
                }
            }
        }
    }
    
    public String toString(){
        return "\nGet access point: "+httpGetOperationAccessPoint+
               "\nPost access point: "+httpPostOperationAccessPoint;
    }
}

class AccessPoint {
    private String xlink_href;
    private String xlink_type;
    
    public AccessPoint(XMLNode node){
        for (int i=0; i<node.getNumSubNodes(); i++){
            if (WCSToolkit.isWCSTab(node.getSubNode(i), "OnlineResource")){
                xlink_href = node.getSubNode(i).getAttribute("xlink:href");
                xlink_type = node.getSubNode(i).getAttribute("xlink:type");
            }   
        }        
    }
    
    public String toString(){
        return "(href="+xlink_href+", "+xlink_type+")";
    }
}