package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * DescribeCoverage.java
 *
 * Created on 31 de diciembre de 2004, 15:03
 */
import java.util.*;
import java.io.*;


/**
 *
 * @author  jaume
 */
public class DescribeCoverageResponse {
    private String version;
    private String updateSequence;
    private ArrayList coverageOfferingList = new ArrayList();
    
    /** Creates a new instance of DescribeCoverage */
    public DescribeCoverageResponse(XMLNode node, Capabilities capabilities) {
        fillupDescribeCoverage(node, capabilities);
    }

    public DescribeCoverageResponse(File file, Capabilities capabilities){
        // for debugging purposes only
        try {
            XMLNode node = new XMLNode(file);
            fillupDescribeCoverage(node, capabilities);
        } catch (Exception e){
            System.out.println("Exception: " + e.getMessage());
        }
    }
    
    public void fillupDescribeCoverage(XMLNode node, Capabilities capabilities){
        try{
            checkDescribeCoverageDocument(node);
            for (int i=0; i<node.getNumSubNodes(); i++){
                XMLNode subnode = node.getSubNode(i);
                
                if (WCSToolkit.isWCSTab(subnode, "CoverageOffering")) coverageOfferingList.add(new CoverageOffering(subnode, capabilities));
            }        
        } catch (NotAnDescribeCoverageXmlDocumentException e){
            new Error("Unrecognized DescribeCapabilities format");
        }
    }
    
    public boolean checkDescribeCoverageDocument(XMLNode node) throws NotAnDescribeCoverageXmlDocumentException{
        if (WCSToolkit.isWCSTab(node, "CoverageDescription")){
            version = node.getAttribute("version");
            updateSequence = node.getAttribute("updateSequence");
            return true;
        } else throw new NotAnDescribeCoverageXmlDocumentException();
    }
    
    public String getVersion(){
        return version;
    }
    
    public String getUpdateSequence(){
        return updateSequence;
    }
    
    public ArrayList getCoverageOfferingList(){
        return coverageOfferingList;
    }
    
    public CoverageOffering getCoverageOffering(String coverage_name){
        // returns the coverage named coverage_name from the list
        Iterator it = coverageOfferingList.iterator();
        while (it.hasNext()){
            CoverageOffering co = (CoverageOffering) it.next();
            if (co.getCoverageOfferingBrief().getName().equals(coverage_name)){
                return co;
            }
        }
        return null;
    }
    
    public String toString(){
        Iterator it = coverageOfferingList.iterator();
        String s = "";
        while (it.hasNext()){
            s += "\nNext item: "+it.next();
        }
        return "\nDESCRIBE COVERAGE"+
               "\nVersion: "+version+
               "\nUpdate Sequence: "+updateSequence+
               "\nCoverage Offering list: "+s;
    }
    
}

class NotAnDescribeCoverageXmlDocumentException extends Exception{
    public NotAnDescribeCoverageXmlDocumentException(){
        super();
    }
    
    public NotAnDescribeCoverageXmlDocumentException(String s){
        super(s);
    }
}