package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * DomainSet.java
 *
 * Created on 3 de enero de 2005, 12:12
 */

/**
 *
 * @author  jaume
 */
public class DomainSet {
    private SpatialDomain spatialDomain;
    private TemporalDomain temporalDomain;
    
    /** Creates a new instance of DomainSet */
    public DomainSet(XMLNode node) {
        for (int i=0; i<node.getNumSubNodes(); i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "spatialDomain")) spatialDomain = new SpatialDomain(subnode);
            if (WCSToolkit.isWCSTab(subnode, "temporalDomain")) temporalDomain = new TemporalDomain(subnode);
        }
    }
    
    public SpatialDomain getSpatialDomain(){
        return spatialDomain;
    }
    
    public TemporalDomain getTemporalDomain(){
        return temporalDomain;
    }
    
    public String toString(){
        return "\nSpatial Domain: "+spatialDomain+
               "\nTemporal Domain: "+temporalDomain;
    }
}
