package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * GMLEnvelopeWithTmePeriod.java
 *
 * Created on 3 de enero de 2005, 12:57
 */

/**
 *
 * @author  jaume
 */
public class GMLEnvelopeWithTimePeriod{
    private String srsName;
    private double [][] gml_pos = new double[2][2];
    private double [][] gml_timePosition = new double[2][2];
    
    /** Creates a new instance of LonLatEnvelope */
    public GMLEnvelopeWithTimePeriod(XMLNode node) {
        srsName = node.getAttribute("srsName");
        int gml_posIndex = 0;
        int gml_timePositionIndex = 0;
        for (int i=0; i<node.getNumSubNodes(); i++){
            if (WCSToolkit.isWCSTab(node.getSubNode(i), "gml:pos")){
                setGmlPos(gml_posIndex, node.getSubNode(i));
                gml_posIndex++;
            }
            if (WCSToolkit.isWCSTab(node.getSubNode(i), "gml:timePosition")){
                setGmlTimePosition(gml_timePositionIndex, node.getSubNode(i));
                gml_timePositionIndex++;
            }
        }
        int i = 0;
    }
    
    public void setGmlPos(int index, XMLNode node){
        String s = node.getText();
        gml_pos[index][0] = Double.parseDouble(s.substring(0, s.indexOf(" ")));
        gml_pos[index][1] = Double.parseDouble(s.substring(s.indexOf(" ")+1, s.length()));
    }

    public void setGmlTimePosition(int index, XMLNode node){
        String s = node.getText();
        gml_timePosition[index][0] = Double.parseDouble(s.substring(0, s.indexOf(" ")));
        gml_timePosition[index][1] = Double.parseDouble(s.substring(s.indexOf(" ")+1, s.length()));
    }
    
    public double getMinX(){
        return gml_pos[0][0];
    }
    
    public double getMinY(){
        return gml_pos[0][1];
    }
    
    public double getMaxX(){
        return gml_pos[1][0];
    }
    
    public double getMaxY(){
        return gml_pos[1][1];
    }
    
    
    public String getSRSName(){
        return srsName;
    }
    public String toString(){
        return "\ngml pos: ("+gml_pos[0][0]+", "+gml_pos[0][1]+") ("+gml_pos[1][0]+", "+gml_pos[1][1]+")"+
               "\ngml time position: ("+gml_timePosition[0][0]+", "+gml_timePosition[0][1]+") ("+gml_timePosition[1][0]+", "+gml_timePosition[1][1]+")";
    }
}
