package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * GMLRectifiedGrid.java
 *
 * Created on 3 de enero de 2005, 15:10
 */
import java.util.*;
/**
 *
 * @author  jaume
 */
public class GMLRectifiedGrid {
    private int dimension;
    private GMLLimits gmlLimits;
    private ArrayList axisNames = new ArrayList();
    private double[] origin;
    private ArrayList offsetVectorList = new ArrayList();
    
    /** Creates a new instance of GMLRectifiedGrid */
    public GMLRectifiedGrid(XMLNode node) {
        dimension = Integer.parseInt(node.getAttribute("dimension"));
        for (int i=0; i<node.getNumSubNodes();i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "gml:limits")) gmlLimits = new GMLLimits(subnode, dimension);
            if (WCSToolkit.isWCSTab(subnode, "gml:axisName")) axisNames.add(subnode.getText());
            if (WCSToolkit.isWCSTab(subnode, "gml:origin")) setOrigin(subnode, dimension);
            if (WCSToolkit.isWCSTab(subnode, "gml:offsetVector")) {
                String[] s = subnode.getText().split(" ");
                double [] aux = new double[dimension];
                for (int j=0; j<dimension; j++){
                    aux[j] = new Double(s[j]).doubleValue();
                }
                offsetVectorList.add(aux);
            }
            int j = 0;
        }
        
    }
    
    public void setOrigin(XMLNode node, int dimension){
        origin = new double[dimension];
        for (int i=0; i<node.getNumSubNodes(); i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "gml:pos")){
                String[] s = subnode.getText().split(" ");
                for (int j=0; j<dimension; j++){
                    origin[j] = new Double(s[j]).doubleValue();
                }
            }
        }
    }
    
    public int getDimension(){
        return dimension;
    }
    
    public GMLLimits getGMLLimits(){
        return gmlLimits;
    }
    
    public ArrayList getAxisNames(){
        return axisNames;
    }
    
    public String getAxisName(int index){
        return (String) axisNames.get(index);
    }
    
    public double[] getOffsetVector(int index){
        return (double[]) offsetVectorList.get(index);
    }
    
    public ArrayList getOffsetVectorList(){
        return offsetVectorList;
    }
    
    public double[] getOrigin(){
        return origin;
    }
    
    public String toString(){
        Iterator it ;
        String s, s2, s3;
        s ="";
        s2 ="";
        s3 ="";
        if (axisNames !=null){
            it = axisNames.iterator();
            while (it.hasNext()){
                s += it.next()+" ";
            }
        }
        
        if (origin != null){
            for (int i=0; i<origin.length; i++){
                s3 += origin[i]+" ";
            }
        }
        return "\nGML Rectified Grid"+
               "\ndimension: "+dimension+
               "\ngml limits: "+gmlLimits+
               "\nAxis names: "+s
               +"\nOffset vector: ["+s2+"]"+
               "\nOrigin: ("+s3+")";
    }
}

