package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * RangeSet.java
 *
 * Created on 8 de enero de 2005, 13:39
 */
import java.util.*;

/**
 *
 * @author  jaume
 */
public class RangeSet {
    private String metadataLink;
    private String description;
    private String name;
    
    private String label;
    private ArrayList axisDescriptionList = new ArrayList();
    private ArrayList nullValuesList = new ArrayList();
    
    /** Creates a new instance of RangeSet */
    public RangeSet(XMLNode node) {
        if (WCSToolkit.isWCSTab(node.getSubNode(0), "RangeSet")) node = node.getSubNode(0);
        for (int i=0; i<node.getNumSubNodes();i++){
            XMLNode subnode = node.getSubNode(i);

            if (WCSToolkit.isWCSTab(subnode, "metadataLink")) metadataLink = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "description")) description = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "name")) name = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "label")) label = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "axisDescription")) axisDescriptionList.add(new AxisDescription(subnode)); 
            if (WCSToolkit.isWCSTab(subnode, "nullValues")) nullValuesList.add(new NullValues(subnode));
        }
    }
    
     public String getMetadataLink(){
        return metadataLink;
    }
    
    public String getDescription(){
        return description;
    }
    
    public String getName(){
        return name;
    }
    
    public String getLabel(){
        return label;
    }
    
    public ArrayList getAxisDescriptionList(){
        return axisDescriptionList;
    }
    
    public AxisDescription getAxisDescription(String name){
        ArrayList al = getAxisDescriptionList();
        Iterator it = al.iterator();
        while (it.hasNext()){
            AxisDescription ad = (AxisDescription) it.next();
            if (ad.getName().equals(name))
                return ad;
        }
        return null;
    }
    
    public ArrayList getNullValuesList(){
        return nullValuesList;
    }
    public String toString(){
        String s, s2;
        s = "";
        s2 = "";
        Iterator it = axisDescriptionList.iterator();
        while (it.hasNext())
            s += it.next().toString();
        
        it = nullValuesList.iterator();
        while (it.hasNext())
            s2 += it.next().toString();
        
        return "\nRANGE SET\nname: "+getName()+"\ndescription: "+getDescription()+
               "\nlabel: "+getLabel()+"\nmetadata link: "+getMetadataLink()+
               "\nAxisDescriptions: "+s+"\nNull Values: "+s2;
        
    }
}
