package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * Service.java
 *
 * Created on 21 de diciembre de 2004, 1:02
 */
/**
 *
 * @author  jaume
 */
public class Service {
    private String description;                   // A description of the server. (optional)
    private String name;                          // A name the service provider assigns to the server. (required)
    private String label;                         // A human-readable label for this server, for use in menus and other displays. (required)
    private String metadataLink;                  // A link to external metadata (of type "FGDC", "TC211", or "other"). (optional)
    private String keywords;                      // Short words to aid catalog searching. (optional)
    private String responsibleParty;              // A tree of elements that identify the service provider and provide contact details. (optional)
    private String fees;                          // A text string indicating any fees imposed by the service provider. The keyword NONE is reserved to mean no fees. (required)
    private String accessConstraints;             // A list of codes describing any access constraints imposed by the service provider. The keyword NONE is reserved to mean no access constraints are imposed. (required)
    
    /** Creates a new instance of Service */
    public Service(XMLNode node) {
        for (int i=0; i<node.getNumSubNodes(); i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "description")) setDescription(subnode.getText());
            if (WCSToolkit.isWCSTab(subnode, "name")) setName(subnode.getText());
            if (WCSToolkit.isWCSTab(subnode, "label")) setLabel(subnode.getText());
            if (WCSToolkit.isWCSTab(subnode, "metadataLink")) setMetadataLink(subnode.getText());
            if (WCSToolkit.isWCSTab(subnode, "keywords")) setKeywords(subnode);
            if (WCSToolkit.isWCSTab(subnode, "responsibleParty")) setResponsibleParty(subnode);
            if (WCSToolkit.isWCSTab(subnode, "fees")) setFees(subnode.getText());
            if (WCSToolkit.isWCSTab(subnode, "accessConstraints")) setAccessConstraints(subnode.getText());
        }
    }
    
    public String getDescription(){
        return description;
    }

    public String getName(){
        return name;
    }

    public String getLabel(){
        return label;
    }

    public String getMetadataLink(){
        return metadataLink;
    }

    public String getKeywords(){
        return keywords;
    }

    public String getResponsibleParty(){
        return responsibleParty;
    }

    public String getFees(){
        return fees;
    }
    
    public String getAccessConstraints(){
        return accessConstraints;
    }
    
    public void setDescription(String s){
        description = s;
    }
    
    public void setName(String s){
        name = s;
    }
    
    public void setLabel(String s){
        label = s;
    }
    
    public void setMetadataLink(String s){
        metadataLink = s;
    }
    
    public void setKeywords(XMLNode node){
        keywords = "";
        for (int i=0; i<node.getNumSubNodes(); i++){
            keywords += node.getSubNode(i).getText()+";";
        }

//        for (int i=0; i<node.getNumSubNodes(); i++){
//            keywords.add(node.getSubNode(i).getText());
//        }
    }

    public void setResponsibleParty(XMLNode node){
        responsibleParty = "";
        for (int j=0; j<node.getNumSubNodes(); j++){
            responsibleParty += node.getSubNode(j).getName()+"="+node.getSubNode(j).getText()+";";
        }   
    }

    public void setFees(String s){
        fees = s;
    }
    
    public void setAccessConstraints(String s){
        accessConstraints = s;
    }
    
    public String toString(){
        return "\nDescription: "+getDescription()+
               "\nName: "+getName()+
               "\nLabel: "+getLabel()+
               "\nMetadata Link: "+getMetadataLink()+
               "\nKeywords: "+getKeywords()+
               "\nResponsible party: "+getResponsibleParty()+
               "\nFees: "+getFees()+
               "\nAccess Constraints: "+getAccessConstraints();
    }
}
