package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * SupportedCRCs.java
 *
 * Created on 13 de enero de 2005, 14:21
 */
import java.util.*;
/**
 *
 * @author  jaume
 */
public class SupportedCRSs {
    private ArrayList requestResponseCRSs;
    private ArrayList requestCRSs;
    private ArrayList responseCRSs;
    private ArrayList nativeCRSs;
    /** Creates a new instance of SupportedCRCs */
    public SupportedCRSs(XMLNode node) {
        for (int i=0; i<node.getNumSubNodes(); i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "requestResponseCRSs")) {
                if (requestResponseCRSs == null) requestResponseCRSs = new ArrayList();
                String[] s = subnode.getText().split(" +");
                for (int j=0; j<s.length; j++) requestResponseCRSs.add(s[j]);
            }
            
            if (WCSToolkit.isWCSTab(subnode, "requestCRSs")) {
                if (requestCRSs == null) requestCRSs = new ArrayList();
                String[] s = subnode.getText().split(" +");
                for (int j=0; j<s.length; j++) requestCRSs.add(s[j]);
            }

            if (WCSToolkit.isWCSTab(subnode, "responseCRSs")) {
                if (responseCRSs == null) responseCRSs = new ArrayList();
                String[] s = subnode.getText().split(" +");
                for (int j=0; j<s.length; j++) responseCRSs.add(s[j]);
            }

            if (WCSToolkit.isWCSTab(subnode, "nativeCRSs")) {
                if (nativeCRSs == null) nativeCRSs = new ArrayList();
                String[] s = subnode.getText().split(" +");
                for (int j=0; j<s.length; j++) nativeCRSs.add(s[j]);
            }
        }
    }
    
    public ArrayList getRequestResponseCRSs(){
        return requestResponseCRSs;
    }
    
    public ArrayList getRequestCRSs(){
        return requestCRSs;
    }

    public ArrayList getResponseCRSs(){
        return responseCRSs;
    }
    
    public ArrayList getNativeCRSs(){
        return nativeCRSs;
    }
    
    public ArrayList getAllRequestableCRSs(){
        // Devuelve getRequestResponseCRSs()+getRequestCRSs();
        ArrayList a = new ArrayList();
        if (getRequestResponseCRSs()!= null){
            Iterator it = getRequestResponseCRSs().iterator();
            while (it.hasNext()){
                a.add((String) it.next());
            }
        }
        if (getRequestCRSs()!= null){
            Iterator it = getRequestCRSs().iterator();
            while (it.hasNext()){
                String s = (String) it.next();
                if (!a.contains(s)) a.add(s);
            }
        }
        
        return a;
    }
    
    public String toString(){
        Iterator it;
        String s = "\nSUPPORTED CRS\n";
        if (requestResponseCRSs != null){
            it = requestResponseCRSs.iterator();
            s += "\nRequest REsponse CRS(s): ";
            while (it.hasNext()){
                s += (String) it.next();
                if (it.hasNext()) s += ", ";
            }
        }

        if (requestCRSs != null){
            it = requestCRSs.iterator();
            s += "\nRequest CRS(s): ";
            while (it.hasNext()){
                s += (String) it.next();
                if (it.hasNext()) s += ", ";
            }
        }

        if (responseCRSs != null){
            it = responseCRSs.iterator();
            s += "\nResponse CRS(s): ";
                    while (it.hasNext()){
                s += (String) it.next();
                if (it.hasNext()) s += ", ";
            }
        }

        if (nativeCRSs != null){
            it = nativeCRSs.iterator();
            s += "\nNative CRS(s): ";
            while (it.hasNext()){
                s += (String) it.next();
                if (it.hasNext()) s += ", ";
            }
        }
        return s;
    }
}
