package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * TimePeriod.java
 *
 * Created on 3 de enero de 2005, 16:15
 */

/**
 *
 * @author  jaume
 */
public class TimePeriod {
    private double beginPosition;
    private String beginPositionFrame;
    
    private double endPosition;
    private String endPositionFrame;
    
    private double timeResolution;
    private String timeResolutionFrame;
    
    /** Creates a new instance of TimePeriod */
    public TimePeriod(XMLNode node) {
        for (int i=0; i<node.getNumSubNodes(); i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "beginPosition")) {
                beginPosition = Double.parseDouble(subnode.getText());
                if (subnode.getAttribute("frame") == null) beginPositionFrame = "ISO-8601";
                else beginPositionFrame = subnode.getAttribute("frame");
            }
            if (WCSToolkit.isWCSTab(subnode, "endPosition")) {
                endPosition = Double.parseDouble(subnode.getText());
                if (subnode.getAttribute("frame") == null) endPositionFrame = "ISO-8601";
                else endPositionFrame = subnode.getAttribute("frame");
            }
            if (WCSToolkit.isWCSTab(subnode, "timeResolution")) {
                timeResolution = Double.parseDouble(subnode.getText());            
                if (subnode.getAttribute("frame") == null) timeResolutionFrame = "ISO-8601";
                else timeResolutionFrame = subnode.getAttribute("frame");
            }
        }
    }
    public double getBeginPosition(){
        return beginPosition;
    }
    
    public String getBeginPositionFrame(){
        return beginPositionFrame;
    }
    
    public double getEndPosition(){
        return endPosition;
    }
    
    public String getEndPositionFrame(){
        return endPositionFrame;
    }
    
    public double getTimeResolution(){
        return timeResolution;
    }
    
    public String getTimeResolutionFrame(){
        return timeResolutionFrame;
    }
    
    public String toString(){
        return "\nTIME PERIOD: "+
               "\nBegin position: "+getBeginPosition()+
               "\nBegin Position: "+getBeginPositionFrame()+
               "\nEnd Position: "+getEndPosition()+
               "\nEnd Position Frame: "+getEndPositionFrame()+
               "\nTime Resolution: "+getTimeResolution()+
               "\nTime Resolution Frame: "+getTimeResolutionFrame();
    }
}
