package es.uji.lsi.wcs.XmlWcsParsing;
/*
 * Values.java
 *
 * Created on 27 de enero de 2005, 21:03
 */
import java.util.*;

/**
 *
 * @author  jaume
 */
public class Values{
    private String semantic;
    private String type;
    private ArrayList singleValueList = new ArrayList();
    private Interval interval; 
    private String Default;
    
    private String miValuesType;
    
    public Values(XMLNode node){
        semantic = node.getAttribute("semantic");
        type = node.getAttribute("type");
        for (int i=0; i<node.getNumSubNodes(); i++){
            XMLNode subnode = node.getSubNode(i);
            if (WCSToolkit.isWCSTab(subnode, "default")) Default = subnode.getText();
            if (WCSToolkit.isWCSTab(subnode, "interval")) {
                interval = new Interval(subnode);
                miValuesType = "interval";
            }
            if (WCSToolkit.isWCSTab(subnode, "singleValue")) {
                singleValueList.add(new SingleValue(subnode));
                miValuesType = "singleValue";
            }
        }
    }
    
    public String getSemantic(){
        return semantic;
    }
    
    public String getType(){
        return type;
    }
    
    public String getValuesType(){
        return miValuesType;
    }
    
    public ArrayList getSingleValueList(){
        return singleValueList;
    }
    
    public Interval getInterval(){
        return interval;
    }
    
    public String toString(){
        String s = "";
            
        if (getType().equals("singleValue")){
            Iterator it = singleValueList.iterator();
            while (it.hasNext()){
                s += it.next();
                if (it.hasNext()) s += ", ";
            }   
        }
        else{
            s = "max="+interval.getMax()+", min="+interval.getMin()+", res="+interval.getRes();
        } 
        return "\nSemantic: "+semantic+
               "\nType: "+type+
               "\nDefault: "+Default+
               
               "\nValueEnum: "+s;
    }
}
