package es.uji.lsi.wcs.client;
/*
 * OperationGetCoverage.java
 *
 * Created on 18 de enero de 2005, 14:27
 */
import java.util.*;
/**
 *
 * @author  jaume
 */
public class OperationGetCoverage extends Operation{
    private Hashtable parameters;

    /** Creates a new instance of OperationGetCoverage */
    public OperationGetCoverage() {
        parameters = new Hashtable();
        initParams();
    }

    private void initParams(){
        parameters.put("service", "WCS");
        parameters.put("request", "GetCoverage");
        parameters.put("version", "1.0.0");
    }    

    public void setParam(String param_name, String value) throws Exception{
        if (param_name.equals("FORMAT") && value.equals("GEOTIFF_16BIT")) value = "GEOTIFF_INT16";
        if (param_name.equals("FORMAT") && value.equals("HFA_16BIT")) value = "HFA_INT16";
        if (param_name.equals("CRS") && value.equals("WGS84(DD)")) value = "EPSG:4326";
        if (param_name.equals("CRS") && value.equals("EPSG:WGS 84")) value = "EPSG:WGS%4326";
        super.setParam(super.GET_COVERAGE, param_name, value, parameters);
    }
    
    public String getParamsString(){
        try {
        	// slo para asegurarse en caso de que no se haya hecho ya, iniciamos los parametros
        	initParams();
            return super.getParamsString(parameters);
        } catch (Exception e){
            new Error("Failed to build GetCoverage param string.");
            return null;
        }
    }
    
    public void cleanParams(){
    	super.cleanParams(super.GET_COVERAGE, parameters); 
    }
}


