/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.uji.lsi.wcs.client;

import com.iver.andami.PluginServices;

/**
 * Excepcin que se lanza cuando el servidor ha respondido con un mensaje de error
 * 
 * @author jaume - jaume.dominguez@iver.es
 *
 */
public class ServerErrorResponseException extends Exception {
	String message = null;
	/**
	 * La respuesta del servidor es un mensaje de error no vinculado a WCS. 
	 * Por ejemplo para un error de configuracin de Apache
	 *
	 */
	public ServerErrorResponseException(){
		message = PluginServices.getText(this, "causa_error_desconocida");
	}
	
	/**
	 * La respuesta del servidor es un mensaje WCS y queremos saber de qu se trata.
	 * 
	 * @param texto parseado de la respuesta en  xml de error
	 */
	public ServerErrorResponseException(String s){
		message = PluginServices.getText(this, "respuesta_error_servidor") + ":\n"+s;
	}
	
	public String getMessage(){
		return message;
	}
}
