/*
 * Created on 22-feb-2005
 */
package org.cresques.io.rasterOld;

import java.awt.Image;

/**
 * Calcula el mximo y el mnimo de un raster.
 * @author Luis W. Sevilla (sevilla_lui@gva.es)
 */
public class ComputeMinMaxFilter extends RasterFilter {
	protected int [] min = {Integer.MAX_VALUE,Integer.MAX_VALUE,Integer.MAX_VALUE};
	protected int [] max = {Integer.MIN_VALUE,Integer.MIN_VALUE,Integer.MIN_VALUE};
	
	public ComputeMinMaxFilter(RasterBuf raster, RasterStats stats) {
		super(raster, stats);
		System.out.println("ComputeMinMaxFilter ...");
		this.min = new int[raster.getBandNr()];
		this.max = new int[raster.getBandNr()];
		for (int i=0; i<min.length; i++) {
			min[i] = stats.minBandValue[i];
			max[i] = stats.maxBandValue[i];
		}
		execute();
		for (int i=0; i<raster.getBandNr(); i++) {
			stats.minBandValue[i] = min[i];
			stats.maxBandValue[i] = max[i];
		}
	}
	
	public ComputeMinMaxFilter(Image image, RasterStats stats) {
		super(image, stats);
		this.min = new int[min.length];
		this.max = new int[max.length];
		for (int i=0; i<min.length; i++) {
			min[i] = stats.minBandValue[i];
			max[i] = stats.maxBandValue[i];
		}
		execute();
		for (int i=0; i<raster.getBandNr(); i++) {
			stats.minBandValue[i] = min[i];
			stats.maxBandValue[i] = max[i];
		}
	}
	
	public void process(int x, int y) {
		raster.getPixelInt(x, y, px);
		for (int i=0; i<raster.getBandNr(); i++) {
			min[i] = Math.min(min[i], px[i]);
			max[i] = Math.max(max[i], px[i]);
		}
	}

	public int getMin(int bandNr) { return min[bandNr]; }

	public int getMax(int bandNr) { return max[bandNr]; }

	/* (non-Javadoc)
	 * @see org.cresques.px.PxRaster.RasterFilter#processLines(int)
	 */
	public void processLine(int y) {
		// TODO Auto-generated method stub
		
	}
}

