/*
 * Created on 25-feb-2005
 */
package org.cresques.io.rasterOld;

import java.awt.Image;
import java.awt.image.BufferedImage;

/**
 * Renderiza el raster.
 * @author Luis W. Sevilla (sevilla_lui@gva.es)
 */

public class GreyscaleRasterToImageFilter extends RasterFilter {
	private BufferedImage image;
	private int alpha;
	private int rgb;
	public GreyscaleRasterToImageFilter(RasterBuf raster, int a) {
		super(raster, null);
		System.out.println("GreyscaleRasterToImageFilter ...");
		this.alpha = (a & 0xff) << 24;
		image = new BufferedImage(raster.getWidth(), raster.getHeight(), BufferedImage.TYPE_INT_ARGB);
		execute();
	}
	
	/* (non-Javadoc)
	 * @see org.cresques.px.PxRaster.RasterFilter#process(int, int)
	 */
	public void process(int x, int y) {
		raster.getPixelInt(x, y, px);
		rgb = alpha | ((px[0] & 0xff) << 16) |
				((px[0] & 0xff) << 8) | (px[0] & 0xff);
		
		image.setRGB(x, y, rgb);
	}
	
	public Image getImage() { return image; }

	/* (non-Javadoc)
	 * @see org.cresques.px.PxRaster.RasterFilter#processLines(int)
	 */
	public void processLine(int y) {
		for (int x=0; x<width; x++) {
			int [][] line = raster.getLineInt(y);
			rgb = alpha | ((line[x][0] & 0xff) << 16) |
				((line[x][0] & 0xff) << 8) | (line[x][0] & 0xff);
	
				image.setRGB(x, y, rgb);
		}
	}
}

