/*
 * Created on 25-feb-2005
 */
package org.cresques.io.rasterOld;

import java.awt.Image;

/**
 * Realzado Lineal (Amplitude Rescaling).
 * @author Luis W. Sevilla (sevilla_lui@gva.es)
 */
public class LinearEnhancementFilter extends RasterFilter {
	protected double [] scale = new double[3];
	protected double [] offset = new double[3];
	public LinearEnhancementFilter(RasterBuf raster, RasterStats stats) {
		super(raster, stats);
		System.out.println("LinearEnhancementFilter ...");
		for (int i=0; i<raster.getBandNr(); i++) {
			scale[i] = 255D/(stats.maxBandValue[i]-stats.minBandValue[i]);
			offset[i] = (255D*stats.minBandValue[i])/(stats.minBandValue[i]-stats.maxBandValue[i]);
		}
		execute();
	}

	public LinearEnhancementFilter(Image image, RasterStats stats) {
		super(image, stats);
		for (int i=0; i<raster.getBandNr(); i++) {
			scale[i] = 255D/(stats.maxBandValue[i]-stats.minBandValue[i]);
			offset[i] = (255D*stats.minBandValue[i])/(stats.minBandValue[i]-stats.maxBandValue[i]);
		}
		execute();
	}

	public void process(int x, int y) {
		raster.getPixelInt(x, y, px);
		for (int i=0; i<raster.getBandNr(); i++)
			px[i] = (((int) (((double)px[i])*scale[i] + offset[i])) & 0xff);
		raster.setPixelInt(x, y, px);
	}

	/* (non-Javadoc)
	 * @see org.cresques.px.PxRaster.RasterFilter#processLines(int)
	 */
	public void processLine(int y) {
		// TODO Auto-generated method stub
		
	}
}

