/*
 * Created on 25-feb-2005
 */
package org.cresques.io.rasterOld;

import java.awt.Image;

/**
 * Filtro para raster. Ancestro de todos los filtros.
 * @author Luis W. Sevilla (sevilla_lui@gva.es)
 */
public abstract class RasterFilter {
	protected RasterBuf raster = null;
	protected RasterStats stats = null;
	protected Image image = null;
	protected int [] px = new int[3];
	protected int height = 0;
	protected int width = 0;
	
	public RasterFilter(RasterBuf raster, RasterStats stats) {
		this.raster = raster;
		this.stats = stats;
		height = raster.getHeight();
		width = raster.getWidth();
	}
	
	public RasterFilter(Image image, RasterStats stats) {
		this.image = image;
		this.stats = stats;
		height = image.getHeight(null);
		width = image.getWidth(null);
	}
	public void execute() {
		for (int y=0; y<height; y++)
			for (int x=0; x<width; x++) {
				process(x, y);
			}
	}
	
	public void executeLines() {
		for (int y=0; y<height; y++)
			processLine(y);
	}

	abstract public void process(int x, int y);

	abstract public void processLine(int y);
}

