/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.drivers;

import java.io.File;
import java.io.IOException;
import java.net.ProtocolException;
import java.net.URL;

import org.gvsig.remoteClient.wms.WMSStatus;


/**
 * Interfaz Driver para WMS.
 *
 * @author $author$
 */
public interface WMSDriver {
	/**
	 * Obtiene las posibilidades del servidor a partir de una URL.
	 *
	 * @param server URL.
	 *
	 * @throws WMSException 
	 * @throws IOException 
	 * @throws ProtocolException 
	 */
	void getCapabilities(URL server)
		throws WMSException, IOException, ProtocolException;

	/**
	 * Devuelve la imagen a partir de MapQuery.
	 *
	 * @param mapQuery MapQuery.
	 *
	 * @return Image.
	 *
	 * @throws WMSException 
	 * @throws IOException 
	 * @throws ProtocolException 
	 */
	File getMap(WMSStatus mapQuery)
		throws WMSException, IOException, ProtocolException;

	//String getFeatureInfo(InfoQuery infoQuery) throws WMSException, IOException, ProtocolException;
}
