package com.iver.cit.gvsig.gui.panels;

import java.awt.Component;
import java.awt.Dimension;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;

import com.iver.cit.gvsig.fmap.layers.WMSLayerNode;
import com.iver.cit.gvsig.gui.beans.controls.dnd.JDnDList;

public class LayerList extends JDnDList {
	public boolean showLayerNames = false;
	private int count = 0; 
	public LayerList() {
		super();
		setCellRenderer(new MyRenderer());
	}
	
	private class MyRenderer extends DefaultListCellRenderer {
		public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
			super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
			if (value instanceof WMSLayerNode){
                WMSLayerNode layer = (WMSLayerNode) value;
                
                if (!showLayerNames) {
                	if (layer.getName() != null || layer.getName() == "") {
                		String text = layer.toString();
                		text = text.substring(text.indexOf(']')+2, text.length());
                		setText(text);
                	}
                }
                
                Dimension sz  = getPreferredSize();
                sz.setSize((sz.getWidth()+50) - (50*count), sz.getHeight());
                setPreferredSize(sz);
                count++;
            }  
			return this;
		}
	}
}
