/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.andami.ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JProgressBar;
import javax.swing.JWindow;

import com.iver.andami.messages.Messages;


/**
 * Clase del ui que consiste en una imagen y una barra de progreso
 */
public class SplashWindow extends JWindow  {
    /** DOCUMENT ME! */
    private static JProgressBar pb;
    private static JLabel lblStatus;

    /**
     * Creates a new SplashWindow object.
     *
     * @param filename ruta de la imagen que se quiere mostrar
     * @param f null
     */
    public SplashWindow(Frame f) {
        super(f);

        String logoName = Messages.get("SplashWindow.logo");
        if( logoName == null) {
        	logoName = "logo_en.png";
        }
        JLabel l = new JLabel(new ImageIcon(this.getClass().getClassLoader().getResource("images/"+logoName)));
        getContentPane().add(l, BorderLayout.CENTER);
        
        lblStatus = new JLabel(Messages.getString("SplashWindow.Iniciando"));
        lblStatus.setBorder(BorderFactory.createEtchedBorder());
        lblStatus.setBackground(Color.WHITE);
        pb = new JProgressBar();
        getContentPane().add(lblStatus, BorderLayout.NORTH);
        getContentPane().add(pb, BorderLayout.SOUTH);
        pack();

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension labelSize = l.getPreferredSize();
        setLocation((screenSize.width / 2) - (labelSize.width / 2),
            (screenSize.height / 2) - (labelSize.height / 2));
        setVisible(true);
    }

    /**
     * cierra la ventana
     */
    public void close() {
        setVisible(false);
        dispose();
    }

    /**
     * @see com.iver.mdiApp.ui.AppLoadingListener#process(int)
     */
    public static void process(int p, String str) {
        
        lblStatus.setText(str);
        // System.out.println("Porcentaje :" + p);
        if (pb.getValue() != p)
        {
        	pb.setValue(p);
        	pb.repaint();
        	// pb.paint(pb.getGraphics());
        }
    }
}
