/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.andami.ui.mdiFrame;

import com.iver.andami.plugins.PluginClassLoader;
import com.iver.andami.plugins.config.generate.Menu;

import java.awt.event.ActionListener;

import javax.swing.JComponent;


/**
 *
 */
public interface MainFrame {
	/**
	 * Aade el men a la barra de mens
	 *
	 * @param menu Texto del menu
	 * @param listener objeto que recibe los eventos del menu
	 * @param loader ClassLoader del plugin que instala el men
	 */
	public void addMenu(Menu menu, ActionListener listener,
		PluginClassLoader loader);

	/**
	 * Cambia el nombre completo del menu, y por tanto su ubicacin. El array
	 * de strings representa la ruta  completa del men. por ejemplo un array
	 * {"ver", "ventanas", "consola"} referencia al men que se encuentra en
	 * ver/ventanas/consola. Hay que tener en cuenta que los elementos en el
	 * array son claves en el fichero de traducciones del plugin
	 *
	 * @param menu Ruta completa del men
	 * @param newName Nuevo nombre del menu
	 * @param loader ClassLoader del plugin que aadi el menu
	 *
	 * @throws NoSuchMenuException Si no existe ningn menu en la
	 * ruta menu
	 */
	public void changeMenuName(String[] menu, String newName,
		PluginClassLoader loader) throws NoSuchMenuException;

	/**
	 * Elimina el men que se pasa como parmetro si est aadido. Si no se
	 * encuentra el men no se hace nada
	 *
	 * @param menu referencia al men que se quiere eliminar
	 */
	public void removeMenu(Menu menu);

	/**
	 * Itera por los controles preguntando a las extensiones si estos estn
	 * habilitados y visibles
	 */
	public void enableControls();

	/**
	 * Sirve para establecec el mensaje en la barra de estado asociado a una etiqueta
	 *
	 * @return main StatusBar 
	 */
	public NewStatusBar getStatusBar();
	/**
	 * DOCUMENT ME!
	 *
	 * @param titulo DOCUMENT ME!
	 */
	public void setTitle(String titulo);
    
    /**
     * Get a JComponent previously added by name. For example
     * you can use it if you need to obtain a JToolBar to
     * add some customized component.
     * @param name
     * @return the JComponent or null if none has been found
     */
    public JComponent getComponentByName(String name);
    
}
