/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.io.raster;

import java.util.ArrayList;


/**
 * Interfaz que deben implementar los Gestores de pila de filtros
 * @author Nacho Brodin (brodin_ign@gva.es)
 *
 */
public interface IStackManager {
    /**
     * Convierte cada filtro o elemento de un filtro de la pila en un String de la forma
     * elemento=valor
     * @return ArrayList donde cada elemento es una cadena
     */
    public ArrayList getStringsFromStack();

    /**
     * Crea una pila de filtros a partir de un Array de Strings. Cada elemento del array debe
     * tener la forma elemento=valor.
     * @param filters
     */
    public void createStackFromStrings(ArrayList f, Integer pos);
}
