/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.ui;

import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;


/**
 * @author Luis W. Sevilla (sevilla_lui@gva.es)
 */
public class DefaultDialogPanel extends JPanel {
    final private static long serialVersionUID = -3370601314380922368L;
    protected JPanel contentPane = null;
    private JPanel tabPane = null;
    private JPanel buttonPane = null;
    private JButton acceptButton = null;
    private JButton cancelButton = null;
    private JButton applyButton = null;

    /**
     * Constructor
     */
    public DefaultDialogPanel() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     *
     * @return void
     */
    private void initialize() {
        //setBounds(0,0,321,230);
        //javax.swing.BoxLayout(jContentPane, javax.swing.BoxLayout.Y_AXIS);
        //jContentPane.setLayout(new java.awt.GridLayout(2,1));
        setLayout(new FlowLayout());
        setBorder(javax.swing.BorderFactory.createEmptyBorder(5, 5, 5, 5));

        //jContentPane.setSize(30, 24);
        this.setPreferredSize(new java.awt.Dimension(320, 165));
        add(getTabPanel(), null);
        add(getButtonPanel(), null);
    }

    /**
     * Obtiene el panel general
     * @return
     */
    protected JPanel getContentPanel() {
        if (contentPane == null) {
            contentPane = new JPanel();
            contentPane.setBounds(6, 200, 309, 125);
            contentPane.setPreferredSize(new java.awt.Dimension(310, 100));
        }

        return contentPane;
    }

    private JPanel getTabPanel() {
        if (tabPane == null) {
            tabPane = new JPanel();
            setLayout(new FlowLayout());

            //tabPane.setBounds(6, 7, 309, 189);
            tabPane.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.SoftBevelBorder.RAISED));
            tabPane.add(getContentPanel(), null);
        }

        return tabPane;
    }

    /**
     * Obtiene el panel que contiene los botones de Aceptar, Cancelar y Aplicar 
     * @return
     */
    protected JPanel getButtonPanel() {
        if (buttonPane == null) {
            java.awt.FlowLayout flowLayout2 = new FlowLayout();
            buttonPane = new JPanel();
            buttonPane.setLayout(flowLayout2);
            buttonPane.setSize(309, 25);
            buttonPane.setBounds(6, 200, 309, 25);
            flowLayout2.setHgap(0);
            flowLayout2.setAlignment(java.awt.FlowLayout.RIGHT);
            flowLayout2.setVgap(1);
            buttonPane.add(getAcceptButton(), null);

            JLabel lbl1 = new JLabel();
            lbl1.setPreferredSize(new java.awt.Dimension(18, 23));
            buttonPane.add(lbl1);
            buttonPane.add(getCancelButton(), null);

            JLabel lbl2 = new JLabel();
            lbl2.setPreferredSize(new java.awt.Dimension(18, 23));
            buttonPane.add(lbl2);
            buttonPane.add(getApplyButton(), null);
        }

        return buttonPane;
    }

    /**
     * This method initializes Accept button
     *
     * @return javax.swing.JButton
     */
    public JButton getAcceptButton() {
        if (acceptButton == null) {
            acceptButton = new JButton("Aceptar");
            acceptButton.setText("Aceptar");
        }

        return acceptButton;
    }

    /**
     * This method initializes Cancel Button
     *
     * @return javax.swing.JButton
     */
    public JButton getCancelButton() {
        if (cancelButton == null) {
            cancelButton = new JButton("Cancelar");
            cancelButton.setText("Cancelar");
        }

        return cancelButton;
    }

    /**
     * This method initializes Apply Button
     *
     * @return javax.swing.JButton
     */
    public JButton getApplyButton() {
        if (applyButton == null) {
            applyButton = new JButton("Aplicar");
        }

        return applyButton;
    }
}
