/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.ui.raster;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.plaf.basic.BasicComboBoxEditor;

import org.cresques.cts.IProjection;


/**
 * Panel que contiene los controles del dialogo de salvar a raster.
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class DataInputSaveRaster extends JPanel {
    final private static long 	serialVersionUID = -3370601314380922368L;
    private JPanel 				jPanel = null;
    private JPanel 				coordenadas = null;
    private JPanel 				pSupIzq = null;
    private JPanel 				pInfDer = null;
    private double				widthSelection = 0D, heightSelection = 0D;
    private IProjection			proj = null;
    private int					widthInPixelsGeodesicas = 0;
    private int					heightInPixelsGeodesicas = 0;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lSupIzq = null;
    private JTextField tSupIzqX = null;
    private JTextField tSupIzqY = null;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lInfDer = null;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lY = null;
    private JTextField tInfDerX = null;
    private JTextField tInfDerY = null;
    private JPanel pDatosImagen = null;
    private JPanel pDatosFichero = null;
    private JPanel pEscalaRes = null;
    private JPanel pNombre = null;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lEscala = null;
    private JTextField tEscala = null;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lFile = null;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lResolucion = null;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lPpp = null;
    private DefaultComboBoxModel defaultComboBoxModel = null;
    private BasicComboBoxEditor basicComboBoxEditor = null;
    private String string = null;
    private JComboBox jComboBox = null;

    /**
     * Control accesible para su traduccin
     */
    public JButton bSeleccion = null;
    private JPanel pAnchoAlto = null;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lAncho = null;

    /**
     * Control accesible para su traduccin
     */
    public JLabel lAlto = null;
    private JTextField tAncho = null;
    private JTextField tAlto = null;

    /**
     * Control accesible para su traduccin
     */
    public JButton bPropiedades = null;

    /**
     * Constructor. Inicializa el panel.
     *
     */
    public DataInputSaveRaster() {
        super();
        initialize();
    }

    /**
     * Inicializa el panel.
     *
     */
    private void initialize() {
        this.setLayout(new BorderLayout());
        this.setSize(350, 208); //AnchoxAlto panel interior
        this.add(getJPanel(), java.awt.BorderLayout.CENTER);
    }

    /**
     * This method initializes jPanel
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel() {
        if (jPanel == null) {
            jPanel = new JPanel();
            jPanel.setLayout(new BorderLayout());
            jPanel.add(getCoordenadas(), java.awt.BorderLayout.NORTH);
            jPanel.add(getDatosImagen(), java.awt.BorderLayout.CENTER);
            jPanel.add(getDatosFichero(), java.awt.BorderLayout.SOUTH);
        }

        return jPanel;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getCoordenadas() {
        if (coordenadas == null) {
            coordenadas = new JPanel();
            coordenadas.setLayout(new BorderLayout());
            coordenadas.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
            coordenadas.add(getPsup_izq(), java.awt.BorderLayout.NORTH);
            coordenadas.add(getPinf_der(), java.awt.BorderLayout.SOUTH);
        }

        return coordenadas;
    }

    /**
     * This method initializes jPanel2
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPsup_izq() {
        if (pSupIzq == null) {
            lSupIzq = new JLabel();
            lY = new JLabel();
            pSupIzq = new JPanel();

            FlowLayout flowLayout1 = new FlowLayout();
            pSupIzq.setLayout(flowLayout1);
            lSupIzq.setText("Sup. izq. X:");
            lY.setText(" Y:");
            flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
            flowLayout1.setHgap(5);
            pSupIzq.setAlignmentY(0.5F);
            pSupIzq.add(lSupIzq, null);
            pSupIzq.add(getTsup_izqX(), null);
            pSupIzq.add(lY, null);
            pSupIzq.add(getTsup_izqY(), null);
        }

        return pSupIzq;
    }

    /**
     * This method initializes jPanel3
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPinf_der() {
        if (pInfDer == null) {
        	lInfDer = new JLabel();
            pInfDer = new JPanel();
            lY= new JLabel();

            FlowLayout flowLayout2 = new FlowLayout();
            pInfDer.setLayout(flowLayout2);
            lY.setText(" Y:");
            lInfDer.setText("Inf. der.  X:");
            flowLayout2.setAlignment(java.awt.FlowLayout.LEFT);
            pInfDer.add(lInfDer, null);
            pInfDer.add(getTinf_derX(), null);
            pInfDer.add(lY, null);
            pInfDer.add(getTinf_derY(), null);
        }

        return pInfDer;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTsup_izqX() {
        if (tSupIzqX == null) {
        	tSupIzqX = new JTextField();
        	tSupIzqX.setPreferredSize(new java.awt.Dimension(110, 19));
        	tSupIzqX.setText("0");
        	tSupIzqX.setMinimumSize(new java.awt.Dimension(110, 19));
        }

        return tSupIzqX;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTsup_izqY() {
        if (tSupIzqY == null) {
        	tSupIzqY = new JTextField();
        	tSupIzqY.setMinimumSize(new java.awt.Dimension(110, 19));
        	tSupIzqY.setPreferredSize(new java.awt.Dimension(110, 19));
        	tSupIzqY.setText("0");
        }

        return tSupIzqY;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTinf_derX() {
        if (tInfDerX == null) {
        	tInfDerX = new JTextField();
        	tInfDerX.setMinimumSize(new java.awt.Dimension(110, 19));
        	tInfDerX.setPreferredSize(new java.awt.Dimension(110, 19));
        	tInfDerX.setText("0");
        }

        return tInfDerX;
    }

    /**
     * This method initializes jTextField1
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTinf_derY() {
        if (tInfDerY == null) {
        	tInfDerY = new JTextField();
        	tInfDerY.setMinimumSize(new java.awt.Dimension(110, 19));
        	tInfDerY.setPreferredSize(new java.awt.Dimension(110, 19));
        	tInfDerY.setText("0");
        }

        return tInfDerY;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getDatosImagen() {
        if (pDatosImagen == null) {
            BorderLayout borderLayout1 = new BorderLayout();
            pDatosImagen = new JPanel();
            pDatosImagen.setLayout(borderLayout1);
            pDatosImagen.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,
                                                                             1));
            pDatosImagen.setAlignmentY(0.5F);
            borderLayout1.setHgap(0);
            borderLayout1.setVgap(0);
            pDatosImagen.add(getPescalaRes(), java.awt.BorderLayout.NORTH);
            pDatosImagen.add(getPanchoAlto(), java.awt.BorderLayout.SOUTH);
        }

        return pDatosImagen;
    }

    /**
     * This method initializes jPanel2
     *
     * @return javax.swing.JPanel
     */
    private JPanel getDatosFichero() {
        if (pDatosFichero == null) {
        	pDatosFichero = new JPanel();
        	pDatosFichero.setLayout(new BorderLayout());
        	pDatosFichero.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        	pDatosFichero.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        	pDatosFichero.add(getPnombre(), java.awt.BorderLayout.CENTER);
        }

        return pDatosFichero;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPescalaRes() {
        if (pEscalaRes == null) {
            lEscala = new JLabel();
            lResolucion = new JLabel();
            lPpp = new JLabel();

            FlowLayout flowLayout3 = new FlowLayout();
            pEscalaRes = new JPanel();
            pEscalaRes.setLayout(flowLayout3);
            lEscala.setText("Escala  1:");
            lResolucion.setText("Resolucin");
            lPpp.setText("ppp");
            lResolucion.setName("");
            flowLayout3.setAlignment(java.awt.FlowLayout.LEFT);
            flowLayout3.setVgap(20);
            pEscalaRes.add(lEscala, null);
            pEscalaRes.add(getTescala(), null);
            pEscalaRes.add(lResolucion, null);
            pEscalaRes.add(getJComboBox(), null);
            pEscalaRes.add(lPpp, null);
        }

        return pEscalaRes;
    }

    /**
     * This method initializes jPanel3
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnombre() {
        if (pNombre == null) {
            lFile = new JLabel();
            pNombre = new JPanel();

            FlowLayout flowLayout4 = new FlowLayout();
            pNombre.setLayout(flowLayout4);
            lFile.setText("Fichero");
            flowLayout4.setAlignment(java.awt.FlowLayout.LEFT);
            pNombre.add(lFile, null);
            pNombre.add(getBseleccion(), null);
            pNombre.add(this.getBPropiedades(), null);
            this.getBPropiedades().setText("Propiedades GeoTiff");
        }

        return pNombre;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTescala() {
        if (tEscala == null) {
            tEscala = new JTextField();
            tEscala.setMinimumSize(new java.awt.Dimension(70, 19));
            tEscala.setPreferredSize(new java.awt.Dimension(80, 19));
            tEscala.setText("0");
        }

        return tEscala;
    }

    private Object makeObj(final String item) {
        return new Object() {
                public String toString() {
                    return item;
                }
            };
    }

    /**
     * This method initializes defaultComboBoxModel
     *
     * @return javax.swing.DefaultComboBoxModel
     */
    private DefaultComboBoxModel getDefaultComboBoxModel() {
        if (defaultComboBoxModel == null) {
            defaultComboBoxModel = new DefaultComboBoxModel();
        }

        return defaultComboBoxModel;
    }

    /**
     * This method initializes basicComboBoxEditor
     *
     * @return javax.swing.plaf.basic.BasicComboBoxEditor
     */
    private BasicComboBoxEditor getBasicComboBoxEditor() {
        if (basicComboBoxEditor == null) {
            basicComboBoxEditor = new BasicComboBoxEditor();
            basicComboBoxEditor.setItem(getString());
        }

        return basicComboBoxEditor;
    }

    /**
     * This method initializes string
     *
     * @return java.lang.String
     */
    private String getString() {
        if (string == null) {
            string = new String();
        }

        return string;
    }

    /**
     * This method initializes jComboBox
     *
     * @return javax.swing.JComboBox
     */
    public JComboBox getJComboBox() {
        if (jComboBox == null) {
            String[] lista = { "75", "150", "300" };
            jComboBox = new JComboBox(lista);
            jComboBox.setPreferredSize(new java.awt.Dimension(70, 24));
        }

        return jComboBox;
    }

    /**
     * This method initializes jComboBox
     *
     * @return javax.swing.JComboBox
     */
    public JButton getBPropiedades() {
        if (bPropiedades == null) {
            bPropiedades = new JButton();
        }

        return bPropiedades;
    }

    /**
     * This method initializes jButton
     *
     * @return javax.swing.JButton
     */
    public JButton getBseleccion() {
        if (bSeleccion == null) {
            bSeleccion = new JButton();
            bSeleccion.setText("Seleccionar");
        }

        return bSeleccion;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPanchoAlto() {
        if (pAnchoAlto == null) {
        	lAlto = new JLabel();
            lAncho = new JLabel();

            FlowLayout flowLayout5 = new FlowLayout();
            pAnchoAlto = new JPanel();
            pAnchoAlto.setLayout(flowLayout5);
            lAncho.setText("Ancho.");
            flowLayout5.setAlignment(java.awt.FlowLayout.LEFT);
            flowLayout5.setVgap(20);
            lAlto.setText("Alto.");
            pAnchoAlto.add(lAncho, null);
            pAnchoAlto.add(getTancho(), null);
            pAnchoAlto.add(lAlto, null);
            pAnchoAlto.add(getTalto(), null);
        }

        return pAnchoAlto;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTancho() {
        if (tAncho == null) {
            tAncho = new JTextField();
            tAncho.setPreferredSize(new java.awt.Dimension(80, 19));
            tAncho.setEditable(false);
            tAncho.setText("0");
        }

        return tAncho;
    }

    /**
     * This method initializes jTextField1
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTalto() {
        if (tAlto == null) {
            tAlto = new JTextField();
            tAlto.setPreferredSize(new java.awt.Dimension(80, 19));
            tAlto.setText("0");
            tAlto.setEditable(false);
        }

        return tAlto;
    }

	/**
	 * Asigna el ancho y el alto en metros de la seleccin hecha en la vista
	 * por el rectangulo de salvar a raster
	 */
	public void setSizeSelection(double	w, double h){
		this.widthSelection = w;
		this.heightSelection = h;
	}

	/**
	 * Obtiene el ancho de la seleccin en metros
	 * @return
	 */
	public double getWidthSelection() {
		return widthSelection;
	}

	/**
	 * Obtiene el alto de la seleccin en metros
	 * @return
	 */
	public double getHeightSelection() {
		return heightSelection;
	}
	
	/**
	 * Asigna la proyeccin 
	 * @param proj Interfaz IProjection
	 */
	public void setProjection(IProjection proj){
		this.proj = proj;
	}
	
	/**
	 * Obtiene la proyeccin
	 * @return Interfaz IProjection
	 */
	public IProjection getProjection(){
		return proj;
	}

	/**
	 * 
	 * @return
	 */
	public int getWidthInPixelsGeodesicas() {
		return widthInPixelsGeodesicas;
	}

	/**
	 * 
	 * @param widthInPixelsWG84
	 */
	public void setWidthInPixelsGeodesicas(int widthInPixelsGeodesicas) {
		this.widthInPixelsGeodesicas = widthInPixelsGeodesicas;
	}
	
	/**
	 * 
	 * @return
	 */
	public int getHeightInPixelsGeodesicas() {
		return heightInPixelsGeodesicas;
	}

	/**
	 * 
	 * @param widthInPixelsWG84
	 */
	public void setHeightInPixelsGeodesicas(int heightInPixelsGeodesicas) {
		this.heightInPixelsGeodesicas = heightInPixelsGeodesicas;
	}

}
