/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.ui.raster;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.plaf.basic.BasicComboBoxEditor;


/**
 * Panel que contiene los elementos para el dialogo de salvar a raster
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class DataInputSaveRasterProps extends JPanel {
    final private static long serialVersionUID = -3370601314380922368L;
    private JPanel jPanel = null;
    private JPanel coordenadas = null;
    private JPanel psup_izq = null;
    private JPanel pinf_der = null;
    private JLabel lsup_izq = null;
    private JTextField tsup_izqX = null;
    private JTextField tsup_izqY = null;
    private JLabel linf_der = null;
    private JLabel y = null;
    private JTextField tinf_derX = null;
    private JTextField tinf_derY = null;
    private JPanel datosImagen = null;
    private JPanel datosFichero = null;
    private JPanel pescalaRes = null;
    private JPanel pnombre = null;
    private JLabel lescala = null;
    private JTextField tescala = null;
    private JLabel lfile = null;
    private JLabel lresolucion = null;
    private JLabel lppp = null;
    private DefaultComboBoxModel defaultComboBoxModel = null;
    private BasicComboBoxEditor basicComboBoxEditor = null;
    private String string = null;
    private JComboBox jComboBox = null;
    private JButton bseleccion = null;
    private JPanel panchoAlto = null;
    private JLabel lancho = null;
    private JLabel jLabel2 = null;
    private JTextField tancho = null;
    private JTextField talto = null;
    private JButton bcompresion = null;

    /**
     * Constructor. Inicializa el panel.
     *
     */
    public DataInputSaveRasterProps() {
        super();
        initialize();
    }

    private void initialize() {
        this.setLayout(new BorderLayout());
        this.setSize(350, 208); //AnchoxAlto panel interior
        this.add(getJPanel(), java.awt.BorderLayout.CENTER);
    }

    /**
     * This method initializes jPanel
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel() {
        if (jPanel == null) {
            jPanel = new JPanel();
            jPanel.setLayout(new BorderLayout());
            jPanel.add(getCoordenadas(), java.awt.BorderLayout.NORTH);
            jPanel.add(getDatosImagen(), java.awt.BorderLayout.CENTER);
            jPanel.add(getDatosFichero(), java.awt.BorderLayout.SOUTH);
        }

        return jPanel;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getCoordenadas() {
        if (coordenadas == null) {
            coordenadas = new JPanel();
            coordenadas.setLayout(new BorderLayout());
            coordenadas.setBorder(javax.swing.BorderFactory.createEmptyBorder(0,
                                                                              0,
                                                                              0,
                                                                              0));
            coordenadas.add(getPsup_izq(), java.awt.BorderLayout.NORTH);
            coordenadas.add(getPinf_der(), java.awt.BorderLayout.SOUTH);
        }

        return coordenadas;
    }

    /**
     * This method initializes jPanel2
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPsup_izq() {
        if (psup_izq == null) {
            lsup_izq = new JLabel();
            y = new JLabel();
            psup_izq = new JPanel();

            FlowLayout flowLayout1 = new FlowLayout();
            psup_izq.setLayout(flowLayout1);
            lsup_izq.setText("Sup. izq. X:");
            y.setText(" Y:");
            flowLayout1.setAlignment(java.awt.FlowLayout.LEFT);
            flowLayout1.setHgap(5);
            psup_izq.setAlignmentY(0.5F);
            psup_izq.add(lsup_izq, null);
            psup_izq.add(getTsup_izqX(), null);
            psup_izq.add(y, null);
            psup_izq.add(getTsup_izqY(), null);
        }

        return psup_izq;
    }

    /**
     * This method initializes jPanel3
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPinf_der() {
        if (pinf_der == null) {
            linf_der = new JLabel();
            pinf_der = new JPanel();
            y = new JLabel();

            FlowLayout flowLayout2 = new FlowLayout();
            pinf_der.setLayout(flowLayout2);
            y.setText(" Y:");
            linf_der.setText("Inf. der.  X:");
            flowLayout2.setAlignment(java.awt.FlowLayout.LEFT);
            pinf_der.add(linf_der, null);
            pinf_der.add(getTinf_derX(), null);
            pinf_der.add(y, null);
            pinf_der.add(getTinf_derY(), null);
        }

        return pinf_der;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTsup_izqX() {
        if (tsup_izqX == null) {
            tsup_izqX = new JTextField();
            tsup_izqX.setPreferredSize(new java.awt.Dimension(110, 19));
            tsup_izqX.setText("0");
            tsup_izqX.setMinimumSize(new java.awt.Dimension(110, 19));
        }

        return tsup_izqX;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTsup_izqY() {
        if (tsup_izqY == null) {
            tsup_izqY = new JTextField();
            tsup_izqY.setMinimumSize(new java.awt.Dimension(110, 19));
            tsup_izqY.setPreferredSize(new java.awt.Dimension(110, 19));
            tsup_izqY.setText("0");
        }

        return tsup_izqY;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTinf_derX() {
        if (tinf_derX == null) {
            tinf_derX = new JTextField();
            tinf_derX.setMinimumSize(new java.awt.Dimension(110, 19));
            tinf_derX.setPreferredSize(new java.awt.Dimension(110, 19));
            tinf_derX.setText("0");
        }

        return tinf_derX;
    }

    /**
     * This method initializes jTextField1
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTinf_derY() {
        if (tinf_derY == null) {
            tinf_derY = new JTextField();
            tinf_derY.setMinimumSize(new java.awt.Dimension(110, 19));
            tinf_derY.setPreferredSize(new java.awt.Dimension(110, 19));
            tinf_derY.setText("0");
        }

        return tinf_derY;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getDatosImagen() {
        if (datosImagen == null) {
            BorderLayout borderLayout1 = new BorderLayout();
            datosImagen = new JPanel();
            datosImagen.setLayout(borderLayout1);
            datosImagen.setBorder(javax.swing.BorderFactory.createLineBorder(java.awt.Color.gray,
                                                                             1));
            datosImagen.setAlignmentY(0.5F);
            borderLayout1.setHgap(0);
            borderLayout1.setVgap(0);
            datosImagen.add(getPescalaRes(), java.awt.BorderLayout.NORTH);
            datosImagen.add(getPanchoAlto(), java.awt.BorderLayout.SOUTH);
        }

        return datosImagen;
    }

    /**
     * This method initializes jPanel2
     *
     * @return javax.swing.JPanel
     */
    private JPanel getDatosFichero() {
        if (datosFichero == null) {
            datosFichero = new JPanel();
            datosFichero.setLayout(new BorderLayout());
            datosFichero.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
            datosFichero.setBorder(javax.swing.BorderFactory.createEmptyBorder(0,
                                                                               0,
                                                                               0,
                                                                               0));
            datosFichero.add(getPnombre(), java.awt.BorderLayout.CENTER);
        }

        return datosFichero;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPescalaRes() {
        if (pescalaRes == null) {
            lescala = new JLabel();
            lresolucion = new JLabel();
            lppp = new JLabel();

            FlowLayout flowLayout3 = new FlowLayout();
            pescalaRes = new JPanel();
            pescalaRes.setLayout(flowLayout3);
            lescala.setText("Escala  1:");
            lresolucion.setText("Resolucin");
            lppp.setText("ppp");
            lresolucion.setName("");
            flowLayout3.setAlignment(java.awt.FlowLayout.LEFT);
            flowLayout3.setVgap(20);
            pescalaRes.add(lescala, null);
            pescalaRes.add(getTescala(), null);
            pescalaRes.add(lresolucion, null);
            pescalaRes.add(getJComboBox(), null);
            pescalaRes.add(lppp, null);
        }

        return pescalaRes;
    }

    /**
     * This method initializes jPanel3
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPnombre() {
        if (pnombre == null) {
            lfile = new JLabel();
            pnombre = new JPanel();

            FlowLayout flowLayout4 = new FlowLayout();
            pnombre.setLayout(flowLayout4);
            lfile.setText("Fichero");
            flowLayout4.setAlignment(java.awt.FlowLayout.LEFT);
            pnombre.add(lfile, null);
            pnombre.add(getBseleccion(), null);
            pnombre.add(this.getBCompresion(), null);
            this.getBCompresion().setText("Propiedades GeoTiff");
        }

        return pnombre;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTescala() {
        if (tescala == null) {
            tescala = new JTextField();
            tescala.setMinimumSize(new java.awt.Dimension(70, 19));
            tescala.setPreferredSize(new java.awt.Dimension(80, 19));
            tescala.setText("0");
        }

        return tescala;
    }

    private Object makeObj(final String item) {
        return new Object() {
                public String toString() {
                    return item;
                }
            };
    }

    /**
     * This method initializes defaultComboBoxModel
     *
     * @return javax.swing.DefaultComboBoxModel
     */
    private DefaultComboBoxModel getDefaultComboBoxModel() {
        if (defaultComboBoxModel == null) {
            defaultComboBoxModel = new DefaultComboBoxModel();
        }

        return defaultComboBoxModel;
    }

    /**
     * This method initializes basicComboBoxEditor
     *
     * @return javax.swing.plaf.basic.BasicComboBoxEditor
     */
    private BasicComboBoxEditor getBasicComboBoxEditor() {
        if (basicComboBoxEditor == null) {
            basicComboBoxEditor = new BasicComboBoxEditor();
            basicComboBoxEditor.setItem(getString());
        }

        return basicComboBoxEditor;
    }

    /**
     * This method initializes string
     *
     * @return java.lang.String
     */
    private String getString() {
        if (string == null) {
            string = new String();
        }

        return string;
    }

    /**
     * This method initializes jComboBox
     *
     * @return javax.swing.JComboBox
     */
    public JComboBox getJComboBox() {
        if (jComboBox == null) {
            String[] lista = { "75", "150", "300" };
            jComboBox = new JComboBox(lista);
            jComboBox.setPreferredSize(new java.awt.Dimension(70, 24));
        }

        return jComboBox;
    }

    /**
     * This method initializes jComboBox
     *
     * @return javax.swing.JComboBox
     */
    public JButton getBCompresion() {
        if (bcompresion == null) {
            bcompresion = new JButton();
        }

        return bcompresion;
    }

    /**
     * This method initializes jButton
     *
     * @return javax.swing.JButton
     */
    public JButton getBseleccion() {
        if (bseleccion == null) {
            bseleccion = new JButton();
            bseleccion.setText("Seleccionar");
        }

        return bseleccion;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getPanchoAlto() {
        if (panchoAlto == null) {
            jLabel2 = new JLabel();
            lancho = new JLabel();

            FlowLayout flowLayout5 = new FlowLayout();
            panchoAlto = new JPanel();
            panchoAlto.setLayout(flowLayout5);
            lancho.setText("Ancho.");
            flowLayout5.setAlignment(java.awt.FlowLayout.LEFT);
            flowLayout5.setVgap(20);
            jLabel2.setText("Alto.");
            panchoAlto.add(lancho, null);
            panchoAlto.add(getTancho(), null);
            panchoAlto.add(jLabel2, null);
            panchoAlto.add(getTalto(), null);
        }

        return panchoAlto;
    }

    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTancho() {
        if (tancho == null) {
            tancho = new JTextField();
            tancho.setPreferredSize(new java.awt.Dimension(80, 19));
            tancho.setEditable(false);
            tancho.setText("0");
        }

        return tancho;
    }

    /**
     * This method initializes jTextField1
     *
     * @return javax.swing.JTextField
     */
    public JTextField getTalto() {
        if (talto == null) {
            talto = new JTextField();
            talto.setPreferredSize(new java.awt.Dimension(80, 19));
            talto.setText("0");
            talto.setEditable(false);
        }

        return talto;
    }
}
