/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.ui.raster;

import java.awt.BorderLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;


/**
 * Panel que contiene la barra de progreso para salvar a raster
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class ProgressSaveRasterPanel extends JPanel {
    final private static long serialVersionUID = -3370601314380922368L;
    private JPanel jPanel = null;
    private JProgressBar jProgressBar = null;

    /**
     * Variable accesible para la traduccin
     */
    public JLabel lwait = null;
    private JPanel jPanel2 = null;
    private JPanel jPanel1 = null;

    /**
     * This method initializes
     *
     */
    public ProgressSaveRasterPanel() {
        super();
        initialize();
    }

    /**
     * This method initializes this
     *
     * @return void
     */
    private void initialize() {
        this.setSize(369, 106);
        this.add(getJPanel(), null);
    }

    /**
     * This method initializes jPanel
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel() {
        if (jPanel == null) {
            lwait = new JLabel();
            jPanel = new JPanel();
            jPanel.setLayout(new BorderLayout());
            jPanel.setPreferredSize(new java.awt.Dimension(354, 70));
            lwait.setText("Por favor, espere ...");
            jPanel.add(lwait, java.awt.BorderLayout.NORTH);
            jPanel.add(getJPanel2(), java.awt.BorderLayout.SOUTH);
            jPanel.add(getJPanel1(), java.awt.BorderLayout.CENTER);
        }

        return jPanel;
    }

    /**
     * This method initializes jProgressBar
     *
     * @return javax.swing.JProgressBar
     */
    public JProgressBar getJProgressBar() {
        if (jProgressBar == null) {
            jProgressBar = new JProgressBar();
            jProgressBar.setVisible(true);
            jProgressBar.show();
            jProgressBar.setValue(0);
            jProgressBar.setPreferredSize(new java.awt.Dimension(350, 25));
        }

        return jProgressBar;
    }

    /**
     * This method initializes jPanel2
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel2() {
        if (jPanel2 == null) {
            jPanel2 = new JPanel();
            jPanel2.add(getJProgressBar(), null);
        }

        return jPanel2;
    }

    /**
     * This method initializes jPanel1
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel1() {
        if (jPanel1 == null) {
            jPanel1 = new JPanel();
        }

        return jPanel1;
    }
} //  @jve:decl-index=0:visual-constraint="10,10"
