/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.ui.raster;

import org.cresques.ui.DefaultDialogPanel;

import javax.swing.JPanel;


/**
 * Panel que contiene los botones de Aceptar, Cancelar y Aplicar heredando de
 * DefaultDialogPanel. Dentro de este estar el panel con los controles de
 * salvar a raster.
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class SaveRasterDialogPanel extends DefaultDialogPanel {
    final private static long serialVersionUID = -3370601314380922368L;

    public SaveRasterDialogPanel() {
        super();
        initialize();
    }

    /**
     * Inicializacin del panel.
     * @return void
     */
    protected void initialize() {
        this.setBounds(0, 0, 355, 230);

        //Ocultamos el botn de aplicar
        this.getApplyButton().setVisible(false);
    }

    /**
     * Obtiene el panel con los controles de Salvar a Raster.
     * @return
     */
    public JPanel getContentPanel() {
        if (contentPane == null) {
            contentPane = new SaveSetupPanel();
            contentPane.setBounds(14, 12, 345, 174);
            ((SaveSetupPanel) contentPane).setDialogPanel(this);
        }

        return contentPane;
    }
}
