/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.ui.raster;

import org.cresques.io.GeoRasterWriter;

import org.cresques.ui.DefaultDialogPanel;

import javax.swing.JPanel;


/**
 * Panel que contiene el panel de propiedades del salvado a raster
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class SaveRasterPropsDialogPanel extends DefaultDialogPanel {
    final private static long serialVersionUID = -3370601314380922368L;
    private GeoRasterWriter writer = null;
    private String formato = null;

    /**
     * Constructor.
     * @param writer
     */
    public SaveRasterPropsDialogPanel(GeoRasterWriter writer) {
        super();
        this.writer = writer;
        this.formato = writer.getIdent();

        if (contentPane != null) {
            ((SavePropsSetupPanel) contentPane).setWriter(writer);
        }

        initialize();
    }

    /**
     * This method initializes this
     * @return void
     */
    protected void initialize() {
        //super.initialize();
        this.setBounds(0, 0, 355, 230);

        //Ocultamos el botn de aplicar
        this.getApplyButton().setVisible(false);
    }

    /**
     * This method obtain the SavePropsSetupPanel
     */
    public JPanel getContentPanel() {
        if (contentPane == null) {
            contentPane = new SavePropsSetupPanel();
            contentPane.setBounds(14, 12, 345, 174);
            ((SavePropsSetupPanel) contentPane).setDialogPanel(this);
        }

        return contentPane;
    }
}
