package com.iver.cit.gvsig.fmap.edition;

import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.layers.VectorialFileAdapter;


/**
 * Fuente de datos de fichero editable
 */
public class FileEditableFeatureSource implements OriginalFeatureAdapter {
	private VectorialFileAdapter featureSource;

	/**
	 * Crea un nuevo FileEditableFeatureSource.
	 *
	 * @param vfa DOCUMENT ME!
	 */
	public FileEditableFeatureSource(VectorialFileAdapter vfa) {
		featureSource = vfa;
	}

	/**
	 * Mtodo invocado cuando se comienza la edicin, para poner en marcha las
	 * estructuras de datos necesarias para la misma, notificar al servidor en
	 * protocolos en los que sea necesario, ...
	 *
	 * @throws EditionException
	 */
	public void startEdition() throws EditionException {
		/*TODO descomentar esto
		try {
			featureSource.start();
		} catch (DriverIOException e) {
			throw new EditionException(e);
		}
		*/
	}

	/**
	 * Invocado cuando termina la edicin. En funcin de la clase concreta que
	 * implemente este mtodo se generar el fichero con los resultados de la
	 * edicin, se realizar una transaccin a la base de datos, etc.
	 *
	 * @throws EditionException
	 */
	public void stopEdition() throws EditionException {
		/*TODO descomentar esto
		try {
			featureSource.stop();
		} catch (DriverIOException e) {
			throw new EditionException(e);
		}
		*/
		//Crear nuevo fichero shape.
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 *
	 * @throws DriverIOException
	 *
	 * @see com.iver.cit.gvsig.fmap.edition.OriginalFeatureAdapter#getGeometryCount()
	 */
	public int getGeometryCount() throws DriverIOException {
		return featureSource.getShapeCount();
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param index DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 *
	 * @throws DriverIOException
	 *
	 * @see com.iver.cit.gvsig.fmap.edition.OriginalFeatureAdapter#getGeometry(int)
	 */
	public IGeometry getGeometry(int index) throws DriverIOException {
		return featureSource.getShape(index);
	}
}
