/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.edition;

import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;


/**
 * DOCUMENT ME!
 *
 * @author Vicente Caballero Navarro
 */
public interface OriginalFeatureAdapter {
	/**
	 * Devuelve el nmero de geometras totales que se contienen en origen.
	 *
	 * @return Numero de geoemetras en origen.
	 *
	 * @throws DriverIOException
	 */
	public int getGeometryCount() throws DriverIOException;

	/**
	 * Mtodo invocado cuando se comienza la edicin, para poner en marcha las
	 * estructuras de datos necesarias para la misma, notificar al servidor en
	 * protocolos en los que sea necesario, ...
	 *
	 * @throws EditionException
	 */
	public void startEdition() throws EditionException;

	/**
	 * Invocado cuando termina la edicin. En funcin de la clase concreta que
	 * implemente este mtodo se generar el fichero con los resultados de la
	 * edicin, se realizar una transaccin a la base de datos, etc.
	 *
	 * @throws EditionException DOCUMENT ME!
	 */
	public void stopEdition() throws EditionException;

	/**
	 * Devuelve la geometra accediendo al adapter.
	 *
	 * @param index ndice.
	 *
	 * @return Geometra.
	 *
	 * @throws DriverIOException
	 */
	public IGeometry getGeometry(int index) throws DriverIOException;
}
