/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.edition;

import com.hardcode.driverManager.Driver;
import com.hardcode.driverManager.DriverLoadException;
import com.hardcode.driverManager.DriverManager;

import com.hardcode.gdbms.engine.instruction.FieldNotFoundException;

import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.core.ShapeFactory;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.drivers.VectorialDriver;
import com.iver.cit.gvsig.fmap.drivers.VectorialFileDriver;
import com.iver.cit.gvsig.fmap.drivers.WithDefaultLegend;
import com.iver.cit.gvsig.fmap.drivers.shp.SHP;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.LayerFactory;
import com.iver.cit.gvsig.fmap.layers.VectorialFileAdapter;
import com.iver.cit.gvsig.fmap.rendering.LegendFactory;
import com.iver.cit.gvsig.fmap.rendering.VectorialLegend;

import org.cresques.cts.IProjection;
import org.cresques.cts.ProjectionPool;

import java.io.File;
import java.io.IOException;


/**
 * DOCUMENT ME!
 *
 * @author Fernando Gonzlez Corts
 */
public class Prueba2 {
	/*public FLayer createLayer(String layerName, VectorialFileDriver d,
	   File f, IProjection proj) throws DriverException {
	   //TODO Comprobar si hay un adaptador ya
	   VectorialFileAdapter adapter = new VectorialFileAdapter(f);
	   adapter.setDriver((VectorialDriver) d);
	   FileEditableFeatureSource fefs=new FileEditableFeatureSource((VectorialFileAdapter)adapter);
	   MemoryExpansionFile mef=new MemoryExpansionFile();
	   DefaultEditableFeatureSource defs=new DefaultEditableFeatureSource(mef,fefs);
	   try {
	           defs.addGeometry(ShapeFactory.createPoint2D(1,3));
	           defs.addGeometry(ShapeFactory.createPoint2D(2,2));
	           defs.addGeometry(ShapeFactory.createPoint2D(3,1));
	           defs.addGeometry(ShapeFactory.createPoint2D(4,0));
	   } catch (DriverIOException e1) {
	           e1.printStackTrace();
	   } catch (IOException e1) {
	           e1.printStackTrace();
	   }
	   FLyrVect capa = new FLyrVect();
	   capa.setName(layerName);
	   //TODO Meter esto dentro de la comprobacin de si hay memoria
	   if (false) {
	   } else {
	           capa.setSource(adapter);
	           capa.setProjection(proj);
	   }
	   try {
	           // Le asignamos tambin una legenda por defecto acorde con
	           // el tipo de shape que tenga. Tampoco s si es aqu el
	           // sitio adecuado, pero en fin....
	           if (d instanceof WithDefaultLegend) {
	                   WithDefaultLegend aux = (WithDefaultLegend) d;
	                   adapter.start();
	                   capa.setLegend((VectorialLegend) aux.getDefaultLegend());
	                   adapter.stop();
	           } else {
	                   capa.setLegend(LegendFactory.createSingleSymbolLegend(
	                                   capa.getShapeType()));
	           }
	   } catch (FieldNotFoundException e) {
	           //Esta no puede saltar
	   } catch (DriverIOException e) {
	           throw new DriverException(e);
	   }
	   return capa;
	   }
	 */
	public static void main(String[] args) {
		File f = new File("C:/tirar/borraprueba5.shp");
		VectorialFileAdapter adapter = new VectorialFileAdapter(f);
		DriverManager driverManager = new DriverManager();
		driverManager.loadDrivers(new File(
				"C:\\eclipse3\\workspace\\Andami\\gvSIG\\extensiones\\com.iver.cit.gvsig\\drivers"));

		try {
			adapter.setDriver((VectorialFileDriver) driverManager.getDriver(
					"gvSIG shp driver"));
		} catch (DriverLoadException e2) {
			e2.printStackTrace();
		}

		FileEditableFeatureSource fefs = new FileEditableFeatureSource((VectorialFileAdapter) adapter);
		MemoryExpansionFile mef = new MemoryExpansionFile();
		DefaultEditableFeatureSource defs = new DefaultEditableFeatureSource(mef,
				fefs);

		try {
			defs.startEdition();

			defs.addGeometry(ShapeFactory.createPoint2D(1, 1));
			defs.addGeometry(ShapeFactory.createPoint2D(2, 2));
			defs.addGeometry(ShapeFactory.createPoint2D(3, 3));
			defs.removeGeometry(1);
			defs.compact();
			defs.addGeometry(ShapeFactory.createPoint2D(4, 4));
			defs.modifyGeometry(0, ShapeFactory.createPoint2D(10, 10));
			//defs.addGeometry(ShapeFactory.createPoint2D(1,1));
			//defs.addGeometry(ShapeFactory.createPoint2D(1,0));
			//defs.removeGeometry(0);
			//defs.removeGeometry(1);
			defs.stopEdition();
		} catch (DriverIOException e1) {
			e1.printStackTrace();
		} catch (IOException e1) {
			e1.printStackTrace();
		} catch (EditionException e) {
			e.printStackTrace();
		}


		IGeometry[] fgs = new IGeometry[defs.getGeometryCount()];

		for (int i = 0; i < fgs.length; i++) {
			try {
				fgs[i] = defs.getGeometry(i);
			} catch (IOException e) {
				e.printStackTrace();
			} catch (DriverIOException e) {
				e.printStackTrace();
			}
		}

		SHP.SHPFileFromGeometries(fgs, null, null, f);
	}
}
