/*
 * Created on 10-feb-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 * 
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 * 
 *    or
 * 
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 * 
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.edition;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Arc2D;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

/**
 * @author FJP
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class UtilFunctions {
    static public Arc2D createCircle(Point2D p1, Point2D p2, Point2D p3) //, Graphics g)
    {
        double xC, yC, w, h;
        
        // Calculamos 2 secantes, tiramos perpendiculares por sus puntos
        // medios y obtenemos el centro. Luego calculamos el radio.
        // Puntos medios de los segmentos.
        double xm1, ym1, xm2, ym2;
        xm1 = (p1.getX() + p2.getX())/ 2.0;
        ym1 = (p1.getY() + p2.getY())/ 2.0;
        xm2 = (p2.getX() + p3.getX())/ 2.0;        
        ym2 = (p2.getY() + p3.getY())/ 2.0;
        
        /* g.setColor(Color.GRAY);
        g.draw3DRect((int)xm1, (int) ym1, 1, 1, true);
        g.draw3DRect((int)xm2, (int) ym2, 1, 1, true); */
        // Pendientes de las perpendiculares y constantes       
        double mP1=0, mP2=0, A1, A2;
        boolean bPerp1 = false, bPerp2 = false;
        if (p2.getY() - p1.getY() == 0)
        {
            A1 = ym1;
            bPerp1 = true;
        }
        else
        {
            mP1 = (p2.getX() - p1.getX()) /(p1.getY() - p2.getY());
            A1 = ym1 - xm1 * mP1;
        }
        if (p2.getY() - p3.getY() == 0)
        {
            A2 = ym2;
            bPerp2 = true;
        }
        else
        {
            mP2 = (p3.getX() - p2.getX()) /(p2.getY() - p3.getY());
            A2 = ym2 - xm2 * mP2;            
        }
        if (mP2 == mP1)
        {
            return null; // Error, 3 puntos alineados. No puede pasar un arco
        }
        else
        {
            xC = (A2 - A1)/(mP1-mP2);
            if (!bPerp1)
                yC = xC * mP1 + A1;
            else 
                yC = xC * mP2 + A2;
        }
        double Radio = p1.distance(xC, yC);
        double xR = xC - Radio ;
        double yR = yC - Radio ;
        w = 2.0* Radio;
        h = w;
        Rectangle2D.Double rBounds = new Rectangle2D.Double(xR,yR, w,h);
        Arc2D.Double resul = new Arc2D.Double(rBounds, 0.0, 360.0, Arc2D.OPEN);
		/* g.setColor(Color.RED);
		((Graphics2D) g).draw(resul);
		g.setColor(Color.BLUE);
		((Graphics2D) g).draw(rBounds);
		g.draw3DRect((int)p1.getX(), (int) p1.getY(), 1, 1, true);
		g.draw3DRect((int)p2.getX(), (int) p2.getY(), 2, 2, true);
		g.draw3DRect((int)p3.getX(), (int) p3.getY(), 1, 1, true);
		g.drawString("1", (int) p1.getX(), (int) p1.getY());
		g.drawString("2", (int) p2.getX(), (int) p2.getY());
		g.drawString("3", (int) p3.getX(), (int) p3.getY());
		g.drawString("C", (int) xC, (int) yC);
		g.draw3DRect((int)xC, (int) yC, 2, 2, true); */
        
        return resul;
    }

}
