/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.layers;

import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.drivers.RasterDriver;

import org.cresques.cts.IProjection;

import java.awt.geom.Rectangle2D;


/**
 * Implementa sus mtodos obteniendo la informacin del driver sobre el que
 * acta
 */
public class ComplexRasterAdapter {
	private RasterDriver rasterFileDriver;

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getBandCount()
	 */
	public int getBandCount() {
		return 0;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getPixel(int,
	 * 		int, byte[])
	 */
	public byte[] getPixel(int x, int y, byte[] dArray) {
		return null;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getPixel(int,
	 * 		int, int[])
	 */
	public int[] getPixel(int x, int y, int[] dArray) {
		return null;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getPixel(int,
	 * 		int, float[])
	 */
	public float[] getPixel(int x, int y, float[] dArray) {
		return null;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getPixel(int,
	 * 		int, double[])
	 */
	public double[] getPixel(int x, int y, double[] dArray) {
		return null;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getSampleByte(int,
	 * 		int, int)
	 */
	public byte getSampleByte(int x, int y, int band) {
		return 0;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getSampleInt(int,
	 * 		int, int)
	 */
	public int getSampleInt(int x, int y, int band) {
		return 0;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getSampleFloat(int,
	 * 		int, int)
	 */
	public float getSampleFloat(int x, int y, int band) {
		return 0;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.drivers.GeorreferencedRasterDriver#getSampleDouble(int,
	 * 		int, int)
	 */
	public double getSampleDouble(int x, int y, int band) {
		return 0;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.layers.GeorreferencedRaster#getFullExtent()
	 */
	public Rectangle2D getFullExtent() {
		return null;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.layers.GeorreferencedRaster#getProjection()
	 */
	public IProjection getProjection() {
		return null;
	}

	/**
	 * Mtodo de inicio del Adapter.
	 *
	 * @throws DriverIOException
	 */
	public void start() throws DriverIOException {
	}

	/**
	 * Mtodo final del Adapter.
	 *
	 * @throws DriverIOException
	 */
	public void stop() throws DriverIOException {
	}
}
