/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.layers;

import com.iver.cit.gvsig.fmap.rendering.RasterLegend;


/**
 * Interfaz con mtodos a bajo nivel sobre una capa raster.
 *
 */
public interface LowLevelRasterOperations {
	/**
	 * Aplica el filtro que se pasa como parmetro.
	 *
	 * @param f Filtro a aplicar.
	 */
	void applyFilter(Filter f);

	/**
	 * Establece las bandas del raster que lee el driver que trata esta capa.
	 * Mediante ste mtodo se puede aadir como una capa una sla banda de un
	 * raster
	 *
	 * @param bandsIndexes ndices.
	 */
	void setBands(int[] bandsIndexes);

	/**
	 * Devuelve la leyenda raster.
	 *
	 * @return RasterLegend.
	 */
	RasterLegend getRasterLegend();

	/**
	 * Inserta la Leyenda Raster.
	 *
	 * @param legend RasterLegend.
	 */
	void setRasterLegend(RasterLegend legend);
}
