/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.rendering.indexes;

import com.iver.cit.gvsig.fmap.drivers.DriverIOException;

import java.awt.geom.Rectangle2D;


/**
 * Interfaz a implementar por todos los drivers que tengan soporte nativo para
 * ndices y que dicho soporte haya de ser implementado por gvsig
 * (shapefiles). Por ejemplo un driver de PostGIS no implementara esta
 * interfaz porque si bien permite ndices, el uso de ellos lo realiza el
 * propio servidor de base de datos. Un driver de dxf tampoco lo hara porque
 * no tiene soporte para ndices
 */
public interface Indexable extends Index {
	/**
	 * El driver deber de implementar en este mtodo la creacin del fichero
	 * de ndices.
	 *
	 * @param boundingBox DOCUMENT ME!
	 *
	 * @throws DriverIOException DOCUMENT ME!
	 */
	void createIndex(Rectangle2D boundingBox) throws DriverIOException;

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	boolean hasIndex();

	/**
	 * Devuelve la ruta del fichero de ndice de la capa
	 *
	 * @return DOCUMENT ME!
	 */
	String getIndexFile();
}
