/* Generated by Together */

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.write;

import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
/**
 * Clase que representa el fichero donde se pueden meter features creadas por el usuario durante la edicin. Si se elimina una geometra se marca como eliminada. La geometria sigue estando pero se devuelve una geometria nula si se accede a tal geometria. Si se aade, se aade al final del fichero y si se modifica se pone el shapetype a MODIFIED y a continuacin del shapetype se pone el nmero de registro donde se inserta la modificacin. Hay que destacar que un ExtensibleFile no deja de crecer. Si hay n features, y se eliminan 2, sigue habiendo n features, aunque algunas de ellas sean null. Esto se hace con la finalidad de que los ndices en los que aaden las features no cambien por eliminaciones de otras features
 */
public class ExtensibleFile {
    /**
     * Crea un fichero temporal y lo abre para escritura
     */
    public void open() throws DriverIOException{ }

    /**
     * Cierra el fichero abierto con create
     */
    public void close() throws DriverIOException{ }

    /**
     * Mete el ndice en el bitset deleted para saber que dicho registro est eliminado
     */
    public int deleteGeometry(int id){
    	//TODO implementar bien
    	return -1;
    }

    /**
     * Aade la feature en la posicin index del fichero. Puede darse que la posicin no sea la ltima del fichero, en cuyo caso se copiar en dicho registro la geometra si cabe y lanzar una excepcin en caso de que no pueda. Generalmente se debe de invocar ste mtodo con un ndice distinto al ltimo en un marco de comandos con opcin de deshacer.
     */
    public void setGeometry(int index, IGeometry g){ }

    /**
     * Aade una geometra al final del fichero y devuelve la posicin que ocupa. Dicha posicin no es valida despues de que se haya eliminado alguna geometry del fichero. 
     */
    public int addGeometry(IGeometry g) {
    	//TODO implementar bien
    	return -1;
    }

    /**
     * Marca la feature i-esima del fichero como modificada (MODIFED), y a continuacin del shapetype mete un entero con el nmero de registro de la feature modificada. Inserta la feature modificada al final del fichero. Llama al mtodo addGeometry(int) para esto ltimo. Retorna la geometry que se va a sustituir
     */
    public IGeometry modifyGeometry(int i, IGeometry g){
    	//TODO implementar bien
    	return null;
    }

    /**
     * Deshace la eliminacin de la geometra. El parmetro que se pasa es el ndice del registro eliminado.
     */
    public void restoreGeometry(int i, int type) {
    }

    /**
     * Comprime el fichero ya que las features modificadas pueden estar encadenadas en ms de un registro.
     */
    public void compact() {
    }

    /**
     * Accede al registro index-simo del fichero y se cuenta el nmero de registros eliminados anteriores a dicho registro (n). Se accede al registro (index+n) y se cuentan nuevamente el nmero de registros eliminados entre index y index+n (m). Se accede a (index+n+m) y asi sucesivamente, hasta que se estabiliza la operacin. Entonces se lee el registro y si el shapetype es MODIFIED se salta a la direccin siguiente sucesivamente hasta que se encuentra el registro correcto. 
     */
    public IGeometry getShape(int index) throws DriverIOException{
    	//TODO implementar bien
    	return null;
    }

    /**
     * Devuelve el nmero de registros del fichero contando los que ya han sido eliminados
     */
    public int getShapeCount() throws DriverIOException{
    	//TODO implementar bien
    	return -1;
    }

    private static int MODIFIED = 1000;
    private int shapeCount;

    /**
     * ndice de la primera feature del fichero. En un fichero de extensin valdr el nmero de features que tenga el ReadableVectorial que se extiende y en un fichero de edicin valdr 0. 
     */
    private int firstGeometry;
}
