/* Generated by Together */

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.write.geometron;

import java.awt.geom.Rectangle2D;

import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.layers.ReadableVectorial;
import com.iver.cit.gvsig.fmap.write.WritableOperations;
public interface EditableFeatureSource extends WritableOperations, ReadableVectorial {
    /**
     * Indica que se va a comenzar a hacer una serie de operaciones sobre el origen de datos con la finalidad de que dicho origen de datos se prepare (abra el fichero, comience una transaccin, conecte al servidor, ...). Abre el fichero de ndices en caso de que exista.
     */
    void start() throws DriverIOException;

    /**
     * Hace que se cierre el soporte fsico de la capa. Cierra el fichero de ndices en caso de que exista.
     */
    void stop() throws DriverIOException;

    IGeometry getShape(int index) throws DriverIOException;

    int getShapeCount() throws DriverIOException;

    /**
     * Elimina una feature de la capa 
     */
    void deleteGeometry(int id);

    /**
     * Sustituye la geometry i-sima de la capa por la que se pasa como parmetro.
     */
    void modifyGeometry(int id, IGeometry g);

    /**
     * Aade una geometry a la capa 
     */
    void addGeometry(IGeometry g);

    Rectangle2D getFullExtent() throws DriverIOException;
}
