/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.write.geometron;

import java.awt.geom.Rectangle2D;

public interface EventHandler {
    /**
     * Evento disparado cuando se hace click sobre un vrtice 
     */
    void vertexClicked(VertexEvent e);

    void edgeClicked(EdgeEvent e);

    void edgeMoved(EdgeEvent e);

    /**
     * Evento disparado cuando se mueve un vrtice 
     */
    void vertexMoved(VertexEvent e);

    /**
     * Cuando el usuario hace un rectangulo con el ratn se invoca este mtodo con el dicha regin en coordenadas del EditableFeatureSource. 
     */
    void zoneCompleted(Rectangle2D zone);

    /**
     * Evento disparado cuando el usuario pincha en un punto del area de edicin en la que, teniendo en cuenta la tolerancia, no hay ninguna geometra 
     */
    void pointClicked(GeometronEvent e);

    /**
     * Evento disparado cuando se mueve el ratn por el rea de edicin 
     */
    void mouseMoved(GeometronEvent e);

    void mouseOverVertex(VertexEvent e);

    void mouseOverEdge(EdgeEvent e);
}
