/* Generated by Together */

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.write.geometron;

import java.awt.geom.Rectangle2D;

/**
 * Tiene indexado espacialmente una serie de EditableSourcePoint. Recibir peticiones sobre el rectangulo en el que pincha el usuario (teniendo en cuenta la tolerancia) y devolver un array de ndices de geometrias en la EditableFeatureSource que se encuentran en la zona 
 */
public interface QuadTree {
    /**
     * Obtiene un array de los indices de las geometrias que se encuentran en el queryArea
     */
    int[] getIndexes(Rectangle2D queryArea);

    /**
     * Aade el ndice de la geometria en la estructura de datos
     */
    void addGeometry(int gid);

    /**
     * Notifica al quadtree de la modificacin de la geometria para que actualice la estructura de datos
     */
    void modifyGeometry(Geometry newGeometry, int gid);

    /**
     * Elimina del QuadTree la geometra cuyo gid se pasa como parmetro
     */
    void delGeometry(int gid);
}
